/* gridframe.c generated by valac 0.56.18, the Vala compiler
 * generated from gridframe.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2015 Michael Catanzaro <mcatanzaro@gnome.org>
 *
 * This file is part of libgnome-games-support.
 *
 * libgnome-games-support is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libgnome-games-support is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libgnome-games-support.  If not, see <http://www.gnu.org/licenses/>.
 */
/* A container that guarantees that the internal allocated space is a fixed*/
/* multiple of an integer. This is a fairly literal translation of the LGPLv2+*/
/* original by Callum McKenzie, itself based on GtkFrame and GtkAspectFrame.*/

#include "libgnome-games-support.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <cairo-gobject.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GAMES_GRID_FRAME_0_PROPERTY,
	GAMES_GRID_FRAME_XPADDING_PROPERTY,
	GAMES_GRID_FRAME_YPADDING_PROPERTY,
	GAMES_GRID_FRAME_WIDTH_PROPERTY,
	GAMES_GRID_FRAME_HEIGHT_PROPERTY,
	GAMES_GRID_FRAME_XALIGN_PROPERTY,
	GAMES_GRID_FRAME_YALIGN_PROPERTY,
	GAMES_GRID_FRAME_CHILD_PROPERTY,
	GAMES_GRID_FRAME_NUM_PROPERTIES
};
static GParamSpec* games_grid_frame_properties[GAMES_GRID_FRAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GamesGridFramePrivate {
	gint _xpadding;
	gint _ypadding;
	gint _xmult;
	gint _ymult;
	gfloat _xalign;
	gfloat _yalign;
	GtkWidget* _child;
	GtkAllocation old_allocation;
};

static gint GamesGridFrame_private_offset;
static gpointer games_grid_frame_parent_class = NULL;

static void games_grid_frame_real_dispose (GObject* base);
static void games_grid_frame_real_size_allocate (GtkWidget* base,
                                          gint width,
                                          gint height,
                                          gint baseline);
static void games_grid_frame_finalize (GObject * obj);
static GType games_grid_frame_get_type_once (void);
static void _vala_games_grid_frame_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_games_grid_frame_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
games_grid_frame_get_instance_private (GamesGridFrame* self)
{
	return G_STRUCT_MEMBER_P (self, GamesGridFrame_private_offset);
}

gint
games_grid_frame_get_xpadding (GamesGridFrame* self)
{
	gint result;
#line 32 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "../games/gridframe.vala"
	result = self->priv->_xpadding;
#line 32 "../games/gridframe.vala"
	return result;
#line 105 "gridframe.c"
}

void
games_grid_frame_set_xpadding (GamesGridFrame* self,
                               gint value)
{
#line 34 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 36 "../games/gridframe.vala"
	if (value >= 0) {
#line 38 "../games/gridframe.vala"
		self->priv->_xpadding = value;
#line 39 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 120 "gridframe.c"
	}
#line 34 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_XPADDING_PROPERTY]);
#line 124 "gridframe.c"
}

gint
games_grid_frame_get_ypadding (GamesGridFrame* self)
{
	gint result;
#line 47 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../games/gridframe.vala"
	result = self->priv->_ypadding;
#line 47 "../games/gridframe.vala"
	return result;
#line 137 "gridframe.c"
}

void
games_grid_frame_set_ypadding (GamesGridFrame* self,
                               gint value)
{
#line 49 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 51 "../games/gridframe.vala"
	if (value >= 0) {
#line 53 "../games/gridframe.vala"
		self->priv->_ypadding = value;
#line 54 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 152 "gridframe.c"
	}
#line 49 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_YPADDING_PROPERTY]);
#line 156 "gridframe.c"
}

gint
games_grid_frame_get_width (GamesGridFrame* self)
{
	gint result;
#line 62 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../games/gridframe.vala"
	result = self->priv->_xmult;
#line 62 "../games/gridframe.vala"
	return result;
#line 169 "gridframe.c"
}

void
games_grid_frame_set_width (GamesGridFrame* self,
                            gint value)
{
#line 64 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 66 "../games/gridframe.vala"
	if (value > 0) {
#line 68 "../games/gridframe.vala"
		self->priv->_xmult = value;
#line 69 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 184 "gridframe.c"
	}
#line 64 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_WIDTH_PROPERTY]);
#line 188 "gridframe.c"
}

gint
games_grid_frame_get_height (GamesGridFrame* self)
{
	gint result;
#line 77 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../games/gridframe.vala"
	result = self->priv->_ymult;
#line 77 "../games/gridframe.vala"
	return result;
#line 201 "gridframe.c"
}

void
games_grid_frame_set_height (GamesGridFrame* self,
                             gint value)
{
#line 79 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 81 "../games/gridframe.vala"
	if (value > 0) {
#line 83 "../games/gridframe.vala"
		self->priv->_ymult = value;
#line 84 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 216 "gridframe.c"
	}
#line 79 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_HEIGHT_PROPERTY]);
#line 220 "gridframe.c"
}

gfloat
games_grid_frame_get_xalign (GamesGridFrame* self)
{
	gfloat result;
#line 92 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 92 "../games/gridframe.vala"
	result = self->priv->_xalign;
#line 92 "../games/gridframe.vala"
	return result;
#line 233 "gridframe.c"
}

void
games_grid_frame_set_xalign (GamesGridFrame* self,
                             gfloat value)
{
#line 94 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 96 "../games/gridframe.vala"
	self->priv->_xalign = CLAMP (value, 0.0f, 1.0f);
#line 97 "../games/gridframe.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 94 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_XALIGN_PROPERTY]);
#line 248 "gridframe.c"
}

gfloat
games_grid_frame_get_yalign (GamesGridFrame* self)
{
	gfloat result;
#line 104 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 104 "../games/gridframe.vala"
	result = self->priv->_yalign;
#line 104 "../games/gridframe.vala"
	return result;
#line 261 "gridframe.c"
}

void
games_grid_frame_set_yalign (GamesGridFrame* self,
                             gfloat value)
{
#line 106 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 108 "../games/gridframe.vala"
	self->priv->_yalign = CLAMP (value, 0.0f, 1.0f);
#line 109 "../games/gridframe.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 106 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_YALIGN_PROPERTY]);
#line 276 "gridframe.c"
}

GtkWidget*
games_grid_frame_get_child (GamesGridFrame* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 115 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../games/gridframe.vala"
	_tmp0_ = self->priv->_child;
#line 115 "../games/gridframe.vala"
	result = _tmp0_;
#line 115 "../games/gridframe.vala"
	return result;
#line 292 "gridframe.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 123 "../games/gridframe.vala"
	return self ? g_object_ref (self) : NULL;
#line 300 "gridframe.c"
}

void
games_grid_frame_set_child (GamesGridFrame* self,
                            GtkWidget* value)
{
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
#line 117 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 119 "../games/gridframe.vala"
	_tmp0_ = self->priv->_child;
#line 119 "../games/gridframe.vala"
	if (_tmp0_ == value) {
#line 120 "../games/gridframe.vala"
		return;
#line 319 "gridframe.c"
	}
#line 121 "../games/gridframe.vala"
	_tmp1_ = self->priv->_child;
#line 121 "../games/gridframe.vala"
	if (_tmp1_ != NULL) {
#line 325 "gridframe.c"
		GtkWidget* _tmp2_;
#line 122 "../games/gridframe.vala"
		_tmp2_ = self->priv->_child;
#line 122 "../games/gridframe.vala"
		gtk_widget_unparent (_tmp2_);
#line 331 "gridframe.c"
	}
#line 123 "../games/gridframe.vala"
	_tmp3_ = _g_object_ref0 (value);
#line 123 "../games/gridframe.vala"
	_g_object_unref0 (self->priv->_child);
#line 123 "../games/gridframe.vala"
	self->priv->_child = _tmp3_;
#line 124 "../games/gridframe.vala"
	_tmp4_ = self->priv->_child;
#line 124 "../games/gridframe.vala"
	if (_tmp4_ != NULL) {
#line 343 "gridframe.c"
		GtkWidget* _tmp5_;
#line 125 "../games/gridframe.vala"
		_tmp5_ = self->priv->_child;
#line 125 "../games/gridframe.vala"
		gtk_widget_set_parent (_tmp5_, (GtkWidget*) self);
#line 349 "gridframe.c"
	}
#line 126 "../games/gridframe.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 117 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_CHILD_PROPERTY]);
#line 355 "gridframe.c"
}

GamesGridFrame*
games_grid_frame_construct (GType object_type,
                            gint width,
                            gint height)
{
	GamesGridFrame * self = NULL;
#line 134 "../games/gridframe.vala"
	self = (GamesGridFrame*) g_object_new (object_type, "width", width, "height", height, NULL);
#line 132 "../games/gridframe.vala"
	return self;
#line 368 "gridframe.c"
}

GamesGridFrame*
games_grid_frame_new (gint width,
                      gint height)
{
#line 132 "../games/gridframe.vala"
	return games_grid_frame_construct (GAMES_TYPE_GRID_FRAME, width, height);
#line 377 "gridframe.c"
}

static void
games_grid_frame_real_dispose (GObject* base)
{
	GamesGridFrame * self;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 137 "../games/gridframe.vala"
	self = (GamesGridFrame*) base;
#line 138 "../games/gridframe.vala"
	_tmp0_ = games_grid_frame_get_child (self);
#line 138 "../games/gridframe.vala"
	_tmp1_ = _tmp0_;
#line 138 "../games/gridframe.vala"
	gtk_widget_unparent (_tmp1_);
#line 139 "../games/gridframe.vala"
	games_grid_frame_set_child (self, NULL);
#line 141 "../games/gridframe.vala"
	G_OBJECT_CLASS (games_grid_frame_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 398 "gridframe.c"
}

void
games_grid_frame_set (GamesGridFrame* self,
                      gint width,
                      gint height)
{
#line 144 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 146 "../games/gridframe.vala"
	games_grid_frame_set_width (self, width);
#line 147 "../games/gridframe.vala"
	games_grid_frame_set_height (self, height);
#line 412 "gridframe.c"
}

void
games_grid_frame_set_padding (GamesGridFrame* self,
                              gint xpadding,
                              gint ypadding)
{
#line 150 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 152 "../games/gridframe.vala"
	games_grid_frame_set_xpadding (self, xpadding);
#line 153 "../games/gridframe.vala"
	games_grid_frame_set_ypadding (self, ypadding);
#line 426 "gridframe.c"
}

void
games_grid_frame_set_alignment (GamesGridFrame* self,
                                gfloat xalign,
                                gfloat yalign)
{
#line 156 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 158 "../games/gridframe.vala"
	games_grid_frame_set_xalign (self, xalign);
#line 159 "../games/gridframe.vala"
	games_grid_frame_set_yalign (self, yalign);
#line 440 "gridframe.c"
}

static void
games_grid_frame_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline)
{
	GamesGridFrame * self;
	gint xsize = 0;
	gint ysize = 0;
	gint size = 0;
	GtkAllocation child_allocation = {0};
	GtkAllocation _tmp0_ = {0};
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkAllocation _tmp11_;
#line 162 "../games/gridframe.vala"
	self = (GamesGridFrame*) base;
#line 164 "../games/gridframe.vala"
	GTK_WIDGET_CLASS (games_grid_frame_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), width, height, baseline);
#line 166 "../games/gridframe.vala"
	xsize = MAX (1, (width - self->priv->_xpadding) / self->priv->_xmult);
#line 167 "../games/gridframe.vala"
	ysize = MAX (1, (height - self->priv->_ypadding) / self->priv->_ymult);
#line 168 "../games/gridframe.vala"
	size = MIN (xsize, ysize);
#line 170 "../games/gridframe.vala"
	_tmp0_.x = 0;
#line 170 "../games/gridframe.vala"
	_tmp0_.y = 0;
#line 170 "../games/gridframe.vala"
	_tmp0_.width = 0;
#line 170 "../games/gridframe.vala"
	_tmp0_.height = 0;
#line 170 "../games/gridframe.vala"
	child_allocation = _tmp0_;
#line 171 "../games/gridframe.vala"
	child_allocation.width = (size * self->priv->_xmult) + self->priv->_xpadding;
#line 172 "../games/gridframe.vala"
	child_allocation.height = (size * self->priv->_ymult) + self->priv->_ypadding;
#line 173 "../games/gridframe.vala"
	_tmp1_ = child_allocation;
#line 173 "../games/gridframe.vala"
	child_allocation.x = (gint) ((width - _tmp1_.width) * self->priv->_xalign);
#line 174 "../games/gridframe.vala"
	_tmp2_ = child_allocation;
#line 174 "../games/gridframe.vala"
	child_allocation.y = (gint) ((height - _tmp2_.height) * self->priv->_yalign);
#line 176 "../games/gridframe.vala"
	_tmp4_ = games_grid_frame_get_child (self);
#line 176 "../games/gridframe.vala"
	_tmp5_ = _tmp4_;
#line 176 "../games/gridframe.vala"
	if (_tmp5_ != NULL) {
#line 499 "gridframe.c"
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
#line 176 "../games/gridframe.vala"
		_tmp6_ = games_grid_frame_get_child (self);
#line 176 "../games/gridframe.vala"
		_tmp7_ = _tmp6_;
#line 176 "../games/gridframe.vala"
		_tmp3_ = gtk_widget_get_visible (_tmp7_);
#line 508 "gridframe.c"
	} else {
#line 176 "../games/gridframe.vala"
		_tmp3_ = FALSE;
#line 512 "gridframe.c"
	}
#line 176 "../games/gridframe.vala"
	if (_tmp3_) {
#line 516 "gridframe.c"
		GtkWidget* _tmp8_;
		GtkWidget* _tmp9_;
		GtkAllocation _tmp10_;
#line 177 "../games/gridframe.vala"
		_tmp8_ = games_grid_frame_get_child (self);
#line 177 "../games/gridframe.vala"
		_tmp9_ = _tmp8_;
#line 177 "../games/gridframe.vala"
		_tmp10_ = child_allocation;
#line 177 "../games/gridframe.vala"
		gtk_widget_size_allocate (_tmp9_, &_tmp10_, -1);
#line 528 "gridframe.c"
	}
#line 179 "../games/gridframe.vala"
	_tmp11_ = child_allocation;
#line 179 "../games/gridframe.vala"
	self->priv->old_allocation = _tmp11_;
#line 534 "gridframe.c"
}

static void
games_grid_frame_class_init (GamesGridFrameClass * klass,
                             gpointer klass_data)
{
#line 27 "../games/gridframe.vala"
	games_grid_frame_parent_class = g_type_class_peek_parent (klass);
#line 27 "../games/gridframe.vala"
	g_type_class_adjust_private_offset (klass, &GamesGridFrame_private_offset);
#line 27 "../games/gridframe.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) games_grid_frame_real_dispose;
#line 27 "../games/gridframe.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) games_grid_frame_real_size_allocate;
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_grid_frame_get_property;
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_grid_frame_set_property;
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (klass)->finalize = games_grid_frame_finalize;
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_XPADDING_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_XPADDING_PROPERTY] = g_param_spec_int ("xpadding", "xpadding", "xpadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_YPADDING_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_YPADDING_PROPERTY] = g_param_spec_int ("ypadding", "ypadding", "ypadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_WIDTH_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_HEIGHT_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_XALIGN_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_XALIGN_PROPERTY] = g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_YALIGN_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_YALIGN_PROPERTY] = g_param_spec_float ("yalign", "yalign", "yalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_CHILD_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_CHILD_PROPERTY] = g_param_spec_object ("child", "child", "child", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 569 "gridframe.c"
}

static void
games_grid_frame_instance_init (GamesGridFrame * self,
                                gpointer klass)
{
#line 27 "../games/gridframe.vala"
	self->priv = games_grid_frame_get_instance_private (self);
#line 29 "../games/gridframe.vala"
	self->priv->_xpadding = 0;
#line 44 "../games/gridframe.vala"
	self->priv->_ypadding = 0;
#line 59 "../games/gridframe.vala"
	self->priv->_xmult = 1;
#line 74 "../games/gridframe.vala"
	self->priv->_ymult = 1;
#line 89 "../games/gridframe.vala"
	self->priv->_xalign = 0.5f;
#line 101 "../games/gridframe.vala"
	self->priv->_yalign = 0.5f;
#line 113 "../games/gridframe.vala"
	self->priv->_child = NULL;
#line 592 "gridframe.c"
}

static void
games_grid_frame_finalize (GObject * obj)
{
	GamesGridFrame * self;
#line 27 "../games/gridframe.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_GRID_FRAME, GamesGridFrame);
#line 113 "../games/gridframe.vala"
	_g_object_unref0 (self->priv->_child);
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (games_grid_frame_parent_class)->finalize (obj);
#line 605 "gridframe.c"
}

static GType
games_grid_frame_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesGridFrameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_grid_frame_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesGridFrame), 0, (GInstanceInitFunc) games_grid_frame_instance_init, NULL };
	GType games_grid_frame_type_id;
	games_grid_frame_type_id = g_type_register_static (gtk_widget_get_type (), "GamesGridFrame", &g_define_type_info, 0);
	GamesGridFrame_private_offset = g_type_add_instance_private (games_grid_frame_type_id, sizeof (GamesGridFramePrivate));
	return games_grid_frame_type_id;
}

GType
games_grid_frame_get_type (void)
{
	static volatile gsize games_grid_frame_type_id__once = 0;
	if (g_once_init_enter (&games_grid_frame_type_id__once)) {
		GType games_grid_frame_type_id;
		games_grid_frame_type_id = games_grid_frame_get_type_once ();
		g_once_init_leave (&games_grid_frame_type_id__once, games_grid_frame_type_id);
	}
	return games_grid_frame_type_id__once;
}

static void
_vala_games_grid_frame_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GamesGridFrame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_GRID_FRAME, GamesGridFrame);
#line 27 "../games/gridframe.vala"
	switch (property_id) {
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_xpadding (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_ypadding (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_WIDTH_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_width (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_HEIGHT_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_height (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_float (value, games_grid_frame_get_xalign (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_float (value, games_grid_frame_get_yalign (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_CHILD_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_object (value, games_grid_frame_get_child (self));
#line 27 "../games/gridframe.vala"
		break;
#line 682 "gridframe.c"
		default:
#line 27 "../games/gridframe.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../games/gridframe.vala"
		break;
#line 688 "gridframe.c"
	}
}

static void
_vala_games_grid_frame_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GamesGridFrame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_GRID_FRAME, GamesGridFrame);
#line 27 "../games/gridframe.vala"
	switch (property_id) {
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_xpadding (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_ypadding (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_WIDTH_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_width (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_HEIGHT_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_height (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_xalign (self, g_value_get_float (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_yalign (self, g_value_get_float (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_CHILD_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_child (self, g_value_get_object (value));
#line 27 "../games/gridframe.vala"
		break;
#line 744 "gridframe.c"
		default:
#line 27 "../games/gridframe.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../games/gridframe.vala"
		break;
#line 750 "gridframe.c"
	}
}

