/* context.c generated by valac 0.56.18, the Vala compiler
 * generated from context.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2014 Nikhar Agrawal
 * Copyright © 2015 Michael Catanzaro <mcatanzaro@gnome.org>
 *
 * This file is part of libgnome-games-support.
 *
 * libgnome-games-support is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libgnome-games-support is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libgnome-games-support.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgnome-games-support.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <errno.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GAMES_SCORES_CONTEXT_0_PROPERTY,
	GAMES_SCORES_CONTEXT_APP_NAME_PROPERTY,
	GAMES_SCORES_CONTEXT_CATEGORY_TYPE_PROPERTY,
	GAMES_SCORES_CONTEXT_GAME_WINDOW_PROPERTY,
	GAMES_SCORES_CONTEXT_STYLE_PROPERTY,
	GAMES_SCORES_CONTEXT_IMPORTER_PROPERTY,
	GAMES_SCORES_CONTEXT_ICON_NAME_PROPERTY,
	GAMES_SCORES_CONTEXT_NUM_PROPERTIES
};
static GParamSpec* games_scores_context_properties[GAMES_SCORES_CONTEXT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GamesScoresContextSaveScoreToFileData GamesScoresContextSaveScoreToFileData;
typedef struct _GamesScoresContextAddScoreInternalData GamesScoresContextAddScoreInternalData;
typedef struct _GamesScoresContextAddScoreData GamesScoresContextAddScoreData;
typedef struct _Block2Data Block2Data;
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _Block3Data Block3Data;

#define GAMES_SCORES_TYPE_DIALOG (games_scores_dialog_get_type ())
#define GAMES_SCORES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialog))
#define GAMES_SCORES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialogClass))
#define GAMES_SCORES_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_SCORES_TYPE_DIALOG))
#define GAMES_SCORES_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_SCORES_TYPE_DIALOG))
#define GAMES_SCORES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialogClass))

typedef struct _GamesScoresDialog GamesScoresDialog;
typedef struct _GamesScoresDialogClass GamesScoresDialogClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GamesScoresContextPrivate {
	gchar* _app_name;
	gchar* _category_type;
	GtkWindow* _game_window;
	GamesScoresStyle _style;
	GamesScoresImporter* _importer;
	gchar* _icon_name;
	GamesScoresCategory* current_category;
	GeeHashMap* scores_per_category;
	gchar* user_score_dir;
	gboolean scores_loaded;
	GamesScoresContextCategoryRequestFunc category_request;
	gpointer category_request_target;
	GDestroyNotify category_request_target_destroy_notify;
};

struct _Block1Data {
	int _ref_count_;
	GamesScoresContext* self;
	GamesScoresContextCategoryRequestFunc category_request;
	gpointer category_request_target;
};

struct _GamesScoresContextSaveScoreToFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GamesScoresContext* self;
	GamesScoresScore* score;
	GamesScoresCategory* category;
	GCancellable* cancellable;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _tmp3_;
	GFile* file;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFileOutputStream* stream;
	GFile* _tmp11_;
	GFileOutputStream* _tmp12_;
	gchar* line;
	glong _tmp13_;
	glong _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gint64 _tmp17_;
	gint64 _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GFileOutputStream* _tmp26_;
	const gchar* _tmp27_;
	guint8* _tmp28_;
	gint _tmp28__length1;
	gint _tmp29_;
	guint8* _tmp30_;
	gint _tmp30__length1;
	GError* _inner_error0_;
};

struct _GamesScoresContextAddScoreInternalData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GamesScoresContext* self;
	GamesScoresScore* score;
	GamesScoresCategory* category;
	gboolean allow_dialog;
	GCancellable* cancellable;
	gboolean result;
	gboolean high_score_added;
	glong _tmp0_;
	glong _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeHashMap* _tmp6_;
	gpointer _tmp7_;
	GeeList* _tmp8_;
	gboolean _tmp9_;
	GamesScoresCategory* _tmp10_;
	gboolean _tmp11_;
	GamesScoresCategory* _tmp12_;
	GError* _inner_error0_;
};

struct _GamesScoresContextAddScoreData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GamesScoresContext* self;
	glong score;
	GamesScoresCategory* category;
	GCancellable* cancellable;
	gboolean result;
	gboolean _tmp0_;
	GamesScoresScore* _tmp1_;
	GamesScoresScore* _tmp2_;
	GtkWindow* _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	GamesScoresContext* self;
	GMainLoop* main_loop;
	gboolean ret;
	GError* _error_;
};

struct _Block3Data {
	int _ref_count_;
	GamesScoresContext* self;
	GamesScoresContextCategoryRequestFunc category_request;
	gpointer category_request_target;
};

static gint GamesScoresContext_private_offset;
static gpointer games_scores_context_parent_class = NULL;
static GeeHashDataFunc games_scores_context_category_hash;
static gpointer games_scores_context_category_hash_target;
static GDestroyNotify games_scores_context_category_hash_target_destroy_notify;
static GeeHashDataFunc games_scores_context_category_hash = NULL;
static gpointer games_scores_context_category_hash_target = NULL;
static GDestroyNotify games_scores_context_category_hash_target_destroy_notify = NULL;
static GeeEqualDataFunc games_scores_context_category_equal;
static gpointer games_scores_context_category_equal_target;
static GDestroyNotify games_scores_context_category_equal_target_destroy_notify;
static GeeEqualDataFunc games_scores_context_category_equal = NULL;
static gpointer games_scores_context_category_equal_target = NULL;
static GDestroyNotify games_scores_context_category_equal_target_destroy_notify = NULL;

static guint _games_scores_context_category_hash_lambda4_ (GamesScoresCategory* a);
static guint __games_scores_context_category_hash_lambda4__gee_hash_data_func (gconstpointer v,
                                                                        gpointer self);
static gboolean _games_scores_context_category_equal_lambda5_ (GamesScoresCategory* a,
                                                        GamesScoresCategory* b);
static gboolean __games_scores_context_category_equal_lambda5__gee_equal_data_func (gconstpointer a,
                                                                             gconstpointer b,
                                                                             gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static GamesScoresCategory* __lambda6_ (Block1Data* _data1_,
                                 const gchar* key);
static GamesScoresCategory* ___lambda6__games_scores_context_category_request_func (const gchar* category_key,
                                                                             gpointer self);
static void games_scores_context_load_scores_from_files (GamesScoresContext* self,
                                                  GError** error);
static void games_scores_context_real_constructed (GObject* base);
VALA_EXTERN void games_scores_importer_run (GamesScoresImporter* self,
                                GamesScoresContext* context,
                                const gchar* new_scores_dir);
VALA_EXTERN GList* games_scores_context_get_categories (GamesScoresContext* self);
VALA_EXTERN void games_scores_context_update_score_name (GamesScoresContext* self,
                                             GamesScoresScore* old_score,
                                             GamesScoresCategory* category,
                                             const gchar* new_name);
static gint ___lambda7_ (GamesScoresContext* self,
                  GamesScoresScore* a,
                  GamesScoresScore* b);
static gint ____lambda7__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static gint ___lambda8_ (GamesScoresContext* self,
                  GamesScoresScore* a,
                  GamesScoresScore* b);
static gint ____lambda8__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static gboolean games_scores_context_is_high_score (GamesScoresContext* self,
                                             glong score_value,
                                             GamesScoresCategory* category);
static void games_scores_context_save_score_to_file_data_free (gpointer _data);
static void games_scores_context_save_score_to_file (GamesScoresContext* self,
                                              GamesScoresScore* score,
                                              GamesScoresCategory* category,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void games_scores_context_save_score_to_file_finish (GamesScoresContext* self,
                                                     GAsyncResult* _res_,
                                                     GError** error);
static gboolean games_scores_context_save_score_to_file_co (GamesScoresContextSaveScoreToFileData* _data_);
static void games_scores_context_save_score_to_file_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void games_scores_context_add_score_internal_data_free (gpointer _data);
VALA_EXTERN void games_scores_context_add_score_internal (GamesScoresContext* self,
                                              GamesScoresScore* score,
                                              GamesScoresCategory* category,
                                              gboolean allow_dialog,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN gboolean games_scores_context_add_score_internal_finish (GamesScoresContext* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static gboolean games_scores_context_add_score_internal_co (GamesScoresContextAddScoreInternalData* _data_);
VALA_EXTERN void games_scores_context_run_dialog_internal (GamesScoresContext* self,
                                               GamesScoresScore* new_high_score);
static void games_scores_context_add_score_internal_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void games_scores_context_add_score_data_free (gpointer _data);
static gboolean games_scores_context_add_score_co (GamesScoresContextAddScoreData* _data_);
static void games_scores_context_add_score_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN gboolean games_scores_context_add_score_sync (GamesScoresContext* self,
                                              GamesScoresScore* score,
                                              GamesScoresCategory* category,
                                              GError** error);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda12_ (Block2Data* _data2_,
                  GObject* object,
                  GAsyncResult* _result_);
static void ___lambda12__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void games_scores_context_load_scores_from_file (GamesScoresContext* self,
                                                 GFileInfo* file_info,
                                                 GError** error);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static GamesScoresCategory* __lambda13_ (Block3Data* _data3_,
                                  const gchar* key);
static GamesScoresCategory* ___lambda13__games_scores_context_category_request_func (const gchar* category_key,
                                                                              gpointer self);
VALA_EXTERN GType games_scores_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesScoresDialog* games_scores_dialog_new (GamesScoresContext* context,
                                            const gchar* category_type,
                                            GamesScoresStyle style,
                                            GamesScoresScore* new_high_score,
                                            GamesScoresCategory* current_cat,
                                            GtkWindow* window,
                                            const gchar* icon_name);
VALA_EXTERN GamesScoresDialog* games_scores_dialog_construct (GType object_type,
                                                  GamesScoresContext* context,
                                                  const gchar* category_type,
                                                  GamesScoresStyle style,
                                                  GamesScoresScore* new_high_score,
                                                  GamesScoresCategory* current_cat,
                                                  GtkWindow* window,
                                                  const gchar* icon_name);
static void __lambda11_ (GamesScoresContext* self,
                  GtkDialog* dialog,
                  gint response);
static void ___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void games_scores_context_finalize (GObject * obj);
static GType games_scores_context_get_type_once (void);
static void _vala_games_scores_context_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_games_scores_context_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GType
games_scores_style_get_type_once (void)
{
	static const GEnumValue values[] = {{GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER, "GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER", "points-greater-is-better"}, {GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER, "GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER", "points-less-is-better"}, {GAMES_SCORES_STYLE_TIME_GREATER_IS_BETTER, "GAMES_SCORES_STYLE_TIME_GREATER_IS_BETTER", "time-greater-is-better"}, {GAMES_SCORES_STYLE_TIME_LESS_IS_BETTER, "GAMES_SCORES_STYLE_TIME_LESS_IS_BETTER", "time-less-is-better"}, {0, NULL, NULL}};
	GType games_scores_style_type_id;
	games_scores_style_type_id = g_enum_register_static ("GamesScoresStyle", values);
	return games_scores_style_type_id;
}

GType
games_scores_style_get_type (void)
{
	static volatile gsize games_scores_style_type_id__once = 0;
	if (g_once_init_enter (&games_scores_style_type_id__once)) {
		GType games_scores_style_type_id;
		games_scores_style_type_id = games_scores_style_get_type_once ();
		g_once_init_leave (&games_scores_style_type_id__once, games_scores_style_type_id);
	}
	return games_scores_style_type_id__once;
}

static inline gpointer
games_scores_context_get_instance_private (GamesScoresContext* self)
{
	return G_STRUCT_MEMBER_P (self, GamesScoresContext_private_offset);
}

const gchar*
games_scores_context_get_app_name (GamesScoresContext* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../games/scores/context.vala"
	_tmp0_ = self->priv->_app_name;
#line 35 "../games/scores/context.vala"
	result = _tmp0_;
#line 35 "../games/scores/context.vala"
	return result;
#line 411 "context.c"
}

static void
games_scores_context_set_app_name (GamesScoresContext* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 35 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 35 "../games/scores/context.vala"
	old_value = games_scores_context_get_app_name (self);
#line 35 "../games/scores/context.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 425 "context.c"
		gchar* _tmp0_;
#line 35 "../games/scores/context.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../games/scores/context.vala"
		_g_free0 (self->priv->_app_name);
#line 35 "../games/scores/context.vala"
		self->priv->_app_name = _tmp0_;
#line 35 "../games/scores/context.vala"
		g_object_notify_by_pspec ((GObject *) self, games_scores_context_properties[GAMES_SCORES_CONTEXT_APP_NAME_PROPERTY]);
#line 435 "context.c"
	}
}

const gchar*
games_scores_context_get_category_type (GamesScoresContext* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../games/scores/context.vala"
	_tmp0_ = self->priv->_category_type;
#line 36 "../games/scores/context.vala"
	result = _tmp0_;
#line 36 "../games/scores/context.vala"
	return result;
#line 452 "context.c"
}

static void
games_scores_context_set_category_type (GamesScoresContext* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 36 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 36 "../games/scores/context.vala"
	old_value = games_scores_context_get_category_type (self);
#line 36 "../games/scores/context.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 466 "context.c"
		gchar* _tmp0_;
#line 36 "../games/scores/context.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../games/scores/context.vala"
		_g_free0 (self->priv->_category_type);
#line 36 "../games/scores/context.vala"
		self->priv->_category_type = _tmp0_;
#line 36 "../games/scores/context.vala"
		g_object_notify_by_pspec ((GObject *) self, games_scores_context_properties[GAMES_SCORES_CONTEXT_CATEGORY_TYPE_PROPERTY]);
#line 476 "context.c"
	}
}

GtkWindow*
games_scores_context_get_game_window (GamesScoresContext* self)
{
	GtkWindow* result;
	GtkWindow* _tmp0_;
#line 37 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../games/scores/context.vala"
	_tmp0_ = self->priv->_game_window;
#line 37 "../games/scores/context.vala"
	result = _tmp0_;
#line 37 "../games/scores/context.vala"
	return result;
#line 493 "context.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../games/scores/context.vala"
	return self ? g_object_ref (self) : NULL;
#line 501 "context.c"
}

static void
games_scores_context_set_game_window (GamesScoresContext* self,
                                      GtkWindow* value)
{
	GtkWindow* old_value;
#line 37 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 37 "../games/scores/context.vala"
	old_value = games_scores_context_get_game_window (self);
#line 37 "../games/scores/context.vala"
	if (old_value != value) {
#line 515 "context.c"
		GtkWindow* _tmp0_;
#line 37 "../games/scores/context.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../games/scores/context.vala"
		_g_object_unref0 (self->priv->_game_window);
#line 37 "../games/scores/context.vala"
		self->priv->_game_window = _tmp0_;
#line 37 "../games/scores/context.vala"
		g_object_notify_by_pspec ((GObject *) self, games_scores_context_properties[GAMES_SCORES_CONTEXT_GAME_WINDOW_PROPERTY]);
#line 525 "context.c"
	}
}

GamesScoresStyle
games_scores_context_get_style (GamesScoresContext* self)
{
	GamesScoresStyle result;
#line 38 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../games/scores/context.vala"
	result = self->priv->_style;
#line 38 "../games/scores/context.vala"
	return result;
#line 539 "context.c"
}

static void
games_scores_context_set_style (GamesScoresContext* self,
                                GamesScoresStyle value)
{
	GamesScoresStyle old_value;
#line 38 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 38 "../games/scores/context.vala"
	old_value = games_scores_context_get_style (self);
#line 38 "../games/scores/context.vala"
	if (old_value != value) {
#line 38 "../games/scores/context.vala"
		self->priv->_style = value;
#line 38 "../games/scores/context.vala"
		g_object_notify_by_pspec ((GObject *) self, games_scores_context_properties[GAMES_SCORES_CONTEXT_STYLE_PROPERTY]);
#line 557 "context.c"
	}
}

GamesScoresImporter*
games_scores_context_get_importer (GamesScoresContext* self)
{
	GamesScoresImporter* result;
	GamesScoresImporter* _tmp0_;
#line 39 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../games/scores/context.vala"
	_tmp0_ = self->priv->_importer;
#line 39 "../games/scores/context.vala"
	result = _tmp0_;
#line 39 "../games/scores/context.vala"
	return result;
#line 574 "context.c"
}

static void
games_scores_context_set_importer (GamesScoresContext* self,
                                   GamesScoresImporter* value)
{
	GamesScoresImporter* old_value;
#line 39 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 39 "../games/scores/context.vala"
	old_value = games_scores_context_get_importer (self);
#line 39 "../games/scores/context.vala"
	if (old_value != value) {
#line 588 "context.c"
		GamesScoresImporter* _tmp0_;
#line 39 "../games/scores/context.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../games/scores/context.vala"
		_g_object_unref0 (self->priv->_importer);
#line 39 "../games/scores/context.vala"
		self->priv->_importer = _tmp0_;
#line 39 "../games/scores/context.vala"
		g_object_notify_by_pspec ((GObject *) self, games_scores_context_properties[GAMES_SCORES_CONTEXT_IMPORTER_PROPERTY]);
#line 598 "context.c"
	}
}

const gchar*
games_scores_context_get_icon_name (GamesScoresContext* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../games/scores/context.vala"
	_tmp0_ = self->priv->_icon_name;
#line 40 "../games/scores/context.vala"
	result = _tmp0_;
#line 40 "../games/scores/context.vala"
	return result;
#line 615 "context.c"
}

static void
games_scores_context_set_icon_name (GamesScoresContext* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 40 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 40 "../games/scores/context.vala"
	old_value = games_scores_context_get_icon_name (self);
#line 40 "../games/scores/context.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 629 "context.c"
		gchar* _tmp0_;
#line 40 "../games/scores/context.vala"
		_tmp0_ = g_strdup (value);
#line 40 "../games/scores/context.vala"
		_g_free0 (self->priv->_icon_name);
#line 40 "../games/scores/context.vala"
		self->priv->_icon_name = _tmp0_;
#line 40 "../games/scores/context.vala"
		g_object_notify_by_pspec ((GObject *) self, games_scores_context_properties[GAMES_SCORES_CONTEXT_ICON_NAME_PROPERTY]);
#line 639 "context.c"
	}
}

static guint
_games_scores_context_category_hash_lambda4_ (GamesScoresCategory* a)
{
	GHashFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	guint result;
#line 45 "../games/scores/context.vala"
	_tmp0_ = g_str_hash;
#line 45 "../games/scores/context.vala"
	_tmp1_ = games_scores_category_get_key (a);
#line 45 "../games/scores/context.vala"
	_tmp2_ = _tmp1_;
#line 45 "../games/scores/context.vala"
	result = _tmp0_ (_tmp2_);
#line 45 "../games/scores/context.vala"
	return result;
#line 660 "context.c"
}

static guint
__games_scores_context_category_hash_lambda4__gee_hash_data_func (gconstpointer v,
                                                                  gpointer self)
{
	guint result;
	result = _games_scores_context_category_hash_lambda4_ ((GamesScoresCategory*) v);
#line 44 "../games/scores/context.vala"
	return result;
#line 671 "context.c"
}

static gboolean
_games_scores_context_category_equal_lambda5_ (GamesScoresCategory* a,
                                               GamesScoresCategory* b)
{
	GEqualFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
#line 48 "../games/scores/context.vala"
	_tmp0_ = g_str_equal;
#line 48 "../games/scores/context.vala"
	_tmp1_ = games_scores_category_get_key (a);
#line 48 "../games/scores/context.vala"
	_tmp2_ = _tmp1_;
#line 48 "../games/scores/context.vala"
	_tmp3_ = games_scores_category_get_key (b);
#line 48 "../games/scores/context.vala"
	_tmp4_ = _tmp3_;
#line 48 "../games/scores/context.vala"
	result = _tmp0_ (_tmp2_, _tmp4_);
#line 48 "../games/scores/context.vala"
	return result;
#line 698 "context.c"
}

static gboolean
__games_scores_context_category_equal_lambda5__gee_equal_data_func (gconstpointer a,
                                                                    gconstpointer b,
                                                                    gpointer self)
{
	gboolean result;
	result = _games_scores_context_category_equal_lambda5_ ((GamesScoresCategory*) a, (GamesScoresCategory*) b);
#line 47 "../games/scores/context.vala"
	return result;
#line 710 "context.c"
}

GamesScoresContext*
games_scores_context_construct (GType object_type,
                                const gchar* app_name,
                                const gchar* category_type,
                                GtkWindow* game_window,
                                GamesScoresContextCategoryRequestFunc category_request,
                                gpointer category_request_target,
                                GamesScoresStyle style)
{
	GamesScoresContext * self = NULL;
#line 71 "../games/scores/context.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 71 "../games/scores/context.vala"
	g_return_val_if_fail (category_type != NULL, NULL);
#line 77 "../games/scores/context.vala"
	self = (GamesScoresContext*) games_scores_context_construct_with_importer_and_icon_name (object_type, app_name, category_type, game_window, category_request, category_request_target, style, NULL, NULL);
#line 71 "../games/scores/context.vala"
	return self;
#line 731 "context.c"
}

GamesScoresContext*
games_scores_context_new (const gchar* app_name,
                          const gchar* category_type,
                          GtkWindow* game_window,
                          GamesScoresContextCategoryRequestFunc category_request,
                          gpointer category_request_target,
                          GamesScoresStyle style)
{
#line 71 "../games/scores/context.vala"
	return games_scores_context_construct (GAMES_SCORES_TYPE_CONTEXT, app_name, category_type, game_window, category_request, category_request_target, style);
#line 744 "context.c"
}

GamesScoresContext*
games_scores_context_construct_with_icon_name (GType object_type,
                                               const gchar* app_name,
                                               const gchar* category_type,
                                               GtkWindow* game_window,
                                               GamesScoresContextCategoryRequestFunc category_request,
                                               gpointer category_request_target,
                                               GamesScoresStyle style,
                                               const gchar* icon_name)
{
	GamesScoresContext * self = NULL;
#line 80 "../games/scores/context.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 80 "../games/scores/context.vala"
	g_return_val_if_fail (category_type != NULL, NULL);
#line 80 "../games/scores/context.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 87 "../games/scores/context.vala"
	self = (GamesScoresContext*) games_scores_context_construct_with_importer_and_icon_name (object_type, app_name, category_type, game_window, category_request, category_request_target, style, NULL, icon_name);
#line 80 "../games/scores/context.vala"
	return self;
#line 768 "context.c"
}

GamesScoresContext*
games_scores_context_new_with_icon_name (const gchar* app_name,
                                         const gchar* category_type,
                                         GtkWindow* game_window,
                                         GamesScoresContextCategoryRequestFunc category_request,
                                         gpointer category_request_target,
                                         GamesScoresStyle style,
                                         const gchar* icon_name)
{
#line 80 "../games/scores/context.vala"
	return games_scores_context_construct_with_icon_name (GAMES_SCORES_TYPE_CONTEXT, app_name, category_type, game_window, category_request, category_request_target, style, icon_name);
#line 782 "context.c"
}

GamesScoresContext*
games_scores_context_construct_with_importer (GType object_type,
                                              const gchar* app_name,
                                              const gchar* category_type,
                                              GtkWindow* game_window,
                                              GamesScoresContextCategoryRequestFunc category_request,
                                              gpointer category_request_target,
                                              GamesScoresStyle style,
                                              GamesScoresImporter* importer)
{
	GamesScoresContext * self = NULL;
#line 90 "../games/scores/context.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 90 "../games/scores/context.vala"
	g_return_val_if_fail (category_type != NULL, NULL);
#line 97 "../games/scores/context.vala"
	self = (GamesScoresContext*) games_scores_context_construct_with_importer_and_icon_name (object_type, app_name, category_type, game_window, category_request, category_request_target, style, importer, NULL);
#line 90 "../games/scores/context.vala"
	return self;
#line 804 "context.c"
}

GamesScoresContext*
games_scores_context_new_with_importer (const gchar* app_name,
                                        const gchar* category_type,
                                        GtkWindow* game_window,
                                        GamesScoresContextCategoryRequestFunc category_request,
                                        gpointer category_request_target,
                                        GamesScoresStyle style,
                                        GamesScoresImporter* importer)
{
#line 90 "../games/scores/context.vala"
	return games_scores_context_construct_with_importer (GAMES_SCORES_TYPE_CONTEXT, app_name, category_type, game_window, category_request, category_request_target, style, importer);
#line 818 "context.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 100 "../games/scores/context.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 100 "../games/scores/context.vala"
	return _data1_;
#line 828 "context.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 100 "../games/scores/context.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 838 "context.c"
		GamesScoresContext* self;
#line 100 "../games/scores/context.vala"
		self = _data1_->self;
#line 100 "../games/scores/context.vala"
		_g_object_unref0 (self);
#line 100 "../games/scores/context.vala"
		g_slice_free (Block1Data, _data1_);
#line 846 "context.c"
	}
}

static GamesScoresCategory*
__lambda6_ (Block1Data* _data1_,
            const gchar* key)
{
	GamesScoresContext* self;
	GamesScoresCategory* _tmp0_;
	GamesScoresCategory* result;
#line 119 "../games/scores/context.vala"
	self = _data1_->self;
#line 119 "../games/scores/context.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 119 "../games/scores/context.vala"
	_tmp0_ = _data1_->category_request (key, _data1_->category_request_target);
#line 119 "../games/scores/context.vala"
	result = _tmp0_;
#line 119 "../games/scores/context.vala"
	return result;
#line 867 "context.c"
}

static GamesScoresCategory*
___lambda6__games_scores_context_category_request_func (const gchar* category_key,
                                                        gpointer self)
{
	GamesScoresCategory* result;
	result = __lambda6_ (self, category_key);
#line 119 "../games/scores/context.vala"
	return result;
#line 878 "context.c"
}

GamesScoresContext*
games_scores_context_construct_with_importer_and_icon_name (GType object_type,
                                                            const gchar* app_name,
                                                            const gchar* category_type,
                                                            GtkWindow* game_window,
                                                            GamesScoresContextCategoryRequestFunc category_request,
                                                            gpointer category_request_target,
                                                            GamesScoresStyle style,
                                                            GamesScoresImporter* importer,
                                                            const gchar* icon_name)
{
	GamesScoresContext * self = NULL;
	Block1Data* _data1_;
	const gchar* _tmp0_ = NULL;
	GError* _inner_error0_ = NULL;
#line 100 "../games/scores/context.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 100 "../games/scores/context.vala"
	g_return_val_if_fail (category_type != NULL, NULL);
#line 100 "../games/scores/context.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 100 "../games/scores/context.vala"
	_data1_->_ref_count_ = 1;
#line 100 "../games/scores/context.vala"
	_data1_->category_request = category_request;
#line 100 "../games/scores/context.vala"
	_data1_->category_request_target = category_request_target;
#line 113 "../games/scores/context.vala"
	_tmp0_ = icon_name;
#line 113 "../games/scores/context.vala"
	if (_tmp0_ == NULL) {
#line 113 "../games/scores/context.vala"
		_tmp0_ = app_name;
#line 914 "context.c"
	}
#line 108 "../games/scores/context.vala"
	self = (GamesScoresContext*) g_object_new (object_type, "app-name", app_name, "category-type", category_type, "game-window", game_window, "style", style, "importer", importer, "icon-name", _tmp0_, NULL);
#line 108 "../games/scores/context.vala"
	_data1_->self = g_object_ref (self);
#line 119 "../games/scores/context.vala"
	(self->priv->category_request_target_destroy_notify == NULL) ? NULL : (self->priv->category_request_target_destroy_notify (self->priv->category_request_target), NULL);
#line 119 "../games/scores/context.vala"
	self->priv->category_request = NULL;
#line 119 "../games/scores/context.vala"
	self->priv->category_request_target = NULL;
#line 119 "../games/scores/context.vala"
	self->priv->category_request_target_destroy_notify = NULL;
#line 119 "../games/scores/context.vala"
	self->priv->category_request = ___lambda6__games_scores_context_category_request_func;
#line 119 "../games/scores/context.vala"
	self->priv->category_request_target = block1_data_ref (_data1_);
#line 119 "../games/scores/context.vala"
	self->priv->category_request_target_destroy_notify = block1_data_unref;
#line 934 "context.c"
	{
#line 122 "../games/scores/context.vala"
		games_scores_context_load_scores_from_files (self, &_inner_error0_);
#line 122 "../games/scores/context.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 940 "context.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 120 "../games/scores/context.vala"
		e = _inner_error0_;
#line 120 "../games/scores/context.vala"
		_inner_error0_ = NULL;
#line 126 "../games/scores/context.vala"
		_tmp1_ = e;
#line 126 "../games/scores/context.vala"
		_tmp2_ = _tmp1_->message;
#line 126 "../games/scores/context.vala"
		g_warning ("context.vala:126: Failed to load scores: %s", _tmp2_);
#line 120 "../games/scores/context.vala"
		_g_error_free0 (e);
#line 962 "context.c"
	}
	__finally0:
#line 120 "../games/scores/context.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../games/scores/context.vala"
		block1_data_unref (_data1_);
#line 120 "../games/scores/context.vala"
		_data1_ = NULL;
#line 120 "../games/scores/context.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../games/scores/context.vala"
		g_clear_error (&_inner_error0_);
#line 120 "../games/scores/context.vala"
		return NULL;
#line 977 "context.c"
	}
#line 100 "../games/scores/context.vala"
	block1_data_unref (_data1_);
#line 100 "../games/scores/context.vala"
	_data1_ = NULL;
#line 100 "../games/scores/context.vala"
	return self;
#line 985 "context.c"
}

GamesScoresContext*
games_scores_context_new_with_importer_and_icon_name (const gchar* app_name,
                                                      const gchar* category_type,
                                                      GtkWindow* game_window,
                                                      GamesScoresContextCategoryRequestFunc category_request,
                                                      gpointer category_request_target,
                                                      GamesScoresStyle style,
                                                      GamesScoresImporter* importer,
                                                      const gchar* icon_name)
{
#line 100 "../games/scores/context.vala"
	return games_scores_context_construct_with_importer_and_icon_name (GAMES_SCORES_TYPE_CONTEXT, app_name, category_type, game_window, category_request, category_request_target, style, importer, icon_name);
#line 1000 "context.c"
}

static void
games_scores_context_real_constructed (GObject* base)
{
	GamesScoresContext * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GamesScoresImporter* _tmp3_;
#line 130 "../games/scores/context.vala"
	self = (GamesScoresContext*) base;
#line 132 "../games/scores/context.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 132 "../games/scores/context.vala"
	_tmp1_ = self->priv->_app_name;
#line 132 "../games/scores/context.vala"
	_tmp2_ = g_build_filename (_tmp0_, _tmp1_, "scores", NULL, NULL);
#line 132 "../games/scores/context.vala"
	_g_free0 (self->priv->user_score_dir);
#line 132 "../games/scores/context.vala"
	self->priv->user_score_dir = _tmp2_;
#line 134 "../games/scores/context.vala"
	_tmp3_ = self->priv->_importer;
#line 134 "../games/scores/context.vala"
	if (_tmp3_ != NULL) {
#line 1027 "context.c"
		GamesScoresImporter* _tmp4_;
		const gchar* _tmp5_;
#line 135 "../games/scores/context.vala"
		_tmp4_ = self->priv->_importer;
#line 135 "../games/scores/context.vala"
		_tmp5_ = self->priv->user_score_dir;
#line 135 "../games/scores/context.vala"
		games_scores_importer_run (_tmp4_, self, _tmp5_);
#line 1036 "context.c"
	}
}

GList*
games_scores_context_get_categories (GamesScoresContext* self)
{
	GList* categories = NULL;
	GeeMapIterator* iterator = NULL;
	GeeHashMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	GList* result;
#line 138 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 140 "../games/scores/context.vala"
	categories = NULL;
#line 141 "../games/scores/context.vala"
	_tmp0_ = self->priv->scores_per_category;
#line 141 "../games/scores/context.vala"
	_tmp1_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp0_);
#line 141 "../games/scores/context.vala"
	iterator = _tmp1_;
#line 143 "../games/scores/context.vala"
	while (TRUE) {
#line 1060 "context.c"
		GeeMapIterator* _tmp2_;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
#line 143 "../games/scores/context.vala"
		_tmp2_ = iterator;
#line 143 "../games/scores/context.vala"
		if (!gee_map_iterator_next (_tmp2_)) {
#line 143 "../games/scores/context.vala"
			break;
#line 1070 "context.c"
		}
#line 145 "../games/scores/context.vala"
		_tmp3_ = iterator;
#line 145 "../games/scores/context.vala"
		_tmp4_ = gee_map_iterator_get_key (_tmp3_);
#line 145 "../games/scores/context.vala"
		categories = g_list_append (categories, (GamesScoresCategory*) _tmp4_);
#line 1078 "context.c"
	}
#line 148 "../games/scores/context.vala"
	result = categories;
#line 148 "../games/scores/context.vala"
	_g_object_unref0 (iterator);
#line 148 "../games/scores/context.vala"
	return result;
#line 1086 "context.c"
}

void
games_scores_context_update_score_name (GamesScoresContext* self,
                                        GamesScoresScore* old_score,
                                        GamesScoresCategory* category,
                                        const gchar* new_name)
{
#line 152 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 152 "../games/scores/context.vala"
	g_return_if_fail (old_score != NULL);
#line 152 "../games/scores/context.vala"
	g_return_if_fail (category != NULL);
#line 152 "../games/scores/context.vala"
	g_return_if_fail (new_name != NULL);
#line 1103 "context.c"
	{
		GeeList* _score_list = NULL;
		GeeHashMap* _tmp0_;
		gpointer _tmp1_;
		gint _score_size = 0;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _score_index = 0;
#line 154 "../games/scores/context.vala"
		_tmp0_ = self->priv->scores_per_category;
#line 154 "../games/scores/context.vala"
		_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, category);
#line 154 "../games/scores/context.vala"
		_score_list = (GeeList*) _tmp1_;
#line 154 "../games/scores/context.vala"
		_tmp2_ = _score_list;
#line 154 "../games/scores/context.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 154 "../games/scores/context.vala"
		_tmp4_ = _tmp3_;
#line 154 "../games/scores/context.vala"
		_score_size = _tmp4_;
#line 154 "../games/scores/context.vala"
		_score_index = -1;
#line 154 "../games/scores/context.vala"
		while (TRUE) {
#line 1131 "context.c"
			gint _tmp5_;
			gint _tmp6_;
			GamesScoresScore* score = NULL;
			GeeList* _tmp7_;
			gpointer _tmp8_;
			GamesScoresScore* _tmp9_;
#line 154 "../games/scores/context.vala"
			_score_index = _score_index + 1;
#line 154 "../games/scores/context.vala"
			_tmp5_ = _score_index;
#line 154 "../games/scores/context.vala"
			_tmp6_ = _score_size;
#line 154 "../games/scores/context.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 154 "../games/scores/context.vala"
				break;
#line 1148 "context.c"
			}
#line 154 "../games/scores/context.vala"
			_tmp7_ = _score_list;
#line 154 "../games/scores/context.vala"
			_tmp8_ = gee_list_get (_tmp7_, _score_index);
#line 154 "../games/scores/context.vala"
			score = (GamesScoresScore*) _tmp8_;
#line 156 "../games/scores/context.vala"
			_tmp9_ = score;
#line 156 "../games/scores/context.vala"
			if (games_scores_score_equals (_tmp9_, old_score)) {
#line 1160 "context.c"
				GamesScoresScore* _tmp10_;
#line 158 "../games/scores/context.vala"
				_tmp10_ = score;
#line 158 "../games/scores/context.vala"
				games_scores_score_set_user (_tmp10_, new_name);
#line 159 "../games/scores/context.vala"
				_g_object_unref0 (score);
#line 159 "../games/scores/context.vala"
				_g_object_unref0 (_score_list);
#line 159 "../games/scores/context.vala"
				return;
#line 1172 "context.c"
			}
#line 154 "../games/scores/context.vala"
			_g_object_unref0 (score);
#line 1176 "context.c"
		}
#line 154 "../games/scores/context.vala"
		_g_object_unref0 (_score_list);
#line 1180 "context.c"
	}
#line 162 "../games/scores/context.vala"
	g_assert_not_reached ();
#line 1184 "context.c"
}

static gint
___lambda7_ (GamesScoresContext* self,
             GamesScoresScore* a,
             GamesScoresScore* b)
{
	glong _tmp0_;
	glong _tmp1_;
	glong _tmp2_;
	glong _tmp3_;
	glong _tmp4_;
	glong _tmp5_;
	glong _tmp6_;
	glong _tmp7_;
	gint result;
#line 174 "../games/scores/context.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 174 "../games/scores/context.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 175 "../games/scores/context.vala"
	_tmp0_ = games_scores_score_get_score (b);
#line 175 "../games/scores/context.vala"
	_tmp1_ = _tmp0_;
#line 175 "../games/scores/context.vala"
	_tmp2_ = games_scores_score_get_score (a);
#line 175 "../games/scores/context.vala"
	_tmp3_ = _tmp2_;
#line 175 "../games/scores/context.vala"
	_tmp4_ = games_scores_score_get_score (a);
#line 175 "../games/scores/context.vala"
	_tmp5_ = _tmp4_;
#line 175 "../games/scores/context.vala"
	_tmp6_ = games_scores_score_get_score (b);
#line 175 "../games/scores/context.vala"
	_tmp7_ = _tmp6_;
#line 175 "../games/scores/context.vala"
	result = ((gint) (_tmp1_ > _tmp3_)) - ((gint) (_tmp5_ > _tmp7_));
#line 175 "../games/scores/context.vala"
	return result;
#line 1225 "context.c"
}

static gint
____lambda7__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = ___lambda7_ ((GamesScoresContext*) self, (GamesScoresScore*) a, (GamesScoresScore*) b);
#line 174 "../games/scores/context.vala"
	return result;
#line 1237 "context.c"
}

static gint
___lambda8_ (GamesScoresContext* self,
             GamesScoresScore* a,
             GamesScoresScore* b)
{
	glong _tmp0_;
	glong _tmp1_;
	glong _tmp2_;
	glong _tmp3_;
	glong _tmp4_;
	glong _tmp5_;
	glong _tmp6_;
	glong _tmp7_;
	gint result;
#line 180 "../games/scores/context.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 180 "../games/scores/context.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 181 "../games/scores/context.vala"
	_tmp0_ = games_scores_score_get_score (b);
#line 181 "../games/scores/context.vala"
	_tmp1_ = _tmp0_;
#line 181 "../games/scores/context.vala"
	_tmp2_ = games_scores_score_get_score (a);
#line 181 "../games/scores/context.vala"
	_tmp3_ = _tmp2_;
#line 181 "../games/scores/context.vala"
	_tmp4_ = games_scores_score_get_score (a);
#line 181 "../games/scores/context.vala"
	_tmp5_ = _tmp4_;
#line 181 "../games/scores/context.vala"
	_tmp6_ = games_scores_score_get_score (b);
#line 181 "../games/scores/context.vala"
	_tmp7_ = _tmp6_;
#line 181 "../games/scores/context.vala"
	result = ((gint) (_tmp1_ < _tmp3_)) - ((gint) (_tmp5_ < _tmp7_));
#line 181 "../games/scores/context.vala"
	return result;
#line 1278 "context.c"
}

static gint
____lambda8__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = ___lambda8_ ((GamesScoresContext*) self, (GamesScoresScore*) a, (GamesScoresScore*) b);
#line 180 "../games/scores/context.vala"
	return result;
#line 1290 "context.c"
}

GeeList*
games_scores_context_get_high_scores (GamesScoresContext* self,
                                      GamesScoresCategory* category,
                                      gint n)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GamesScoresStyle _tmp3_;
	GeeList* result;
#line 166 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 166 "../games/scores/context.vala"
	g_return_val_if_fail (category != NULL, NULL);
#line 168 "../games/scores/context.vala"
	_tmp0_ = gee_array_list_new (GAMES_SCORES_TYPE_SCORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 168 "../games/scores/context.vala"
	_result_ = _tmp0_;
#line 169 "../games/scores/context.vala"
	_tmp1_ = self->priv->scores_per_category;
#line 169 "../games/scores/context.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, category)) {
#line 170 "../games/scores/context.vala"
		result = (GeeList*) _result_;
#line 170 "../games/scores/context.vala"
		return result;
#line 1320 "context.c"
	}
#line 172 "../games/scores/context.vala"
	_tmp3_ = self->priv->_style;
#line 172 "../games/scores/context.vala"
	if (_tmp3_ == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 172 "../games/scores/context.vala"
		_tmp2_ = TRUE;
#line 1328 "context.c"
	} else {
		GamesScoresStyle _tmp4_;
#line 172 "../games/scores/context.vala"
		_tmp4_ = self->priv->_style;
#line 172 "../games/scores/context.vala"
		_tmp2_ = _tmp4_ == GAMES_SCORES_STYLE_TIME_GREATER_IS_BETTER;
#line 1335 "context.c"
	}
#line 172 "../games/scores/context.vala"
	if (_tmp2_) {
#line 1339 "context.c"
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
		GeeList* _tmp7_;
#line 174 "../games/scores/context.vala"
		_tmp5_ = self->priv->scores_per_category;
#line 174 "../games/scores/context.vala"
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, category);
#line 174 "../games/scores/context.vala"
		_tmp7_ = (GeeList*) _tmp6_;
#line 174 "../games/scores/context.vala"
		gee_list_sort (_tmp7_, ____lambda7__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 174 "../games/scores/context.vala"
		_g_object_unref0 (_tmp7_);
#line 1353 "context.c"
	} else {
		GeeHashMap* _tmp8_;
		gpointer _tmp9_;
		GeeList* _tmp10_;
#line 180 "../games/scores/context.vala"
		_tmp8_ = self->priv->scores_per_category;
#line 180 "../games/scores/context.vala"
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, category);
#line 180 "../games/scores/context.vala"
		_tmp10_ = (GeeList*) _tmp9_;
#line 180 "../games/scores/context.vala"
		gee_list_sort (_tmp10_, ____lambda8__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 180 "../games/scores/context.vala"
		_g_object_unref0 (_tmp10_);
#line 1368 "context.c"
	}
	{
		gint i = 0;
#line 185 "../games/scores/context.vala"
		i = 0;
#line 1374 "context.c"
		{
			gboolean _tmp11_ = FALSE;
#line 185 "../games/scores/context.vala"
			_tmp11_ = TRUE;
#line 185 "../games/scores/context.vala"
			while (TRUE) {
#line 1381 "context.c"
				gboolean _tmp13_ = FALSE;
				GeeArrayList* _tmp19_;
				GeeHashMap* _tmp20_;
				gpointer _tmp21_;
				GeeList* _tmp22_;
				gpointer _tmp23_;
				GamesScoresScore* _tmp24_;
#line 185 "../games/scores/context.vala"
				if (!_tmp11_) {
#line 1391 "context.c"
					gint _tmp12_;
#line 185 "../games/scores/context.vala"
					_tmp12_ = i;
#line 185 "../games/scores/context.vala"
					i = _tmp12_ + 1;
#line 1397 "context.c"
				}
#line 185 "../games/scores/context.vala"
				_tmp11_ = FALSE;
#line 185 "../games/scores/context.vala"
				if (i < n) {
#line 1403 "context.c"
					GeeHashMap* _tmp14_;
					gpointer _tmp15_;
					GeeList* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
#line 185 "../games/scores/context.vala"
					_tmp14_ = self->priv->scores_per_category;
#line 185 "../games/scores/context.vala"
					_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, category);
#line 185 "../games/scores/context.vala"
					_tmp16_ = (GeeList*) _tmp15_;
#line 185 "../games/scores/context.vala"
					_tmp17_ = gee_collection_get_size ((GeeCollection*) _tmp16_);
#line 185 "../games/scores/context.vala"
					_tmp18_ = _tmp17_;
#line 185 "../games/scores/context.vala"
					_tmp13_ = i < _tmp18_;
#line 185 "../games/scores/context.vala"
					_g_object_unref0 (_tmp16_);
#line 1423 "context.c"
				} else {
#line 185 "../games/scores/context.vala"
					_tmp13_ = FALSE;
#line 1427 "context.c"
				}
#line 185 "../games/scores/context.vala"
				if (!_tmp13_) {
#line 185 "../games/scores/context.vala"
					break;
#line 1433 "context.c"
				}
#line 186 "../games/scores/context.vala"
				_tmp19_ = _result_;
#line 186 "../games/scores/context.vala"
				_tmp20_ = self->priv->scores_per_category;
#line 186 "../games/scores/context.vala"
				_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, category);
#line 186 "../games/scores/context.vala"
				_tmp22_ = (GeeList*) _tmp21_;
#line 186 "../games/scores/context.vala"
				_tmp23_ = gee_list_get (_tmp22_, i);
#line 186 "../games/scores/context.vala"
				_tmp24_ = (GamesScoresScore*) _tmp23_;
#line 186 "../games/scores/context.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp24_);
#line 186 "../games/scores/context.vala"
				_g_object_unref0 (_tmp24_);
#line 186 "../games/scores/context.vala"
				_g_object_unref0 (_tmp22_);
#line 1453 "context.c"
			}
		}
	}
#line 187 "../games/scores/context.vala"
	result = (GeeList*) _result_;
#line 187 "../games/scores/context.vala"
	return result;
#line 1461 "context.c"
}

static gboolean
games_scores_context_is_high_score (GamesScoresContext* self,
                                    glong score_value,
                                    GamesScoresCategory* category)
{
	GeeList* best_scores = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	glong lowest = 0L;
	GeeList* _tmp5_;
	gpointer _tmp6_;
	GamesScoresScore* _tmp7_;
	glong _tmp8_;
	glong _tmp9_;
	glong _tmp10_;
	gboolean _tmp11_ = FALSE;
	GamesScoresStyle _tmp12_;
	gboolean result;
#line 190 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 190 "../games/scores/context.vala"
	g_return_val_if_fail (category != NULL, FALSE);
#line 192 "../games/scores/context.vala"
	_tmp0_ = games_scores_context_get_high_scores (self, category, 10);
#line 192 "../games/scores/context.vala"
	best_scores = _tmp0_;
#line 195 "../games/scores/context.vala"
	_tmp1_ = best_scores;
#line 195 "../games/scores/context.vala"
	if (_tmp1_ == NULL) {
#line 196 "../games/scores/context.vala"
		result = TRUE;
#line 196 "../games/scores/context.vala"
		_g_object_unref0 (best_scores);
#line 196 "../games/scores/context.vala"
		return result;
#line 1503 "context.c"
	}
#line 198 "../games/scores/context.vala"
	_tmp2_ = best_scores;
#line 198 "../games/scores/context.vala"
	_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 198 "../games/scores/context.vala"
	_tmp4_ = _tmp3_;
#line 198 "../games/scores/context.vala"
	if (_tmp4_ < 10) {
#line 199 "../games/scores/context.vala"
		result = TRUE;
#line 199 "../games/scores/context.vala"
		_g_object_unref0 (best_scores);
#line 199 "../games/scores/context.vala"
		return result;
#line 1519 "context.c"
	}
#line 201 "../games/scores/context.vala"
	_tmp5_ = best_scores;
#line 201 "../games/scores/context.vala"
	_tmp6_ = gee_list_get (_tmp5_, 9);
#line 201 "../games/scores/context.vala"
	_tmp7_ = (GamesScoresScore*) _tmp6_;
#line 201 "../games/scores/context.vala"
	_tmp8_ = games_scores_score_get_score (_tmp7_);
#line 201 "../games/scores/context.vala"
	_tmp9_ = _tmp8_;
#line 201 "../games/scores/context.vala"
	_tmp10_ = _tmp9_;
#line 201 "../games/scores/context.vala"
	_g_object_unref0 (_tmp7_);
#line 201 "../games/scores/context.vala"
	lowest = _tmp10_;
#line 203 "../games/scores/context.vala"
	_tmp12_ = self->priv->_style;
#line 203 "../games/scores/context.vala"
	if (_tmp12_ == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER) {
#line 203 "../games/scores/context.vala"
		_tmp11_ = TRUE;
#line 1543 "context.c"
	} else {
		GamesScoresStyle _tmp13_;
#line 203 "../games/scores/context.vala"
		_tmp13_ = self->priv->_style;
#line 203 "../games/scores/context.vala"
		_tmp11_ = _tmp13_ == GAMES_SCORES_STYLE_TIME_LESS_IS_BETTER;
#line 1550 "context.c"
	}
#line 203 "../games/scores/context.vala"
	if (_tmp11_) {
#line 204 "../games/scores/context.vala"
		result = score_value < lowest;
#line 204 "../games/scores/context.vala"
		_g_object_unref0 (best_scores);
#line 204 "../games/scores/context.vala"
		return result;
#line 1560 "context.c"
	}
#line 206 "../games/scores/context.vala"
	result = score_value > lowest;
#line 206 "../games/scores/context.vala"
	_g_object_unref0 (best_scores);
#line 206 "../games/scores/context.vala"
	return result;
#line 1568 "context.c"
}

static void
games_scores_context_save_score_to_file_data_free (gpointer _data)
{
	GamesScoresContextSaveScoreToFileData* _data_;
	_data_ = _data;
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->score);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->category);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../games/scores/context.vala"
	g_slice_free (GamesScoresContextSaveScoreToFileData, _data_);
#line 1586 "context.c"
}

static void
games_scores_context_save_score_to_file (GamesScoresContext* self,
                                         GamesScoresScore* score,
                                         GamesScoresCategory* category,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GamesScoresContextSaveScoreToFileData* _data_;
	GamesScoresContext* _tmp0_;
	GamesScoresScore* _tmp1_;
	GamesScoresCategory* _tmp2_;
	GCancellable* _tmp3_;
#line 33 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 33 "../games/scores/context.vala"
	g_return_if_fail (score != NULL);
#line 33 "../games/scores/context.vala"
	g_return_if_fail (category != NULL);
#line 33 "../games/scores/context.vala"
	_data_ = g_slice_new0 (GamesScoresContextSaveScoreToFileData);
#line 33 "../games/scores/context.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 33 "../games/scores/context.vala"
	g_task_set_task_data (_data_->_async_result, _data_, games_scores_context_save_score_to_file_data_free);
#line 33 "../games/scores/context.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../games/scores/context.vala"
	_data_->self = _tmp0_;
#line 33 "../games/scores/context.vala"
	_tmp1_ = _g_object_ref0 (score);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->score);
#line 33 "../games/scores/context.vala"
	_data_->score = _tmp1_;
#line 33 "../games/scores/context.vala"
	_tmp2_ = _g_object_ref0 (category);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->category);
#line 33 "../games/scores/context.vala"
	_data_->category = _tmp2_;
#line 33 "../games/scores/context.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../games/scores/context.vala"
	_data_->cancellable = _tmp3_;
#line 33 "../games/scores/context.vala"
	games_scores_context_save_score_to_file_co (_data_);
#line 1638 "context.c"
}

static void
games_scores_context_save_score_to_file_finish (GamesScoresContext* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GamesScoresContextSaveScoreToFileData* _data_;
#line 33 "../games/scores/context.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 33 "../games/scores/context.vala"
	if (NULL == _data_) {
#line 33 "../games/scores/context.vala"
		return;
#line 1653 "context.c"
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1667 "context.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1704 "context.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1710 "context.c"
}

static void
games_scores_context_save_score_to_file_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GamesScoresContextSaveScoreToFileData* _data_;
#line 220 "../games/scores/context.vala"
	_data_ = _user_data_;
#line 220 "../games/scores/context.vala"
	_data_->_source_object_ = source_object;
#line 220 "../games/scores/context.vala"
	_data_->_res_ = _res_;
#line 220 "../games/scores/context.vala"
	games_scores_context_save_score_to_file_co (_data_);
#line 1727 "context.c"
}

static gboolean
games_scores_context_save_score_to_file_co (GamesScoresContextSaveScoreToFileData* _data_)
{
#line 209 "../games/scores/context.vala"
	switch (_data_->_state_) {
#line 209 "../games/scores/context.vala"
		case 0:
#line 1737 "context.c"
		goto _state_0;
#line 209 "../games/scores/context.vala"
		case 1:
#line 1741 "context.c"
		goto _state_1;
		default:
#line 209 "../games/scores/context.vala"
		g_assert_not_reached ();
#line 1746 "context.c"
	}
	_state_0:
#line 211 "../games/scores/context.vala"
	_data_->_tmp0_ = _data_->self->priv->user_score_dir;
#line 211 "../games/scores/context.vala"
	if (g_mkdir_with_parents (_data_->_tmp0_, 0766) == -1) {
#line 213 "../games/scores/context.vala"
		_data_->_tmp1_ = _data_->self->priv->user_score_dir;
#line 213 "../games/scores/context.vala"
		_data_->_tmp2_ = g_strerror (errno);
#line 213 "../games/scores/context.vala"
		_data_->_tmp3_ = g_error_new (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Failed to create %s: %s", _data_->_tmp1_, _data_->_tmp2_);
#line 213 "../games/scores/context.vala"
		_data_->_inner_error0_ = _data_->_tmp3_;
#line 213 "../games/scores/context.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 213 "../games/scores/context.vala"
		g_object_unref (_data_->_async_result);
#line 213 "../games/scores/context.vala"
		return FALSE;
#line 1767 "context.c"
	}
#line 216 "../games/scores/context.vala"
	_data_->_tmp4_ = _data_->self->priv->user_score_dir;
#line 216 "../games/scores/context.vala"
	_data_->_tmp5_ = games_scores_category_get_key (_data_->category);
#line 216 "../games/scores/context.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 216 "../games/scores/context.vala"
	_data_->_tmp7_ = g_build_filename (_data_->_tmp4_, _data_->_tmp6_, NULL);
#line 216 "../games/scores/context.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 216 "../games/scores/context.vala"
	_data_->_tmp9_ = g_file_new_for_path (_data_->_tmp8_);
#line 216 "../games/scores/context.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 216 "../games/scores/context.vala"
	_g_free0 (_data_->_tmp8_);
#line 216 "../games/scores/context.vala"
	_data_->file = _data_->_tmp10_;
#line 217 "../games/scores/context.vala"
	_data_->_tmp11_ = _data_->file;
#line 217 "../games/scores/context.vala"
	_data_->_tmp12_ = g_file_append_to (_data_->_tmp11_, G_FILE_CREATE_NONE, NULL, &_data_->_inner_error0_);
#line 217 "../games/scores/context.vala"
	_data_->stream = _data_->_tmp12_;
#line 217 "../games/scores/context.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 217 "../games/scores/context.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 217 "../games/scores/context.vala"
		_g_object_unref0 (_data_->file);
#line 217 "../games/scores/context.vala"
		g_object_unref (_data_->_async_result);
#line 217 "../games/scores/context.vala"
		return FALSE;
#line 1803 "context.c"
	}
#line 218 "../games/scores/context.vala"
	_data_->_tmp13_ = games_scores_score_get_score (_data_->score);
#line 218 "../games/scores/context.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 218 "../games/scores/context.vala"
	_data_->_tmp15_ = g_strdup_printf ("%li", _data_->_tmp14_);
#line 218 "../games/scores/context.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 218 "../games/scores/context.vala"
	_data_->_tmp17_ = games_scores_score_get_time (_data_->score);
#line 218 "../games/scores/context.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 218 "../games/scores/context.vala"
	_data_->_tmp19_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp18_);
#line 218 "../games/scores/context.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 218 "../games/scores/context.vala"
	_data_->_tmp21_ = games_scores_score_get_user (_data_->score);
#line 218 "../games/scores/context.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 218 "../games/scores/context.vala"
	_data_->_tmp23_ = string_to_string (_data_->_tmp22_);
#line 218 "../games/scores/context.vala"
	_data_->_tmp24_ = g_strconcat (_data_->_tmp16_, " ", _data_->_tmp20_, " ", _data_->_tmp23_, "\n", NULL);
#line 218 "../games/scores/context.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 218 "../games/scores/context.vala"
	_g_free0 (_data_->_tmp20_);
#line 218 "../games/scores/context.vala"
	_g_free0 (_data_->_tmp16_);
#line 218 "../games/scores/context.vala"
	_data_->line = _data_->_tmp25_;
#line 220 "../games/scores/context.vala"
	_data_->_tmp26_ = _data_->stream;
#line 220 "../games/scores/context.vala"
	_data_->_tmp27_ = _data_->line;
#line 220 "../games/scores/context.vala"
	_data_->_tmp29_ = 0;
#line 220 "../games/scores/context.vala"
	_data_->_tmp28_ = string_get_data (_data_->_tmp27_, &_data_->_tmp29_);
#line 220 "../games/scores/context.vala"
	_data_->_tmp28__length1 = _data_->_tmp29_;
#line 220 "../games/scores/context.vala"
	_data_->_tmp30_ = _data_->_tmp28_;
#line 220 "../games/scores/context.vala"
	_data_->_tmp30__length1 = _data_->_tmp28__length1;
#line 220 "../games/scores/context.vala"
	_data_->_state_ = 1;
#line 220 "../games/scores/context.vala"
	g_output_stream_write_all_async ((GOutputStream*) _data_->_tmp26_, _data_->_tmp30_, (gsize) _data_->_tmp30__length1, G_PRIORITY_DEFAULT, _data_->cancellable, games_scores_context_save_score_to_file_ready, _data_);
#line 220 "../games/scores/context.vala"
	return FALSE;
#line 1857 "context.c"
	_state_1:
#line 220 "../games/scores/context.vala"
	g_output_stream_write_all_finish ((GOutputStream*) _data_->_tmp26_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 220 "../games/scores/context.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 220 "../games/scores/context.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 220 "../games/scores/context.vala"
		_g_free0 (_data_->line);
#line 220 "../games/scores/context.vala"
		_g_object_unref0 (_data_->stream);
#line 220 "../games/scores/context.vala"
		_g_object_unref0 (_data_->file);
#line 220 "../games/scores/context.vala"
		g_object_unref (_data_->_async_result);
#line 220 "../games/scores/context.vala"
		return FALSE;
#line 1875 "context.c"
	}
#line 209 "../games/scores/context.vala"
	_g_free0 (_data_->line);
#line 209 "../games/scores/context.vala"
	_g_object_unref0 (_data_->stream);
#line 209 "../games/scores/context.vala"
	_g_object_unref0 (_data_->file);
#line 209 "../games/scores/context.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 209 "../games/scores/context.vala"
	if (_data_->_state_ != 0) {
#line 209 "../games/scores/context.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 209 "../games/scores/context.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1891 "context.c"
		}
	}
#line 209 "../games/scores/context.vala"
	g_object_unref (_data_->_async_result);
#line 209 "../games/scores/context.vala"
	return FALSE;
#line 1898 "context.c"
}

static void
games_scores_context_add_score_internal_data_free (gpointer _data)
{
	GamesScoresContextAddScoreInternalData* _data_;
	_data_ = _data;
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->score);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->category);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../games/scores/context.vala"
	g_slice_free (GamesScoresContextAddScoreInternalData, _data_);
#line 1916 "context.c"
}

void
games_scores_context_add_score_internal (GamesScoresContext* self,
                                         GamesScoresScore* score,
                                         GamesScoresCategory* category,
                                         gboolean allow_dialog,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GamesScoresContextAddScoreInternalData* _data_;
	GamesScoresContext* _tmp0_;
	GamesScoresScore* _tmp1_;
	GamesScoresCategory* _tmp2_;
	GCancellable* _tmp3_;
#line 33 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 33 "../games/scores/context.vala"
	g_return_if_fail (score != NULL);
#line 33 "../games/scores/context.vala"
	g_return_if_fail (category != NULL);
#line 33 "../games/scores/context.vala"
	_data_ = g_slice_new0 (GamesScoresContextAddScoreInternalData);
#line 33 "../games/scores/context.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 33 "../games/scores/context.vala"
	g_task_set_task_data (_data_->_async_result, _data_, games_scores_context_add_score_internal_data_free);
#line 33 "../games/scores/context.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../games/scores/context.vala"
	_data_->self = _tmp0_;
#line 33 "../games/scores/context.vala"
	_tmp1_ = _g_object_ref0 (score);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->score);
#line 33 "../games/scores/context.vala"
	_data_->score = _tmp1_;
#line 33 "../games/scores/context.vala"
	_tmp2_ = _g_object_ref0 (category);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->category);
#line 33 "../games/scores/context.vala"
	_data_->category = _tmp2_;
#line 33 "../games/scores/context.vala"
	_data_->allow_dialog = allow_dialog;
#line 33 "../games/scores/context.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../games/scores/context.vala"
	_data_->cancellable = _tmp3_;
#line 33 "../games/scores/context.vala"
	games_scores_context_add_score_internal_co (_data_);
#line 1971 "context.c"
}

gboolean
games_scores_context_add_score_internal_finish (GamesScoresContext* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	gboolean result;
	GamesScoresContextAddScoreInternalData* _data_;
#line 33 "../games/scores/context.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 33 "../games/scores/context.vala"
	if (NULL == _data_) {
#line 1985 "context.c"
		gboolean _tmp0_ = FALSE;
#line 33 "../games/scores/context.vala"
		return _tmp0_;
#line 1989 "context.c"
	}
#line 33 "../games/scores/context.vala"
	result = _data_->result;
#line 33 "../games/scores/context.vala"
	return result;
#line 1995 "context.c"
}

static void
games_scores_context_add_score_internal_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GamesScoresContextAddScoreInternalData* _data_;
#line 243 "../games/scores/context.vala"
	_data_ = _user_data_;
#line 243 "../games/scores/context.vala"
	_data_->_source_object_ = source_object;
#line 243 "../games/scores/context.vala"
	_data_->_res_ = _res_;
#line 243 "../games/scores/context.vala"
	games_scores_context_add_score_internal_co (_data_);
#line 2012 "context.c"
}

static gboolean
games_scores_context_add_score_internal_co (GamesScoresContextAddScoreInternalData* _data_)
{
#line 223 "../games/scores/context.vala"
	switch (_data_->_state_) {
#line 223 "../games/scores/context.vala"
		case 0:
#line 2022 "context.c"
		goto _state_0;
#line 223 "../games/scores/context.vala"
		case 1:
#line 2026 "context.c"
		goto _state_1;
		default:
#line 223 "../games/scores/context.vala"
		g_assert_not_reached ();
#line 2031 "context.c"
	}
	_state_0:
#line 228 "../games/scores/context.vala"
	_data_->_tmp0_ = games_scores_score_get_score (_data_->score);
#line 228 "../games/scores/context.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 228 "../games/scores/context.vala"
	_data_->high_score_added = games_scores_context_is_high_score (_data_->self, _data_->_tmp1_, _data_->category);
#line 231 "../games/scores/context.vala"
	_data_->_tmp2_ = _data_->self->priv->scores_per_category;
#line 231 "../games/scores/context.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _data_->_tmp2_, _data_->category)) {
#line 232 "../games/scores/context.vala"
		_data_->_tmp3_ = _data_->self->priv->scores_per_category;
#line 232 "../games/scores/context.vala"
		_data_->_tmp4_ = gee_array_list_new (GAMES_SCORES_TYPE_SCORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 232 "../games/scores/context.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 232 "../games/scores/context.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp3_, _data_->category, (GeeList*) _data_->_tmp5_);
#line 232 "../games/scores/context.vala"
		_g_object_unref0 (_data_->_tmp5_);
#line 2054 "context.c"
	}
#line 234 "../games/scores/context.vala"
	_data_->_tmp6_ = _data_->self->priv->scores_per_category;
#line 234 "../games/scores/context.vala"
	_data_->_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp6_, _data_->category);
#line 234 "../games/scores/context.vala"
	_data_->_tmp8_ = (GeeList*) _data_->_tmp7_;
#line 234 "../games/scores/context.vala"
	_data_->_tmp9_ = gee_collection_add ((GeeCollection*) _data_->_tmp8_, _data_->score);
#line 234 "../games/scores/context.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 234 "../games/scores/context.vala"
	if (_data_->_tmp9_) {
#line 235 "../games/scores/context.vala"
		_data_->_tmp10_ = _g_object_ref0 (_data_->category);
#line 235 "../games/scores/context.vala"
		_g_object_unref0 (_data_->self->priv->current_category);
#line 235 "../games/scores/context.vala"
		_data_->self->priv->current_category = _data_->_tmp10_;
#line 2074 "context.c"
	}
#line 240 "../games/scores/context.vala"
	if (_data_->high_score_added) {
#line 240 "../games/scores/context.vala"
		_data_->_tmp11_ = _data_->allow_dialog;
#line 2080 "context.c"
	} else {
#line 240 "../games/scores/context.vala"
		_data_->_tmp11_ = FALSE;
#line 2084 "context.c"
	}
#line 240 "../games/scores/context.vala"
	if (_data_->_tmp11_) {
#line 241 "../games/scores/context.vala"
		games_scores_context_run_dialog_internal (_data_->self, _data_->score);
#line 2090 "context.c"
	}
#line 243 "../games/scores/context.vala"
	_data_->_tmp12_ = _data_->self->priv->current_category;
#line 243 "../games/scores/context.vala"
	_data_->_state_ = 1;
#line 243 "../games/scores/context.vala"
	games_scores_context_save_score_to_file (_data_->self, _data_->score, _data_->_tmp12_, _data_->cancellable, games_scores_context_add_score_internal_ready, _data_);
#line 243 "../games/scores/context.vala"
	return FALSE;
#line 2100 "context.c"
	_state_1:
#line 243 "../games/scores/context.vala"
	games_scores_context_save_score_to_file_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 243 "../games/scores/context.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 243 "../games/scores/context.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 243 "../games/scores/context.vala"
		g_object_unref (_data_->_async_result);
#line 243 "../games/scores/context.vala"
		return FALSE;
#line 2112 "context.c"
	}
#line 244 "../games/scores/context.vala"
	_data_->result = _data_->high_score_added;
#line 244 "../games/scores/context.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 244 "../games/scores/context.vala"
	if (_data_->_state_ != 0) {
#line 244 "../games/scores/context.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 244 "../games/scores/context.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2124 "context.c"
		}
	}
#line 244 "../games/scores/context.vala"
	g_object_unref (_data_->_async_result);
#line 244 "../games/scores/context.vala"
	return FALSE;
#line 2131 "context.c"
}

static void
games_scores_context_add_score_data_free (gpointer _data)
{
	GamesScoresContextAddScoreData* _data_;
	_data_ = _data;
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->category);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../games/scores/context.vala"
	g_slice_free (GamesScoresContextAddScoreData, _data_);
#line 2147 "context.c"
}

void
games_scores_context_add_score (GamesScoresContext* self,
                                glong score,
                                GamesScoresCategory* category,
                                GCancellable* cancellable,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	GamesScoresContextAddScoreData* _data_;
	GamesScoresContext* _tmp0_;
	GamesScoresCategory* _tmp1_;
	GCancellable* _tmp2_;
#line 33 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 33 "../games/scores/context.vala"
	g_return_if_fail (category != NULL);
#line 33 "../games/scores/context.vala"
	_data_ = g_slice_new0 (GamesScoresContextAddScoreData);
#line 33 "../games/scores/context.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 33 "../games/scores/context.vala"
	g_task_set_task_data (_data_->_async_result, _data_, games_scores_context_add_score_data_free);
#line 33 "../games/scores/context.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../games/scores/context.vala"
	_data_->self = _tmp0_;
#line 33 "../games/scores/context.vala"
	_data_->score = score;
#line 33 "../games/scores/context.vala"
	_tmp1_ = _g_object_ref0 (category);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->category);
#line 33 "../games/scores/context.vala"
	_data_->category = _tmp1_;
#line 33 "../games/scores/context.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 33 "../games/scores/context.vala"
	_g_object_unref0 (_data_->cancellable);
#line 33 "../games/scores/context.vala"
	_data_->cancellable = _tmp2_;
#line 33 "../games/scores/context.vala"
	games_scores_context_add_score_co (_data_);
#line 2192 "context.c"
}

gboolean
games_scores_context_add_score_finish (GamesScoresContext* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	gboolean result;
	GamesScoresContextAddScoreData* _data_;
#line 33 "../games/scores/context.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 33 "../games/scores/context.vala"
	if (NULL == _data_) {
#line 2206 "context.c"
		gboolean _tmp0_ = FALSE;
#line 33 "../games/scores/context.vala"
		return _tmp0_;
#line 2210 "context.c"
	}
#line 33 "../games/scores/context.vala"
	result = _data_->result;
#line 33 "../games/scores/context.vala"
	return result;
#line 2216 "context.c"
}

static void
games_scores_context_add_score_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	GamesScoresContextAddScoreData* _data_;
#line 251 "../games/scores/context.vala"
	_data_ = _user_data_;
#line 251 "../games/scores/context.vala"
	_data_->_source_object_ = source_object;
#line 251 "../games/scores/context.vala"
	_data_->_res_ = _res_;
#line 251 "../games/scores/context.vala"
	games_scores_context_add_score_co (_data_);
#line 2233 "context.c"
}

static gboolean
games_scores_context_add_score_co (GamesScoresContextAddScoreData* _data_)
{
#line 248 "../games/scores/context.vala"
	switch (_data_->_state_) {
#line 248 "../games/scores/context.vala"
		case 0:
#line 2243 "context.c"
		goto _state_0;
#line 248 "../games/scores/context.vala"
		case 1:
#line 2247 "context.c"
		goto _state_1;
		default:
#line 248 "../games/scores/context.vala"
		g_assert_not_reached ();
#line 2252 "context.c"
	}
	_state_0:
#line 251 "../games/scores/context.vala"
	_data_->_tmp1_ = games_scores_score_new (_data_->score, (gint64) 0, NULL);
#line 251 "../games/scores/context.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 251 "../games/scores/context.vala"
	_data_->_tmp3_ = _data_->self->priv->_game_window;
#line 251 "../games/scores/context.vala"
	_data_->_state_ = 1;
#line 251 "../games/scores/context.vala"
	games_scores_context_add_score_internal (_data_->self, _data_->_tmp2_, _data_->category, _data_->_tmp3_ != NULL, _data_->cancellable, games_scores_context_add_score_ready, _data_);
#line 251 "../games/scores/context.vala"
	return FALSE;
#line 2267 "context.c"
	_state_1:
#line 251 "../games/scores/context.vala"
	_data_->_tmp4_ = games_scores_context_add_score_internal_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 251 "../games/scores/context.vala"
	_g_object_unref0 (_data_->_tmp2_);
#line 251 "../games/scores/context.vala"
	_data_->_tmp0_ = _data_->_tmp4_;
#line 251 "../games/scores/context.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 251 "../games/scores/context.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 251 "../games/scores/context.vala"
		g_object_unref (_data_->_async_result);
#line 251 "../games/scores/context.vala"
		return FALSE;
#line 2283 "context.c"
	}
#line 251 "../games/scores/context.vala"
	_data_->result = _data_->_tmp0_;
#line 251 "../games/scores/context.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 251 "../games/scores/context.vala"
	if (_data_->_state_ != 0) {
#line 251 "../games/scores/context.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 251 "../games/scores/context.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2295 "context.c"
		}
	}
#line 251 "../games/scores/context.vala"
	g_object_unref (_data_->_async_result);
#line 251 "../games/scores/context.vala"
	return FALSE;
#line 2302 "context.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 254 "../games/scores/context.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 254 "../games/scores/context.vala"
	return _data2_;
#line 2312 "context.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 254 "../games/scores/context.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2322 "context.c"
		GamesScoresContext* self;
#line 254 "../games/scores/context.vala"
		self = _data2_->self;
#line 254 "../games/scores/context.vala"
		_g_error_free0 (_data2_->_error_);
#line 254 "../games/scores/context.vala"
		_g_main_loop_unref0 (_data2_->main_loop);
#line 254 "../games/scores/context.vala"
		_g_object_unref0 (self);
#line 254 "../games/scores/context.vala"
		g_slice_free (Block2Data, _data2_);
#line 2334 "context.c"
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 269 "../games/scores/context.vala"
	return self ? g_error_copy (self) : NULL;
#line 2343 "context.c"
}

static void
__lambda12_ (Block2Data* _data2_,
             GObject* object,
             GAsyncResult* _result_)
{
	GamesScoresContext* self;
	GMainLoop* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 262 "../games/scores/context.vala"
	self = _data2_->self;
#line 262 "../games/scores/context.vala"
	g_return_if_fail (_result_ != NULL);
#line 2358 "context.c"
	{
		gboolean _tmp0_ = FALSE;
#line 265 "../games/scores/context.vala"
		_tmp0_ = games_scores_context_add_score_internal_finish (self, _result_, &_inner_error0_);
#line 265 "../games/scores/context.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2365 "context.c"
			goto __catch0_g_error;
		}
#line 265 "../games/scores/context.vala"
		_data2_->ret = _tmp0_;
#line 2370 "context.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		GError* _tmp2_;
#line 263 "../games/scores/context.vala"
		e = _inner_error0_;
#line 263 "../games/scores/context.vala"
		_inner_error0_ = NULL;
#line 269 "../games/scores/context.vala"
		_tmp1_ = e;
#line 269 "../games/scores/context.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 269 "../games/scores/context.vala"
		_g_error_free0 (_data2_->_error_);
#line 269 "../games/scores/context.vala"
		_data2_->_error_ = _tmp2_;
#line 263 "../games/scores/context.vala"
		_g_error_free0 (e);
#line 2392 "context.c"
	}
	__finally0:
#line 263 "../games/scores/context.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../games/scores/context.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 263 "../games/scores/context.vala"
		g_clear_error (&_inner_error0_);
#line 263 "../games/scores/context.vala"
		return;
#line 2403 "context.c"
	}
#line 271 "../games/scores/context.vala"
	_tmp3_ = _data2_->main_loop;
#line 271 "../games/scores/context.vala"
	g_main_loop_quit (_tmp3_);
#line 2409 "context.c"
}

static void
___lambda12__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 262 "../games/scores/context.vala"
	__lambda12_ (self, source_object, res);
#line 262 "../games/scores/context.vala"
	block2_data_unref (self);
#line 2421 "context.c"
}

gboolean
games_scores_context_add_score_sync (GamesScoresContext* self,
                                     GamesScoresScore* score,
                                     GamesScoresCategory* category,
                                     GError** error)
{
	Block2Data* _data2_;
	GMainContext* main_context = NULL;
	GMainContext* _tmp0_;
	GMainContext* _tmp1_;
	GMainLoop* _tmp2_;
	GMainContext* _tmp3_;
	GMainLoop* _tmp4_;
	GMainContext* _tmp5_;
	GError* _tmp6_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 254 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 254 "../games/scores/context.vala"
	g_return_val_if_fail (score != NULL, FALSE);
#line 254 "../games/scores/context.vala"
	g_return_val_if_fail (category != NULL, FALSE);
#line 254 "../games/scores/context.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 254 "../games/scores/context.vala"
	_data2_->_ref_count_ = 1;
#line 254 "../games/scores/context.vala"
	_data2_->self = g_object_ref (self);
#line 256 "../games/scores/context.vala"
	_tmp0_ = g_main_context_new ();
#line 256 "../games/scores/context.vala"
	main_context = _tmp0_;
#line 257 "../games/scores/context.vala"
	_tmp1_ = main_context;
#line 257 "../games/scores/context.vala"
	_tmp2_ = g_main_loop_new (_tmp1_, FALSE);
#line 257 "../games/scores/context.vala"
	_data2_->main_loop = _tmp2_;
#line 258 "../games/scores/context.vala"
	_data2_->ret = FALSE;
#line 259 "../games/scores/context.vala"
	_data2_->_error_ = NULL;
#line 261 "../games/scores/context.vala"
	_tmp3_ = main_context;
#line 261 "../games/scores/context.vala"
	g_main_context_push_thread_default (_tmp3_);
#line 262 "../games/scores/context.vala"
	games_scores_context_add_score_internal (self, score, category, FALSE, NULL, ___lambda12__gasync_ready_callback, block2_data_ref (_data2_));
#line 273 "../games/scores/context.vala"
	_tmp4_ = _data2_->main_loop;
#line 273 "../games/scores/context.vala"
	g_main_loop_run (_tmp4_);
#line 274 "../games/scores/context.vala"
	_tmp5_ = main_context;
#line 274 "../games/scores/context.vala"
	g_main_context_pop_thread_default (_tmp5_);
#line 276 "../games/scores/context.vala"
	_tmp6_ = _data2_->_error_;
#line 276 "../games/scores/context.vala"
	if (_tmp6_ != NULL) {
#line 2485 "context.c"
		GError* _tmp7_;
		GError* _tmp8_;
		gboolean _tmp9_ = FALSE;
#line 277 "../games/scores/context.vala"
		_tmp7_ = _data2_->_error_;
#line 277 "../games/scores/context.vala"
		_tmp8_ = _g_error_copy0 (_tmp7_);
#line 277 "../games/scores/context.vala"
		_inner_error0_ = _tmp8_;
#line 277 "../games/scores/context.vala"
		g_propagate_error (error, _inner_error0_);
#line 277 "../games/scores/context.vala"
		_g_main_context_unref0 (main_context);
#line 277 "../games/scores/context.vala"
		block2_data_unref (_data2_);
#line 277 "../games/scores/context.vala"
		_data2_ = NULL;
#line 277 "../games/scores/context.vala"
		return _tmp9_;
#line 2505 "context.c"
	}
#line 278 "../games/scores/context.vala"
	result = _data2_->ret;
#line 278 "../games/scores/context.vala"
	_g_main_context_unref0 (main_context);
#line 278 "../games/scores/context.vala"
	block2_data_unref (_data2_);
#line 278 "../games/scores/context.vala"
	_data2_ = NULL;
#line 278 "../games/scores/context.vala"
	return result;
#line 2517 "context.c"
}

static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 4109 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4111 "glib-2.0.vapi"
	ret = NULL;
#line 4112 "glib-2.0.vapi"
	while (TRUE) {
#line 2533 "context.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4112 "glib-2.0.vapi"
		c = fgetc (self);
#line 4112 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4112 "glib-2.0.vapi"
			break;
#line 2542 "context.c"
		}
#line 4113 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4113 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 2548 "context.c"
			GString* _tmp1_;
#line 4114 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4114 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4114 "glib-2.0.vapi"
			ret = _tmp1_;
#line 2556 "context.c"
		}
#line 4116 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4117 "glib-2.0.vapi"
			break;
#line 2562 "context.c"
		}
#line 4119 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4119 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 2568 "context.c"
	}
#line 4121 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4121 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4122 "glib-2.0.vapi"
		result = NULL;
#line 4122 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4122 "glib-2.0.vapi"
		return result;
#line 2580 "context.c"
	} else {
		GString* _tmp4_;
		gchar* _tmp5_;
#line 4124 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4124 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4124 "glib-2.0.vapi"
		((GString*) _tmp4_)->str = NULL;
#line 4124 "glib-2.0.vapi"
		result = _tmp5_;
#line 4124 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4124 "glib-2.0.vapi"
		return result;
#line 2596 "context.c"
	}
}

static glong
long_parse (const gchar* str,
            guint _base)
{
	glong result;
#line 315 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0L);
#line 316 "glib-2.0.vapi"
	result = strtol (str, NULL, (gint) _base);
#line 316 "glib-2.0.vapi"
	return result;
#line 2611 "context.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 2625 "context.c"
}

static void
games_scores_context_load_scores_from_file (GamesScoresContext* self,
                                            GFileInfo* file_info,
                                            GError** error)
{
	gchar* category_key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GamesScoresCategory* category = NULL;
	GamesScoresContextCategoryRequestFunc _tmp2_;
	gpointer _tmp2__target;
	const gchar* _tmp3_;
	GamesScoresCategory* _tmp4_;
	GamesScoresCategory* _tmp5_;
	gchar* filename = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GeeArrayList* scores_of_single_category = NULL;
	GeeArrayList* _tmp9_;
	FILE* stream = NULL;
	const gchar* _tmp10_;
	FILE* _tmp11_;
	gchar* line = NULL;
	GeeHashMap* _tmp44_;
	GamesScoresCategory* _tmp45_;
	GeeArrayList* _tmp46_;
#line 281 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 281 "../games/scores/context.vala"
	g_return_if_fail (file_info != NULL);
#line 283 "../games/scores/context.vala"
	_tmp0_ = g_file_info_get_name (file_info);
#line 283 "../games/scores/context.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 283 "../games/scores/context.vala"
	category_key = _tmp1_;
#line 284 "../games/scores/context.vala"
	_tmp2_ = self->priv->category_request;
#line 284 "../games/scores/context.vala"
	_tmp2__target = self->priv->category_request_target;
#line 284 "../games/scores/context.vala"
	_tmp3_ = category_key;
#line 284 "../games/scores/context.vala"
	_tmp4_ = _tmp2_ (_tmp3_, _tmp2__target);
#line 284 "../games/scores/context.vala"
	category = _tmp4_;
#line 285 "../games/scores/context.vala"
	_tmp5_ = category;
#line 285 "../games/scores/context.vala"
	if (_tmp5_ == NULL) {
#line 286 "../games/scores/context.vala"
		_g_object_unref0 (category);
#line 286 "../games/scores/context.vala"
		_g_free0 (category_key);
#line 286 "../games/scores/context.vala"
		return;
#line 2685 "context.c"
	}
#line 288 "../games/scores/context.vala"
	_tmp6_ = self->priv->user_score_dir;
#line 288 "../games/scores/context.vala"
	_tmp7_ = category_key;
#line 288 "../games/scores/context.vala"
	_tmp8_ = g_build_filename (_tmp6_, _tmp7_, NULL);
#line 288 "../games/scores/context.vala"
	filename = _tmp8_;
#line 289 "../games/scores/context.vala"
	_tmp9_ = gee_array_list_new (GAMES_SCORES_TYPE_SCORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 289 "../games/scores/context.vala"
	scores_of_single_category = _tmp9_;
#line 290 "../games/scores/context.vala"
	_tmp10_ = filename;
#line 290 "../games/scores/context.vala"
	_tmp11_ = g_fopen (_tmp10_, "r");
#line 290 "../games/scores/context.vala"
	stream = _tmp11_;
#line 292 "../games/scores/context.vala"
	while (TRUE) {
#line 2707 "context.c"
		FILE* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar** tokens = NULL;
		const gchar* _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint tokens_length1;
		gint _tokens_size_;
		gchar* user = NULL;
		gchar** _tmp18_;
		gint _tmp18__length1;
		glong score_value = 0L;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		gint64 time = 0LL;
		gchar** _tmp23_;
		gint _tmp23__length1;
		const gchar* _tmp24_;
		gboolean _tmp25_ = FALSE;
		gboolean _tmp26_ = FALSE;
		gchar** _tmp34_;
		gint _tmp34__length1;
		GeeArrayList* _tmp40_;
		const gchar* _tmp41_;
		GamesScoresScore* _tmp42_;
		GamesScoresScore* _tmp43_;
#line 292 "../games/scores/context.vala"
		_tmp12_ = stream;
#line 292 "../games/scores/context.vala"
		_tmp13_ = g_file_stream_read_line (_tmp12_);
#line 292 "../games/scores/context.vala"
		_g_free0 (line);
#line 292 "../games/scores/context.vala"
		line = _tmp13_;
#line 292 "../games/scores/context.vala"
		_tmp14_ = line;
#line 292 "../games/scores/context.vala"
		if (!(_tmp14_ != NULL)) {
#line 292 "../games/scores/context.vala"
			break;
#line 2750 "context.c"
		}
#line 294 "../games/scores/context.vala"
		_tmp15_ = line;
#line 294 "../games/scores/context.vala"
		_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, " ", 3);
#line 294 "../games/scores/context.vala"
		tokens = _tmp17_;
#line 294 "../games/scores/context.vala"
		tokens_length1 = _vala_array_length (_tmp16_);
#line 294 "../games/scores/context.vala"
		_tokens_size_ = tokens_length1;
#line 295 "../games/scores/context.vala"
		user = NULL;
#line 297 "../games/scores/context.vala"
		_tmp18_ = tokens;
#line 297 "../games/scores/context.vala"
		_tmp18__length1 = tokens_length1;
#line 297 "../games/scores/context.vala"
		if (_tmp18__length1 < 2) {
#line 2770 "context.c"
			const gchar* _tmp19_;
			const gchar* _tmp20_;
#line 299 "../games/scores/context.vala"
			_tmp19_ = line;
#line 299 "../games/scores/context.vala"
			_tmp20_ = filename;
#line 299 "../games/scores/context.vala"
			g_warning ("context.vala:299: Failed to read malformed score %s in %s.", _tmp19_, _tmp20_);
#line 300 "../games/scores/context.vala"
			_g_free0 (user);
#line 300 "../games/scores/context.vala"
			tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 300 "../games/scores/context.vala"
			continue;
#line 2785 "context.c"
		}
#line 303 "../games/scores/context.vala"
		_tmp21_ = tokens;
#line 303 "../games/scores/context.vala"
		_tmp21__length1 = tokens_length1;
#line 303 "../games/scores/context.vala"
		_tmp22_ = _tmp21_[0];
#line 303 "../games/scores/context.vala"
		score_value = long_parse (_tmp22_, (guint) 0);
#line 304 "../games/scores/context.vala"
		_tmp23_ = tokens;
#line 304 "../games/scores/context.vala"
		_tmp23__length1 = tokens_length1;
#line 304 "../games/scores/context.vala"
		_tmp24_ = _tmp23_[1];
#line 304 "../games/scores/context.vala"
		time = int64_parse (_tmp24_, (guint) 0);
#line 306 "../games/scores/context.vala"
		if (score_value == ((glong) 0)) {
#line 2805 "context.c"
			gchar** _tmp27_;
			gint _tmp27__length1;
			const gchar* _tmp28_;
#line 306 "../games/scores/context.vala"
			_tmp27_ = tokens;
#line 306 "../games/scores/context.vala"
			_tmp27__length1 = tokens_length1;
#line 306 "../games/scores/context.vala"
			_tmp28_ = _tmp27_[0];
#line 306 "../games/scores/context.vala"
			_tmp26_ = g_strcmp0 (_tmp28_, "0") != 0;
#line 2817 "context.c"
		} else {
#line 306 "../games/scores/context.vala"
			_tmp26_ = FALSE;
#line 2821 "context.c"
		}
#line 306 "../games/scores/context.vala"
		if (_tmp26_) {
#line 306 "../games/scores/context.vala"
			_tmp25_ = TRUE;
#line 2827 "context.c"
		} else {
			gboolean _tmp29_ = FALSE;
#line 307 "../games/scores/context.vala"
			if (time == ((gint64) 0)) {
#line 2832 "context.c"
				gchar** _tmp30_;
				gint _tmp30__length1;
				const gchar* _tmp31_;
#line 307 "../games/scores/context.vala"
				_tmp30_ = tokens;
#line 307 "../games/scores/context.vala"
				_tmp30__length1 = tokens_length1;
#line 307 "../games/scores/context.vala"
				_tmp31_ = _tmp30_[1];
#line 307 "../games/scores/context.vala"
				_tmp29_ = g_strcmp0 (_tmp31_, "0") != 0;
#line 2844 "context.c"
			} else {
#line 307 "../games/scores/context.vala"
				_tmp29_ = FALSE;
#line 2848 "context.c"
			}
#line 307 "../games/scores/context.vala"
			_tmp25_ = _tmp29_;
#line 2852 "context.c"
		}
#line 306 "../games/scores/context.vala"
		if (_tmp25_) {
#line 2856 "context.c"
			const gchar* _tmp32_;
			const gchar* _tmp33_;
#line 309 "../games/scores/context.vala"
			_tmp32_ = line;
#line 309 "../games/scores/context.vala"
			_tmp33_ = filename;
#line 309 "../games/scores/context.vala"
			g_warning ("context.vala:309: Failed to read malformed score %s in %s.", _tmp32_, _tmp33_);
#line 310 "../games/scores/context.vala"
			_g_free0 (user);
#line 310 "../games/scores/context.vala"
			tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 310 "../games/scores/context.vala"
			continue;
#line 2871 "context.c"
		}
#line 313 "../games/scores/context.vala"
		_tmp34_ = tokens;
#line 313 "../games/scores/context.vala"
		_tmp34__length1 = tokens_length1;
#line 313 "../games/scores/context.vala"
		if (_tmp34__length1 == 3) {
#line 2879 "context.c"
			gchar** _tmp35_;
			gint _tmp35__length1;
			const gchar* _tmp36_;
			gchar* _tmp37_;
#line 314 "../games/scores/context.vala"
			_tmp35_ = tokens;
#line 314 "../games/scores/context.vala"
			_tmp35__length1 = tokens_length1;
#line 314 "../games/scores/context.vala"
			_tmp36_ = _tmp35_[2];
#line 314 "../games/scores/context.vala"
			_tmp37_ = g_strdup (_tmp36_);
#line 314 "../games/scores/context.vala"
			_g_free0 (user);
#line 314 "../games/scores/context.vala"
			user = _tmp37_;
#line 2896 "context.c"
		} else {
			const gchar* _tmp38_;
			const gchar* _tmp39_;
#line 316 "../games/scores/context.vala"
			_tmp38_ = line;
#line 316 "../games/scores/context.vala"
			_tmp39_ = filename;
#line 316 "../games/scores/context.vala"
			g_debug ("context.vala:316: Assuming current username for old score %s in %s.", _tmp38_, _tmp39_);
#line 2906 "context.c"
		}
#line 318 "../games/scores/context.vala"
		_tmp40_ = scores_of_single_category;
#line 318 "../games/scores/context.vala"
		_tmp41_ = user;
#line 318 "../games/scores/context.vala"
		_tmp42_ = games_scores_score_new (score_value, time, _tmp41_);
#line 318 "../games/scores/context.vala"
		_tmp43_ = _tmp42_;
#line 318 "../games/scores/context.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, _tmp43_);
#line 318 "../games/scores/context.vala"
		_g_object_unref0 (_tmp43_);
#line 292 "../games/scores/context.vala"
		_g_free0 (user);
#line 292 "../games/scores/context.vala"
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 2924 "context.c"
	}
#line 321 "../games/scores/context.vala"
	_tmp44_ = self->priv->scores_per_category;
#line 321 "../games/scores/context.vala"
	_tmp45_ = category;
#line 321 "../games/scores/context.vala"
	_tmp46_ = scores_of_single_category;
#line 321 "../games/scores/context.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp44_, _tmp45_, (GeeList*) _tmp46_);
#line 281 "../games/scores/context.vala"
	_g_free0 (line);
#line 281 "../games/scores/context.vala"
	_fclose0 (stream);
#line 281 "../games/scores/context.vala"
	_g_object_unref0 (scores_of_single_category);
#line 281 "../games/scores/context.vala"
	_g_free0 (filename);
#line 281 "../games/scores/context.vala"
	_g_object_unref0 (category);
#line 281 "../games/scores/context.vala"
	_g_free0 (category_key);
#line 2946 "context.c"
}

static void
games_scores_context_load_scores_from_files (GamesScoresContext* self,
                                             GError** error)
{
	gboolean _tmp0_ = FALSE;
	GtkWindow* _tmp1_;
	GFile* directory = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFileEnumerator* enumerator = NULL;
	GFile* _tmp8_;
	GFileEnumerator* _tmp9_;
	GFileInfo* file_info = NULL;
	GError* _inner_error0_ = NULL;
#line 324 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 324 "../games/scores/context.vala"
	_vala_return_if_fail (!self->priv->scores_loaded, "!scores_loaded");
#line 327 "../games/scores/context.vala"
	self->priv->scores_loaded = TRUE;
#line 329 "../games/scores/context.vala"
	_tmp1_ = self->priv->_game_window;
#line 329 "../games/scores/context.vala"
	if (_tmp1_ != NULL) {
#line 2974 "context.c"
		GtkWindow* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 329 "../games/scores/context.vala"
		_tmp2_ = self->priv->_game_window;
#line 329 "../games/scores/context.vala"
		_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 329 "../games/scores/context.vala"
		_tmp4_ = _tmp3_;
#line 329 "../games/scores/context.vala"
		_tmp0_ = _tmp4_;
#line 2986 "context.c"
	} else {
#line 329 "../games/scores/context.vala"
		_tmp0_ = FALSE;
#line 2990 "context.c"
	}
#line 329 "../games/scores/context.vala"
	if (_tmp0_) {
#line 331 "../games/scores/context.vala"
		g_error ("context.vala:331: %s", "The application window associated with the GamesScoresContext " "was set visible before loading scores. The Context performs " "synchronous I/O in the default main context to load scores, so " "so you should do this before showing your main window.");
#line 2996 "context.c"
	}
#line 337 "../games/scores/context.vala"
	_tmp5_ = self->priv->user_score_dir;
#line 337 "../games/scores/context.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 337 "../games/scores/context.vala"
	directory = _tmp6_;
#line 338 "../games/scores/context.vala"
	_tmp7_ = directory;
#line 338 "../games/scores/context.vala"
	if (!g_file_query_exists (_tmp7_, NULL)) {
#line 339 "../games/scores/context.vala"
		_g_object_unref0 (directory);
#line 339 "../games/scores/context.vala"
		return;
#line 3012 "context.c"
	}
#line 341 "../games/scores/context.vala"
	_tmp8_ = directory;
#line 341 "../games/scores/context.vala"
	_tmp9_ = g_file_enumerate_children (_tmp8_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error0_);
#line 341 "../games/scores/context.vala"
	enumerator = _tmp9_;
#line 341 "../games/scores/context.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 341 "../games/scores/context.vala"
		g_propagate_error (error, _inner_error0_);
#line 341 "../games/scores/context.vala"
		_g_object_unref0 (directory);
#line 341 "../games/scores/context.vala"
		return;
#line 3028 "context.c"
	}
#line 343 "../games/scores/context.vala"
	while (TRUE) {
#line 3032 "context.c"
		GFileInfo* _tmp10_ = NULL;
		GFileEnumerator* _tmp11_;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		GFileInfo* _tmp14_;
		GFileInfo* _tmp15_;
#line 343 "../games/scores/context.vala"
		_tmp11_ = enumerator;
#line 343 "../games/scores/context.vala"
		_tmp12_ = g_file_enumerator_next_file (_tmp11_, NULL, &_inner_error0_);
#line 343 "../games/scores/context.vala"
		_tmp10_ = _tmp12_;
#line 343 "../games/scores/context.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 343 "../games/scores/context.vala"
			g_propagate_error (error, _inner_error0_);
#line 343 "../games/scores/context.vala"
			_g_object_unref0 (file_info);
#line 343 "../games/scores/context.vala"
			_g_object_unref0 (enumerator);
#line 343 "../games/scores/context.vala"
			_g_object_unref0 (directory);
#line 343 "../games/scores/context.vala"
			return;
#line 3057 "context.c"
		}
#line 343 "../games/scores/context.vala"
		_tmp13_ = _tmp10_;
#line 343 "../games/scores/context.vala"
		_tmp10_ = NULL;
#line 343 "../games/scores/context.vala"
		_g_object_unref0 (file_info);
#line 343 "../games/scores/context.vala"
		file_info = _tmp13_;
#line 343 "../games/scores/context.vala"
		_tmp14_ = file_info;
#line 343 "../games/scores/context.vala"
		if (!(_tmp14_ != NULL)) {
#line 343 "../games/scores/context.vala"
			_g_object_unref0 (_tmp10_);
#line 343 "../games/scores/context.vala"
			break;
#line 3075 "context.c"
		}
#line 345 "../games/scores/context.vala"
		_tmp15_ = file_info;
#line 345 "../games/scores/context.vala"
		games_scores_context_load_scores_from_file (self, _tmp15_, &_inner_error0_);
#line 345 "../games/scores/context.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "../games/scores/context.vala"
			g_propagate_error (error, _inner_error0_);
#line 345 "../games/scores/context.vala"
			_g_object_unref0 (_tmp10_);
#line 345 "../games/scores/context.vala"
			_g_object_unref0 (file_info);
#line 345 "../games/scores/context.vala"
			_g_object_unref0 (enumerator);
#line 345 "../games/scores/context.vala"
			_g_object_unref0 (directory);
#line 345 "../games/scores/context.vala"
			return;
#line 3095 "context.c"
		}
#line 343 "../games/scores/context.vala"
		_g_object_unref0 (_tmp10_);
#line 3099 "context.c"
	}
#line 324 "../games/scores/context.vala"
	_g_object_unref0 (file_info);
#line 324 "../games/scores/context.vala"
	_g_object_unref0 (enumerator);
#line 324 "../games/scores/context.vala"
	_g_object_unref0 (directory);
#line 3107 "context.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 351 "../games/scores/context.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 351 "../games/scores/context.vala"
	return _data3_;
#line 3117 "context.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 351 "../games/scores/context.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3127 "context.c"
		GamesScoresContext* self;
#line 351 "../games/scores/context.vala"
		self = _data3_->self;
#line 351 "../games/scores/context.vala"
		_g_object_unref0 (self);
#line 351 "../games/scores/context.vala"
		g_slice_free (Block3Data, _data3_);
#line 3135 "context.c"
	}
}

static GamesScoresCategory*
__lambda13_ (Block3Data* _data3_,
             const gchar* key)
{
	GamesScoresContext* self;
	GamesScoresCategory* _tmp0_;
	GamesScoresCategory* result;
#line 354 "../games/scores/context.vala"
	self = _data3_->self;
#line 354 "../games/scores/context.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 354 "../games/scores/context.vala"
	_tmp0_ = _data3_->category_request (key, _data3_->category_request_target);
#line 354 "../games/scores/context.vala"
	result = _tmp0_;
#line 354 "../games/scores/context.vala"
	return result;
#line 3156 "context.c"
}

static GamesScoresCategory*
___lambda13__games_scores_context_category_request_func (const gchar* category_key,
                                                         gpointer self)
{
	GamesScoresCategory* result;
	result = __lambda13_ (self, category_key);
#line 354 "../games/scores/context.vala"
	return result;
#line 3167 "context.c"
}

void
games_scores_context_load_scores (GamesScoresContext* self,
                                  GamesScoresContextCategoryRequestFunc category_request,
                                  gpointer category_request_target,
                                  GError** error)
{
	GamesScoresContextCategoryRequestFunc _tmp0_;
	gpointer _tmp0__target;
	Block3Data* _data3_;
	GError* _inner_error0_ = NULL;
#line 351 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 351 "../games/scores/context.vala"
	_tmp0_ = self->priv->category_request;
#line 351 "../games/scores/context.vala"
	_tmp0__target = self->priv->category_request_target;
#line 351 "../games/scores/context.vala"
	_vala_return_if_fail (_tmp0_ == NULL, "this.category_request == null");
#line 351 "../games/scores/context.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 351 "../games/scores/context.vala"
	_data3_->_ref_count_ = 1;
#line 351 "../games/scores/context.vala"
	_data3_->self = g_object_ref (self);
#line 351 "../games/scores/context.vala"
	_data3_->category_request = category_request;
#line 351 "../games/scores/context.vala"
	_data3_->category_request_target = category_request_target;
#line 354 "../games/scores/context.vala"
	(self->priv->category_request_target_destroy_notify == NULL) ? NULL : (self->priv->category_request_target_destroy_notify (self->priv->category_request_target), NULL);
#line 354 "../games/scores/context.vala"
	self->priv->category_request = NULL;
#line 354 "../games/scores/context.vala"
	self->priv->category_request_target = NULL;
#line 354 "../games/scores/context.vala"
	self->priv->category_request_target_destroy_notify = NULL;
#line 354 "../games/scores/context.vala"
	self->priv->category_request = ___lambda13__games_scores_context_category_request_func;
#line 354 "../games/scores/context.vala"
	self->priv->category_request_target = block3_data_ref (_data3_);
#line 354 "../games/scores/context.vala"
	self->priv->category_request_target_destroy_notify = block3_data_unref;
#line 355 "../games/scores/context.vala"
	games_scores_context_load_scores_from_files (self, &_inner_error0_);
#line 355 "../games/scores/context.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "../games/scores/context.vala"
		g_propagate_error (error, _inner_error0_);
#line 355 "../games/scores/context.vala"
		block3_data_unref (_data3_);
#line 355 "../games/scores/context.vala"
		_data3_ = NULL;
#line 355 "../games/scores/context.vala"
		return;
#line 3224 "context.c"
	}
#line 351 "../games/scores/context.vala"
	block3_data_unref (_data3_);
#line 351 "../games/scores/context.vala"
	_data3_ = NULL;
#line 3230 "context.c"
}

static void
__lambda11_ (GamesScoresContext* self,
             GtkDialog* dialog,
             gint response)
{
#line 362 "../games/scores/context.vala"
	g_return_if_fail (dialog != NULL);
#line 363 "../games/scores/context.vala"
	gtk_window_destroy ((GtkWindow*) dialog);
#line 3242 "context.c"
}

static void
___lambda11__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 362 "../games/scores/context.vala"
	__lambda11_ ((GamesScoresContext*) self, _sender, response_id);
#line 3252 "context.c"
}

void
games_scores_context_run_dialog_internal (GamesScoresContext* self,
                                          GamesScoresScore* new_high_score)
{
	GtkWindow* _tmp0_;
	GamesScoresDialog* dialog = NULL;
	const gchar* _tmp1_;
	GamesScoresStyle _tmp2_;
	GamesScoresCategory* _tmp3_;
	GtkWindow* _tmp4_;
	const gchar* _tmp5_;
	GamesScoresDialog* _tmp6_;
#line 358 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 358 "../games/scores/context.vala"
	_tmp0_ = self->priv->_game_window;
#line 358 "../games/scores/context.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "game_window != null");
#line 361 "../games/scores/context.vala"
	_tmp1_ = self->priv->_category_type;
#line 361 "../games/scores/context.vala"
	_tmp2_ = self->priv->_style;
#line 361 "../games/scores/context.vala"
	_tmp3_ = self->priv->current_category;
#line 361 "../games/scores/context.vala"
	_tmp4_ = self->priv->_game_window;
#line 361 "../games/scores/context.vala"
	_tmp5_ = self->priv->_icon_name;
#line 361 "../games/scores/context.vala"
	_tmp6_ = games_scores_dialog_new (self, _tmp1_, _tmp2_, new_high_score, _tmp3_, _tmp4_, _tmp5_);
#line 361 "../games/scores/context.vala"
	g_object_ref_sink (_tmp6_);
#line 361 "../games/scores/context.vala"
	dialog = _tmp6_;
#line 362 "../games/scores/context.vala"
	g_signal_connect_object ((GtkDialog*) dialog, "response", (GCallback) ___lambda11__gtk_dialog_response, self, 0);
#line 365 "../games/scores/context.vala"
	gtk_window_present ((GtkWindow*) dialog);
#line 358 "../games/scores/context.vala"
	_g_object_unref0 (dialog);
#line 3295 "context.c"
}

void
games_scores_context_run_dialog (GamesScoresContext* self)
{
#line 368 "../games/scores/context.vala"
	g_return_if_fail (self != NULL);
#line 370 "../games/scores/context.vala"
	games_scores_context_run_dialog_internal (self, NULL);
#line 3305 "context.c"
}

gboolean
games_scores_context_has_scores (GamesScoresContext* self)
{
	gboolean result;
#line 373 "../games/scores/context.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3314 "context.c"
	{
		GeeIterator* _scores_it = NULL;
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 375 "../games/scores/context.vala"
		_tmp0_ = self->priv->scores_per_category;
#line 375 "../games/scores/context.vala"
		_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 375 "../games/scores/context.vala"
		_tmp2_ = _tmp1_;
#line 375 "../games/scores/context.vala"
		_tmp3_ = _tmp2_;
#line 375 "../games/scores/context.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 375 "../games/scores/context.vala"
		_tmp5_ = _tmp4_;
#line 375 "../games/scores/context.vala"
		_g_object_unref0 (_tmp3_);
#line 375 "../games/scores/context.vala"
		_scores_it = _tmp5_;
#line 375 "../games/scores/context.vala"
		while (TRUE) {
#line 3341 "context.c"
			GeeIterator* _tmp6_;
			GeeList* scores = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 375 "../games/scores/context.vala"
			_tmp6_ = _scores_it;
#line 375 "../games/scores/context.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 375 "../games/scores/context.vala"
				break;
#line 3355 "context.c"
			}
#line 375 "../games/scores/context.vala"
			_tmp7_ = _scores_it;
#line 375 "../games/scores/context.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 375 "../games/scores/context.vala"
			scores = (GeeList*) _tmp8_;
#line 377 "../games/scores/context.vala"
			_tmp9_ = scores;
#line 377 "../games/scores/context.vala"
			_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
#line 377 "../games/scores/context.vala"
			_tmp11_ = _tmp10_;
#line 377 "../games/scores/context.vala"
			if (_tmp11_ > 0) {
#line 378 "../games/scores/context.vala"
				result = TRUE;
#line 378 "../games/scores/context.vala"
				_g_object_unref0 (scores);
#line 378 "../games/scores/context.vala"
				_g_object_unref0 (_scores_it);
#line 378 "../games/scores/context.vala"
				return result;
#line 3379 "context.c"
			}
#line 375 "../games/scores/context.vala"
			_g_object_unref0 (scores);
#line 3383 "context.c"
		}
#line 375 "../games/scores/context.vala"
		_g_object_unref0 (_scores_it);
#line 3387 "context.c"
	}
#line 380 "../games/scores/context.vala"
	result = FALSE;
#line 380 "../games/scores/context.vala"
	return result;
#line 3393 "context.c"
}

static void
games_scores_context_base_init (GamesScoresContextClass * klass)
{
#line 67 "../games/scores/context.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 68 "../games/scores/context.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 3403 "context.c"
}

static void
games_scores_context_class_init (GamesScoresContextClass * klass,
                                 gpointer klass_data)
{
#line 33 "../games/scores/context.vala"
	games_scores_context_parent_class = g_type_class_peek_parent (klass);
#line 33 "../games/scores/context.vala"
	g_type_class_adjust_private_offset (klass, &GamesScoresContext_private_offset);
#line 33 "../games/scores/context.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) games_scores_context_real_constructed;
#line 33 "../games/scores/context.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_scores_context_get_property;
#line 33 "../games/scores/context.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_scores_context_set_property;
#line 33 "../games/scores/context.vala"
	G_OBJECT_CLASS (klass)->finalize = games_scores_context_finalize;
#line 33 "../games/scores/context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SCORES_CONTEXT_APP_NAME_PROPERTY, games_scores_context_properties[GAMES_SCORES_CONTEXT_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../games/scores/context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SCORES_CONTEXT_CATEGORY_TYPE_PROPERTY, games_scores_context_properties[GAMES_SCORES_CONTEXT_CATEGORY_TYPE_PROPERTY] = g_param_spec_string ("category-type", "category-type", "category-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../games/scores/context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SCORES_CONTEXT_GAME_WINDOW_PROPERTY, games_scores_context_properties[GAMES_SCORES_CONTEXT_GAME_WINDOW_PROPERTY] = g_param_spec_object ("game-window", "game-window", "game-window", gtk_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../games/scores/context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SCORES_CONTEXT_STYLE_PROPERTY, games_scores_context_properties[GAMES_SCORES_CONTEXT_STYLE_PROPERTY] = g_param_spec_enum ("style", "style", "style", GAMES_SCORES_TYPE_STYLE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../games/scores/context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SCORES_CONTEXT_IMPORTER_PROPERTY, games_scores_context_properties[GAMES_SCORES_CONTEXT_IMPORTER_PROPERTY] = g_param_spec_object ("importer", "importer", "importer", GAMES_SCORES_TYPE_IMPORTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../games/scores/context.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_SCORES_CONTEXT_ICON_NAME_PROPERTY, games_scores_context_properties[GAMES_SCORES_CONTEXT_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 44 "../games/scores/context.vala"
	games_scores_context_category_hash = __games_scores_context_category_hash_lambda4__gee_hash_data_func;
#line 44 "../games/scores/context.vala"
	games_scores_context_category_hash_target = NULL;
#line 44 "../games/scores/context.vala"
	games_scores_context_category_hash_target_destroy_notify = NULL;
#line 47 "../games/scores/context.vala"
	games_scores_context_category_equal = __games_scores_context_category_equal_lambda5__gee_equal_data_func;
#line 47 "../games/scores/context.vala"
	games_scores_context_category_equal_target = NULL;
#line 47 "../games/scores/context.vala"
	games_scores_context_category_equal_target_destroy_notify = NULL;
#line 3446 "context.c"
}

static void
games_scores_context_instance_init (GamesScoresContext * self,
                                    gpointer klass)
{
	GeeHashDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeEqualDataFunc _tmp1_;
	gpointer _tmp1__target;
	GDestroyNotify _tmp1__target_destroy_notify;
	GeeHashMap* _tmp2_;
#line 33 "../games/scores/context.vala"
	self->priv = games_scores_context_get_instance_private (self);
#line 42 "../games/scores/context.vala"
	self->priv->current_category = NULL;
#line 50 "../games/scores/context.vala"
	_tmp0_ = games_scores_context_category_hash;
#line 50 "../games/scores/context.vala"
	_tmp0__target = games_scores_context_category_hash_target;
#line 50 "../games/scores/context.vala"
	_tmp0__target_destroy_notify = games_scores_context_category_hash_target_destroy_notify;
#line 50 "../games/scores/context.vala"
	games_scores_context_category_hash = NULL;
#line 50 "../games/scores/context.vala"
	games_scores_context_category_hash_target = NULL;
#line 50 "../games/scores/context.vala"
	games_scores_context_category_hash_target_destroy_notify = NULL;
#line 50 "../games/scores/context.vala"
	_tmp1_ = games_scores_context_category_equal;
#line 50 "../games/scores/context.vala"
	_tmp1__target = games_scores_context_category_equal_target;
#line 50 "../games/scores/context.vala"
	_tmp1__target_destroy_notify = games_scores_context_category_equal_target_destroy_notify;
#line 50 "../games/scores/context.vala"
	games_scores_context_category_equal = NULL;
#line 50 "../games/scores/context.vala"
	games_scores_context_category_equal_target = NULL;
#line 50 "../games/scores/context.vala"
	games_scores_context_category_equal_target_destroy_notify = NULL;
#line 50 "../games/scores/context.vala"
	_tmp2_ = gee_hash_map_new (GAMES_SCORES_TYPE_CATEGORY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify, NULL, NULL, NULL);
#line 50 "../games/scores/context.vala"
	self->priv->scores_per_category = _tmp2_;
#line 54 "../games/scores/context.vala"
	self->priv->scores_loaded = FALSE;
#line 63 "../games/scores/context.vala"
	self->priv->category_request = NULL;
#line 63 "../games/scores/context.vala"
	self->priv->category_request_target = NULL;
#line 63 "../games/scores/context.vala"
	self->priv->category_request_target_destroy_notify = NULL;
#line 3500 "context.c"
}

static void
games_scores_context_finalize (GObject * obj)
{
	GamesScoresContext * self;
#line 33 "../games/scores/context.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_SCORES_TYPE_CONTEXT, GamesScoresContext);
#line 35 "../games/scores/context.vala"
	_g_free0 (self->priv->_app_name);
#line 36 "../games/scores/context.vala"
	_g_free0 (self->priv->_category_type);
#line 37 "../games/scores/context.vala"
	_g_object_unref0 (self->priv->_game_window);
#line 39 "../games/scores/context.vala"
	_g_object_unref0 (self->priv->_importer);
#line 40 "../games/scores/context.vala"
	_g_free0 (self->priv->_icon_name);
#line 42 "../games/scores/context.vala"
	_g_object_unref0 (self->priv->current_category);
#line 50 "../games/scores/context.vala"
	_g_object_unref0 (self->priv->scores_per_category);
#line 53 "../games/scores/context.vala"
	_g_free0 (self->priv->user_score_dir);
#line 63 "../games/scores/context.vala"
	(self->priv->category_request_target_destroy_notify == NULL) ? NULL : (self->priv->category_request_target_destroy_notify (self->priv->category_request_target), NULL);
#line 63 "../games/scores/context.vala"
	self->priv->category_request = NULL;
#line 63 "../games/scores/context.vala"
	self->priv->category_request_target = NULL;
#line 63 "../games/scores/context.vala"
	self->priv->category_request_target_destroy_notify = NULL;
#line 33 "../games/scores/context.vala"
	G_OBJECT_CLASS (games_scores_context_parent_class)->finalize (obj);
#line 3535 "context.c"
}

static GType
games_scores_context_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesScoresContextClass), (GBaseInitFunc) games_scores_context_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_scores_context_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesScoresContext), 0, (GInstanceInitFunc) games_scores_context_instance_init, NULL };
	GType games_scores_context_type_id;
	games_scores_context_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesScoresContext", &g_define_type_info, 0);
	GamesScoresContext_private_offset = g_type_add_instance_private (games_scores_context_type_id, sizeof (GamesScoresContextPrivate));
	return games_scores_context_type_id;
}

GType
games_scores_context_get_type (void)
{
	static volatile gsize games_scores_context_type_id__once = 0;
	if (g_once_init_enter (&games_scores_context_type_id__once)) {
		GType games_scores_context_type_id;
		games_scores_context_type_id = games_scores_context_get_type_once ();
		g_once_init_leave (&games_scores_context_type_id__once, games_scores_context_type_id);
	}
	return games_scores_context_type_id__once;
}

static void
_vala_games_scores_context_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	GamesScoresContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_SCORES_TYPE_CONTEXT, GamesScoresContext);
#line 33 "../games/scores/context.vala"
	switch (property_id) {
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_APP_NAME_PROPERTY:
#line 33 "../games/scores/context.vala"
		g_value_set_string (value, games_scores_context_get_app_name (self));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_CATEGORY_TYPE_PROPERTY:
#line 33 "../games/scores/context.vala"
		g_value_set_string (value, games_scores_context_get_category_type (self));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_GAME_WINDOW_PROPERTY:
#line 33 "../games/scores/context.vala"
		g_value_set_object (value, games_scores_context_get_game_window (self));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_STYLE_PROPERTY:
#line 33 "../games/scores/context.vala"
		g_value_set_enum (value, games_scores_context_get_style (self));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_IMPORTER_PROPERTY:
#line 33 "../games/scores/context.vala"
		g_value_set_object (value, games_scores_context_get_importer (self));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_ICON_NAME_PROPERTY:
#line 33 "../games/scores/context.vala"
		g_value_set_string (value, games_scores_context_get_icon_name (self));
#line 33 "../games/scores/context.vala"
		break;
#line 3606 "context.c"
		default:
#line 33 "../games/scores/context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "../games/scores/context.vala"
		break;
#line 3612 "context.c"
	}
}

static void
_vala_games_scores_context_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	GamesScoresContext * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_SCORES_TYPE_CONTEXT, GamesScoresContext);
#line 33 "../games/scores/context.vala"
	switch (property_id) {
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_APP_NAME_PROPERTY:
#line 33 "../games/scores/context.vala"
		games_scores_context_set_app_name (self, g_value_get_string (value));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_CATEGORY_TYPE_PROPERTY:
#line 33 "../games/scores/context.vala"
		games_scores_context_set_category_type (self, g_value_get_string (value));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_GAME_WINDOW_PROPERTY:
#line 33 "../games/scores/context.vala"
		games_scores_context_set_game_window (self, g_value_get_object (value));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_STYLE_PROPERTY:
#line 33 "../games/scores/context.vala"
		games_scores_context_set_style (self, g_value_get_enum (value));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_IMPORTER_PROPERTY:
#line 33 "../games/scores/context.vala"
		games_scores_context_set_importer (self, g_value_get_object (value));
#line 33 "../games/scores/context.vala"
		break;
#line 33 "../games/scores/context.vala"
		case GAMES_SCORES_CONTEXT_ICON_NAME_PROPERTY:
#line 33 "../games/scores/context.vala"
		games_scores_context_set_icon_name (self, g_value_get_string (value));
#line 33 "../games/scores/context.vala"
		break;
#line 3662 "context.c"
		default:
#line 33 "../games/scores/context.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 33 "../games/scores/context.vala"
		break;
#line 3668 "context.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

