/* dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2014 Nikhar Agrawal
 *
 * This file is part of libgnome-games-support.
 *
 * libgnome-games-support is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libgnome-games-support is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libgnome-games-support.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libgnome-games-support.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GAMES_SCORES_TYPE_DIALOG (games_scores_dialog_get_type ())
#define GAMES_SCORES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialog))
#define GAMES_SCORES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialogClass))
#define GAMES_SCORES_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_SCORES_TYPE_DIALOG))
#define GAMES_SCORES_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_SCORES_TYPE_DIALOG))
#define GAMES_SCORES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialogClass))

typedef struct _GamesScoresDialog GamesScoresDialog;
typedef struct _GamesScoresDialogClass GamesScoresDialogClass;
typedef struct _GamesScoresDialogPrivate GamesScoresDialogPrivate;
enum  {
	GAMES_SCORES_DIALOG_0_PROPERTY,
	GAMES_SCORES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* games_scores_dialog_properties[GAMES_SCORES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

struct _GamesScoresDialog {
	GtkDialog parent_instance;
	GamesScoresDialogPrivate * priv;
};

struct _GamesScoresDialogClass {
	GtkDialogClass parent_class;
};

struct _GamesScoresDialogPrivate {
	GamesScoresContext* context;
	GamesScoresCategory* active_category;
	gint rows_to_display;
	GtkComboBoxText* combo;
	GtkLabel* category_label;
	GtkHeaderBar* headerbar;
	GtkGrid* grid;
	GtkLabel* window_title;
	GtkLabel* window_subtitle;
	GamesScoresStyle scores_style;
	GamesScoresScore* new_high_score;
	GamesScoresCategory* scores_active_category;
};

struct _Block4Data {
	int _ref_count_;
	GamesScoresDialog* self;
	GamesScoresScore* score;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GtkEntry* entry;
};

static gint GamesScoresDialog_private_offset;
static gpointer games_scores_dialog_parent_class = NULL;

VALA_EXTERN GType games_scores_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesScoresDialog* games_scores_dialog_new (GamesScoresContext* context,
                                            const gchar* category_type,
                                            GamesScoresStyle style,
                                            GamesScoresScore* new_high_score,
                                            GamesScoresCategory* current_cat,
                                            GtkWindow* window,
                                            const gchar* icon_name);
VALA_EXTERN GamesScoresDialog* games_scores_dialog_construct (GType object_type,
                                                  GamesScoresContext* context,
                                                  const gchar* category_type,
                                                  GamesScoresStyle style,
                                                  GamesScoresScore* new_high_score,
                                                  GamesScoresCategory* current_cat,
                                                  GtkWindow* window,
                                                  const gchar* icon_name);
VALA_EXTERN GList* games_scores_context_get_categories (GamesScoresContext* self);
static void games_scores_dialog_load_scores (GamesScoresDialog* self);
static void _games_scores_dialog_load_scores_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self);
static void games_scores_dialog_fill_grid_with_labels (GamesScoresDialog* self);
static void games_scores_dialog_load_categories (GamesScoresDialog* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void __lambda10_ (GamesScoresDialog* self,
                  GamesScoresCategory* x);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void games_scores_dialog_display_single_score (GamesScoresDialog* self,
                                               GamesScoresScore* score,
                                               gint row_count,
                                               guint no_scores);
static void games_scores_dialog_make_remaining_labels_empty (GamesScoresDialog* self,
                                                      gint row_count);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda9_ (Block5Data* _data5_);
VALA_EXTERN void games_scores_context_update_score_name (GamesScoresContext* self,
                                             GamesScoresScore* old_score,
                                             GamesScoresCategory* category,
                                             const gchar* new_name);
static void ____lambda9__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void games_scores_dialog_finalize (GObject * obj);
static GType games_scores_dialog_get_type_once (void);

static inline gpointer
games_scores_dialog_get_instance_private (GamesScoresDialog* self)
{
	return G_STRUCT_MEMBER_P (self, GamesScoresDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../games/scores/dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "dialog.c"
}

static void
_games_scores_dialog_load_scores_gtk_combo_box_changed (GtkComboBox* _sender,
                                                        gpointer self)
{
#line 152 "../games/scores/dialog.vala"
	games_scores_dialog_load_scores ((GamesScoresDialog*) self);
#line 172 "dialog.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 41 "../games/scores/dialog.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 180 "dialog.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 41 "../games/scores/dialog.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 188 "dialog.c"
}

GamesScoresDialog*
games_scores_dialog_construct (GType object_type,
                               GamesScoresContext* context,
                               const gchar* category_type,
                               GamesScoresStyle style,
                               GamesScoresScore* new_high_score,
                               GamesScoresCategory* current_cat,
                               GtkWindow* window,
                               const gchar* icon_name)
{
	GamesScoresDialog * self = NULL;
	GamesScoresContext* _tmp0_;
	GamesScoresScore* _tmp1_;
	GamesScoresCategory* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkBox* title_widget = NULL;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	GtkLabel* _tmp18_;
	GtkBox* _tmp19_;
	GtkLabel* _tmp20_;
	GtkHeaderBar* _tmp21_;
	GtkHeaderBar* _tmp22_;
	GtkHeaderBar* _tmp23_;
	GtkBox* _tmp24_;
	GtkHeaderBar* _tmp25_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp30_;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	gboolean _tmp33_ = FALSE;
	GtkBox* _tmp60_;
	GtkBox* catbar = NULL;
	GtkBox* _tmp61_;
	GtkBox* _tmp62_;
	GtkBox* _tmp63_;
	GtkBox* _tmp64_;
	GtkBox* _tmp65_;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	GtkSeparator* hdiv = NULL;
	GtkSeparator* _tmp68_;
	GtkBox* _tmp69_;
	GtkSeparator* _tmp70_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp71_;
	GtkLabel* _tmp72_;
	GtkLabel* _tmp73_;
	GtkBox* _tmp74_;
	GtkLabel* _tmp75_;
	GList* categories = NULL;
	GList* _tmp76_;
	gboolean _tmp77_ = FALSE;
	GtkGrid* _tmp97_;
	GtkBox* _tmp98_;
	GtkGrid* _tmp99_;
	GtkGrid* _tmp100_;
	GtkGrid* _tmp101_;
	GtkGrid* _tmp102_;
	GtkGrid* _tmp103_;
	GtkGrid* _tmp104_;
	GtkGrid* _tmp105_;
	gchar* string_rank = NULL;
	gchar* _tmp106_;
	GtkLabel* label_column_1 = NULL;
	const gchar* _tmp107_;
	gchar* _tmp108_;
	gchar* _tmp109_;
	gchar* _tmp110_;
	gchar* _tmp111_;
	GtkLabel* _tmp112_;
	GtkLabel* _tmp113_;
	GtkLabel* _tmp114_;
	GtkGrid* _tmp115_;
	GtkLabel* _tmp116_;
	gchar* score_or_time = NULL;
	gchar* _tmp117_;
	gboolean _tmp118_ = FALSE;
	GtkLabel* label_column_2 = NULL;
	const gchar* _tmp121_;
	gchar* _tmp122_;
	gchar* _tmp123_;
	gchar* _tmp124_;
	gchar* _tmp125_;
	GtkLabel* _tmp126_;
	GtkLabel* _tmp127_;
	GtkLabel* _tmp128_;
	GtkGrid* _tmp129_;
	GtkLabel* _tmp130_;
	gchar* string_player = NULL;
	gchar* _tmp131_;
	GtkLabel* label_column_3 = NULL;
	const gchar* _tmp132_;
	gchar* _tmp133_;
	gchar* _tmp134_;
	gchar* _tmp135_;
	gchar* _tmp136_;
	GtkLabel* _tmp137_;
	GtkLabel* _tmp138_;
	GtkLabel* _tmp139_;
	GtkGrid* _tmp140_;
	GtkLabel* _tmp141_;
	GtkGrid* _tmp142_;
#line 41 "../games/scores/dialog.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 41 "../games/scores/dialog.vala"
	g_return_val_if_fail (category_type != NULL, NULL);
#line 41 "../games/scores/dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 41 "../games/scores/dialog.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 43 "../games/scores/dialog.vala"
	self = (GamesScoresDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 45 "../games/scores/dialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 47 "../games/scores/dialog.vala"
	_tmp0_ = _g_object_ref0 (context);
#line 47 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->context);
#line 47 "../games/scores/dialog.vala"
	self->priv->context = _tmp0_;
#line 48 "../games/scores/dialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 49 "../games/scores/dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, window);
#line 50 "../games/scores/dialog.vala"
	_tmp1_ = _g_object_ref0 (new_high_score);
#line 50 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->new_high_score);
#line 50 "../games/scores/dialog.vala"
	self->priv->new_high_score = _tmp1_;
#line 52 "../games/scores/dialog.vala"
	self->priv->scores_style = style;
#line 53 "../games/scores/dialog.vala"
	_tmp2_ = _g_object_ref0 (current_cat);
#line 53 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->scores_active_category);
#line 53 "../games/scores/dialog.vala"
	self->priv->scores_active_category = _tmp2_;
#line 56 "../games/scores/dialog.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new (NULL);
#line 56 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp3_);
#line 56 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->window_title);
#line 56 "../games/scores/dialog.vala"
	self->priv->window_title = _tmp3_;
#line 57 "../games/scores/dialog.vala"
	_tmp4_ = self->priv->window_title;
#line 57 "../games/scores/dialog.vala"
	gtk_label_set_ellipsize (_tmp4_, PANGO_ELLIPSIZE_END);
#line 58 "../games/scores/dialog.vala"
	_tmp5_ = self->priv->window_title;
#line 58 "../games/scores/dialog.vala"
	gtk_label_set_wrap (_tmp5_, FALSE);
#line 59 "../games/scores/dialog.vala"
	_tmp6_ = self->priv->window_title;
#line 59 "../games/scores/dialog.vala"
	gtk_label_set_single_line_mode (_tmp6_, TRUE);
#line 60 "../games/scores/dialog.vala"
	_tmp7_ = self->priv->window_title;
#line 60 "../games/scores/dialog.vala"
	gtk_label_set_width_chars (_tmp7_, 5);
#line 61 "../games/scores/dialog.vala"
	_tmp8_ = self->priv->window_title;
#line 61 "../games/scores/dialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "title");
#line 63 "../games/scores/dialog.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 63 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp9_);
#line 63 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->window_subtitle);
#line 63 "../games/scores/dialog.vala"
	self->priv->window_subtitle = _tmp9_;
#line 64 "../games/scores/dialog.vala"
	_tmp10_ = self->priv->window_subtitle;
#line 64 "../games/scores/dialog.vala"
	gtk_label_set_ellipsize (_tmp10_, PANGO_ELLIPSIZE_END);
#line 65 "../games/scores/dialog.vala"
	_tmp11_ = self->priv->window_subtitle;
#line 65 "../games/scores/dialog.vala"
	gtk_label_set_wrap (_tmp11_, FALSE);
#line 66 "../games/scores/dialog.vala"
	_tmp12_ = self->priv->window_subtitle;
#line 66 "../games/scores/dialog.vala"
	gtk_label_set_single_line_mode (_tmp12_, TRUE);
#line 67 "../games/scores/dialog.vala"
	_tmp13_ = self->priv->window_subtitle;
#line 67 "../games/scores/dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 68 "../games/scores/dialog.vala"
	_tmp14_ = self->priv->window_subtitle;
#line 68 "../games/scores/dialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, "subtitle");
#line 70 "../games/scores/dialog.vala"
	_tmp15_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 70 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp15_);
#line 70 "../games/scores/dialog.vala"
	title_widget = _tmp15_;
#line 71 "../games/scores/dialog.vala"
	_tmp16_ = title_widget;
#line 71 "../games/scores/dialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
#line 72 "../games/scores/dialog.vala"
	_tmp17_ = title_widget;
#line 72 "../games/scores/dialog.vala"
	_tmp18_ = self->priv->window_title;
#line 72 "../games/scores/dialog.vala"
	gtk_box_append (_tmp17_, (GtkWidget*) _tmp18_);
#line 73 "../games/scores/dialog.vala"
	_tmp19_ = title_widget;
#line 73 "../games/scores/dialog.vala"
	_tmp20_ = self->priv->window_subtitle;
#line 73 "../games/scores/dialog.vala"
	gtk_box_append (_tmp19_, (GtkWidget*) _tmp20_);
#line 75 "../games/scores/dialog.vala"
	_tmp21_ = gtk_dialog_get_header_bar ((GtkDialog*) self);
#line 75 "../games/scores/dialog.vala"
	_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_header_bar_get_type (), GtkHeaderBar));
#line 75 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 75 "../games/scores/dialog.vala"
	self->priv->headerbar = _tmp22_;
#line 77 "../games/scores/dialog.vala"
	_tmp23_ = self->priv->headerbar;
#line 77 "../games/scores/dialog.vala"
	_tmp24_ = title_widget;
#line 77 "../games/scores/dialog.vala"
	gtk_header_bar_set_title_widget (_tmp23_, (GtkWidget*) _tmp24_);
#line 78 "../games/scores/dialog.vala"
	_tmp25_ = self->priv->headerbar;
#line 78 "../games/scores/dialog.vala"
	gtk_header_bar_set_show_title_buttons (_tmp25_, new_high_score == NULL);
#line 80 "../games/scores/dialog.vala"
	if (new_high_score != NULL) {
#line 440 "dialog.c"
		GtkLabel* _tmp26_;
#line 82 "../games/scores/dialog.vala"
		_tmp26_ = self->priv->window_title;
#line 82 "../games/scores/dialog.vala"
		gtk_label_set_label (_tmp26_, _ ("Congratulations!"));
#line 446 "dialog.c"
	} else {
		gboolean _tmp27_ = FALSE;
#line 83 "../games/scores/dialog.vala"
		if (self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 83 "../games/scores/dialog.vala"
			_tmp27_ = TRUE;
#line 453 "dialog.c"
		} else {
#line 83 "../games/scores/dialog.vala"
			_tmp27_ = self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER;
#line 457 "dialog.c"
		}
#line 83 "../games/scores/dialog.vala"
		if (_tmp27_) {
#line 461 "dialog.c"
			GtkLabel* _tmp28_;
#line 84 "../games/scores/dialog.vala"
			_tmp28_ = self->priv->window_title;
#line 84 "../games/scores/dialog.vala"
			gtk_label_set_label (_tmp28_, _ ("High Scores"));
#line 467 "dialog.c"
		} else {
			GtkLabel* _tmp29_;
#line 86 "../games/scores/dialog.vala"
			_tmp29_ = self->priv->window_title;
#line 86 "../games/scores/dialog.vala"
			gtk_label_set_label (_tmp29_, _ ("Best Times"));
#line 474 "dialog.c"
		}
	}
#line 88 "../games/scores/dialog.vala"
	_tmp30_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 88 "../games/scores/dialog.vala"
	_tmp31_ = _g_object_ref0 (_tmp30_);
#line 88 "../games/scores/dialog.vala"
	vbox = _tmp31_;
#line 89 "../games/scores/dialog.vala"
	_tmp32_ = vbox;
#line 89 "../games/scores/dialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp32_, GTK_ORIENTATION_VERTICAL);
#line 91 "../games/scores/dialog.vala"
	if (!games_scores_context_has_scores (context)) {
#line 91 "../games/scores/dialog.vala"
		_tmp33_ = new_high_score == NULL;
#line 491 "dialog.c"
	} else {
#line 91 "../games/scores/dialog.vala"
		_tmp33_ = FALSE;
#line 495 "dialog.c"
	}
#line 91 "../games/scores/dialog.vala"
	if (_tmp33_) {
#line 499 "dialog.c"
		GtkBox* _tmp34_;
		GtkBox* _tmp35_;
		GtkBox* _tmp36_;
		GtkBox* _tmp37_;
		GtkBox* _tmp38_;
		GtkStyleContext* _tmp39_;
		GtkImage* image = NULL;
		GtkImage* _tmp40_;
		GtkImage* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		GtkImage* _tmp44_;
		GtkImage* _tmp45_;
		GtkBox* _tmp46_;
		GtkImage* _tmp47_;
		GtkLabel* title_label = NULL;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		GtkLabel* _tmp52_;
		GtkLabel* _tmp53_;
		GtkLabel* _tmp54_;
		GtkBox* _tmp55_;
		GtkLabel* _tmp56_;
		GtkLabel* description_label = NULL;
		GtkLabel* _tmp57_;
		GtkBox* _tmp58_;
		GtkLabel* _tmp59_;
#line 93 "../games/scores/dialog.vala"
		_tmp34_ = vbox;
#line 93 "../games/scores/dialog.vala"
		gtk_box_set_spacing (_tmp34_, 4);
#line 94 "../games/scores/dialog.vala"
		_tmp35_ = vbox;
#line 94 "../games/scores/dialog.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp35_, TRUE);
#line 95 "../games/scores/dialog.vala"
		_tmp36_ = vbox;
#line 95 "../games/scores/dialog.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp36_, TRUE);
#line 96 "../games/scores/dialog.vala"
		_tmp37_ = vbox;
#line 96 "../games/scores/dialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
#line 97 "../games/scores/dialog.vala"
		_tmp38_ = vbox;
#line 97 "../games/scores/dialog.vala"
		_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
#line 97 "../games/scores/dialog.vala"
		gtk_style_context_add_class (_tmp39_, "dim-label");
#line 99 "../games/scores/dialog.vala"
		_tmp40_ = (GtkImage*) gtk_image_new ();
#line 99 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp40_);
#line 99 "../games/scores/dialog.vala"
		image = _tmp40_;
#line 100 "../games/scores/dialog.vala"
		_tmp41_ = image;
#line 100 "../games/scores/dialog.vala"
		_tmp42_ = g_strconcat (icon_name, "-symbolic", NULL);
#line 100 "../games/scores/dialog.vala"
		_tmp43_ = _tmp42_;
#line 100 "../games/scores/dialog.vala"
		g_object_set (_tmp41_, "icon-name", _tmp43_, NULL);
#line 100 "../games/scores/dialog.vala"
		_g_free0 (_tmp43_);
#line 101 "../games/scores/dialog.vala"
		_tmp44_ = image;
#line 101 "../games/scores/dialog.vala"
		gtk_image_set_pixel_size (_tmp44_, 64);
#line 102 "../games/scores/dialog.vala"
		_tmp45_ = image;
#line 102 "../games/scores/dialog.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp45_, 0.2);
#line 103 "../games/scores/dialog.vala"
		_tmp46_ = vbox;
#line 103 "../games/scores/dialog.vala"
		_tmp47_ = image;
#line 103 "../games/scores/dialog.vala"
		gtk_box_append (_tmp46_, (GtkWidget*) _tmp47_);
#line 105 "../games/scores/dialog.vala"
		_tmp48_ = g_strconcat ("<b><span size=\"large\">", _ ("No scores yet"), NULL);
#line 105 "../games/scores/dialog.vala"
		_tmp49_ = _tmp48_;
#line 105 "../games/scores/dialog.vala"
		_tmp50_ = g_strconcat (_tmp49_, "</span></b>", NULL);
#line 105 "../games/scores/dialog.vala"
		_tmp51_ = _tmp50_;
#line 105 "../games/scores/dialog.vala"
		_tmp52_ = (GtkLabel*) gtk_label_new (_tmp51_);
#line 105 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp52_);
#line 105 "../games/scores/dialog.vala"
		_tmp53_ = _tmp52_;
#line 105 "../games/scores/dialog.vala"
		_g_free0 (_tmp51_);
#line 105 "../games/scores/dialog.vala"
		_g_free0 (_tmp49_);
#line 105 "../games/scores/dialog.vala"
		title_label = _tmp53_;
#line 106 "../games/scores/dialog.vala"
		_tmp54_ = title_label;
#line 106 "../games/scores/dialog.vala"
		gtk_label_set_use_markup (_tmp54_, TRUE);
#line 107 "../games/scores/dialog.vala"
		_tmp55_ = vbox;
#line 107 "../games/scores/dialog.vala"
		_tmp56_ = title_label;
#line 107 "../games/scores/dialog.vala"
		gtk_box_append (_tmp55_, (GtkWidget*) _tmp56_);
#line 109 "../games/scores/dialog.vala"
		_tmp57_ = (GtkLabel*) gtk_label_new (_ ("Play some games and your scores will show up here."));
#line 109 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp57_);
#line 109 "../games/scores/dialog.vala"
		description_label = _tmp57_;
#line 110 "../games/scores/dialog.vala"
		_tmp58_ = vbox;
#line 110 "../games/scores/dialog.vala"
		_tmp59_ = description_label;
#line 110 "../games/scores/dialog.vala"
		gtk_box_append (_tmp58_, (GtkWidget*) _tmp59_);
#line 112 "../games/scores/dialog.vala"
		g_object_set ((GtkWidget*) self, "width-request", 450, NULL);
#line 113 "../games/scores/dialog.vala"
		g_object_set ((GtkWidget*) self, "height-request", 500, NULL);
#line 115 "../games/scores/dialog.vala"
		_g_object_unref0 (description_label);
#line 115 "../games/scores/dialog.vala"
		_g_object_unref0 (title_label);
#line 115 "../games/scores/dialog.vala"
		_g_object_unref0 (image);
#line 115 "../games/scores/dialog.vala"
		_g_object_unref0 (vbox);
#line 115 "../games/scores/dialog.vala"
		_g_object_unref0 (title_widget);
#line 115 "../games/scores/dialog.vala"
		return self;
#line 639 "dialog.c"
	}
#line 118 "../games/scores/dialog.vala"
	_tmp60_ = vbox;
#line 118 "../games/scores/dialog.vala"
	gtk_box_set_spacing (_tmp60_, 20);
#line 120 "../games/scores/dialog.vala"
	_tmp61_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 120 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp61_);
#line 120 "../games/scores/dialog.vala"
	catbar = _tmp61_;
#line 121 "../games/scores/dialog.vala"
	_tmp62_ = catbar;
#line 121 "../games/scores/dialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp62_, 20);
#line 122 "../games/scores/dialog.vala"
	_tmp63_ = catbar;
#line 122 "../games/scores/dialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp63_, 20);
#line 123 "../games/scores/dialog.vala"
	_tmp64_ = catbar;
#line 123 "../games/scores/dialog.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp64_, 20);
#line 124 "../games/scores/dialog.vala"
	_tmp65_ = catbar;
#line 124 "../games/scores/dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp65_, GTK_ALIGN_CENTER);
#line 126 "../games/scores/dialog.vala"
	_tmp66_ = vbox;
#line 126 "../games/scores/dialog.vala"
	_tmp67_ = catbar;
#line 126 "../games/scores/dialog.vala"
	gtk_box_append (_tmp66_, (GtkWidget*) _tmp67_);
#line 128 "../games/scores/dialog.vala"
	_tmp68_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 128 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp68_);
#line 128 "../games/scores/dialog.vala"
	hdiv = _tmp68_;
#line 129 "../games/scores/dialog.vala"
	_tmp69_ = vbox;
#line 129 "../games/scores/dialog.vala"
	_tmp70_ = hdiv;
#line 129 "../games/scores/dialog.vala"
	gtk_box_append (_tmp69_, (GtkWidget*) _tmp70_);
#line 131 "../games/scores/dialog.vala"
	_tmp71_ = (GtkLabel*) gtk_label_new (category_type);
#line 131 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp71_);
#line 131 "../games/scores/dialog.vala"
	label = _tmp71_;
#line 132 "../games/scores/dialog.vala"
	_tmp72_ = label;
#line 132 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp72_, TRUE);
#line 133 "../games/scores/dialog.vala"
	_tmp73_ = label;
#line 133 "../games/scores/dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp73_, GTK_ALIGN_CENTER);
#line 134 "../games/scores/dialog.vala"
	_tmp74_ = catbar;
#line 134 "../games/scores/dialog.vala"
	_tmp75_ = label;
#line 134 "../games/scores/dialog.vala"
	gtk_box_append (_tmp74_, (GtkWidget*) _tmp75_);
#line 136 "../games/scores/dialog.vala"
	_tmp76_ = games_scores_context_get_categories (context);
#line 136 "../games/scores/dialog.vala"
	categories = _tmp76_;
#line 137 "../games/scores/dialog.vala"
	if (new_high_score != NULL) {
#line 137 "../games/scores/dialog.vala"
		_tmp77_ = TRUE;
#line 713 "dialog.c"
	} else {
		GList* _tmp78_;
#line 137 "../games/scores/dialog.vala"
		_tmp78_ = categories;
#line 137 "../games/scores/dialog.vala"
		_tmp77_ = g_list_length (_tmp78_) == ((guint) 1);
#line 720 "dialog.c"
	}
#line 137 "../games/scores/dialog.vala"
	if (_tmp77_) {
#line 724 "dialog.c"
		GamesScoresCategory* _tmp83_;
		const gchar* _tmp84_;
		const gchar* _tmp85_;
		GtkLabel* _tmp86_;
		GtkLabel* _tmp87_;
		GtkLabel* _tmp88_;
		GtkLabel* _tmp89_;
		GtkBox* _tmp90_;
		GtkLabel* _tmp91_;
#line 139 "../games/scores/dialog.vala"
		if (new_high_score == NULL) {
#line 736 "dialog.c"
			GList* _tmp79_;
			GList* _tmp80_;
			gconstpointer _tmp81_;
			GamesScoresCategory* _tmp82_;
#line 140 "../games/scores/dialog.vala"
			_tmp79_ = categories;
#line 140 "../games/scores/dialog.vala"
			_tmp80_ = g_list_first (_tmp79_);
#line 140 "../games/scores/dialog.vala"
			_tmp81_ = ((GList*) _tmp80_)->data;
#line 140 "../games/scores/dialog.vala"
			_tmp82_ = _g_object_ref0 ((GamesScoresCategory*) _tmp81_);
#line 140 "../games/scores/dialog.vala"
			_g_object_unref0 (self->priv->scores_active_category);
#line 140 "../games/scores/dialog.vala"
			self->priv->scores_active_category = _tmp82_;
#line 753 "dialog.c"
		}
#line 141 "../games/scores/dialog.vala"
		_tmp83_ = self->priv->scores_active_category;
#line 141 "../games/scores/dialog.vala"
		_tmp84_ = games_scores_category_get_name (_tmp83_);
#line 141 "../games/scores/dialog.vala"
		_tmp85_ = _tmp84_;
#line 141 "../games/scores/dialog.vala"
		_tmp86_ = (GtkLabel*) gtk_label_new (_tmp85_);
#line 141 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp86_);
#line 141 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->category_label);
#line 141 "../games/scores/dialog.vala"
		self->priv->category_label = _tmp86_;
#line 142 "../games/scores/dialog.vala"
		_tmp87_ = self->priv->category_label;
#line 142 "../games/scores/dialog.vala"
		gtk_label_set_use_markup (_tmp87_, TRUE);
#line 143 "../games/scores/dialog.vala"
		_tmp88_ = self->priv->category_label;
#line 143 "../games/scores/dialog.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp88_, GTK_ALIGN_CENTER);
#line 144 "../games/scores/dialog.vala"
		_tmp89_ = self->priv->category_label;
#line 144 "../games/scores/dialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp89_, GTK_ALIGN_CENTER);
#line 145 "../games/scores/dialog.vala"
		_tmp90_ = catbar;
#line 145 "../games/scores/dialog.vala"
		_tmp91_ = self->priv->category_label;
#line 145 "../games/scores/dialog.vala"
		gtk_box_append (_tmp90_, (GtkWidget*) _tmp91_);
#line 787 "dialog.c"
	} else {
		GtkComboBoxText* _tmp92_;
		GtkComboBoxText* _tmp93_;
		GtkBox* _tmp94_;
		GtkComboBoxText* _tmp95_;
		GtkComboBoxText* _tmp96_;
#line 149 "../games/scores/dialog.vala"
		_tmp92_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 149 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp92_);
#line 149 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->combo);
#line 149 "../games/scores/dialog.vala"
		self->priv->combo = _tmp92_;
#line 150 "../games/scores/dialog.vala"
		_tmp93_ = self->priv->combo;
#line 150 "../games/scores/dialog.vala"
		gtk_widget_set_focus_on_click ((GtkWidget*) _tmp93_, FALSE);
#line 151 "../games/scores/dialog.vala"
		_tmp94_ = catbar;
#line 151 "../games/scores/dialog.vala"
		_tmp95_ = self->priv->combo;
#line 151 "../games/scores/dialog.vala"
		gtk_box_append (_tmp94_, (GtkWidget*) _tmp95_);
#line 152 "../games/scores/dialog.vala"
		_tmp96_ = self->priv->combo;
#line 152 "../games/scores/dialog.vala"
		g_signal_connect_object ((GtkComboBox*) _tmp96_, "changed", (GCallback) _games_scores_dialog_load_scores_gtk_combo_box_changed, self, 0);
#line 816 "dialog.c"
	}
#line 155 "../games/scores/dialog.vala"
	_tmp97_ = (GtkGrid*) gtk_grid_new ();
#line 155 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp97_);
#line 155 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->grid);
#line 155 "../games/scores/dialog.vala"
	self->priv->grid = _tmp97_;
#line 156 "../games/scores/dialog.vala"
	_tmp98_ = vbox;
#line 156 "../games/scores/dialog.vala"
	_tmp99_ = self->priv->grid;
#line 156 "../games/scores/dialog.vala"
	gtk_box_append (_tmp98_, (GtkWidget*) _tmp99_);
#line 158 "../games/scores/dialog.vala"
	_tmp100_ = self->priv->grid;
#line 158 "../games/scores/dialog.vala"
	gtk_grid_set_row_homogeneous (_tmp100_, TRUE);
#line 159 "../games/scores/dialog.vala"
	_tmp101_ = self->priv->grid;
#line 159 "../games/scores/dialog.vala"
	gtk_grid_set_column_spacing (_tmp101_, 40);
#line 160 "../games/scores/dialog.vala"
	_tmp102_ = self->priv->grid;
#line 160 "../games/scores/dialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp102_, 30);
#line 161 "../games/scores/dialog.vala"
	_tmp103_ = self->priv->grid;
#line 161 "../games/scores/dialog.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp103_, 30);
#line 162 "../games/scores/dialog.vala"
	_tmp104_ = self->priv->grid;
#line 162 "../games/scores/dialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp104_, 20);
#line 163 "../games/scores/dialog.vala"
	_tmp105_ = self->priv->grid;
#line 163 "../games/scores/dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp105_, GTK_ALIGN_CENTER);
#line 166 "../games/scores/dialog.vala"
	_tmp106_ = g_strdup (_ ("Rank"));
#line 166 "../games/scores/dialog.vala"
	string_rank = _tmp106_;
#line 167 "../games/scores/dialog.vala"
	_tmp107_ = string_rank;
#line 167 "../games/scores/dialog.vala"
	_tmp108_ = g_strconcat ("<span weight='bold'>", _tmp107_, NULL);
#line 167 "../games/scores/dialog.vala"
	_tmp109_ = _tmp108_;
#line 167 "../games/scores/dialog.vala"
	_tmp110_ = g_strconcat (_tmp109_, "</span>", NULL);
#line 167 "../games/scores/dialog.vala"
	_tmp111_ = _tmp110_;
#line 167 "../games/scores/dialog.vala"
	_tmp112_ = (GtkLabel*) gtk_label_new (_tmp111_);
#line 167 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp112_);
#line 167 "../games/scores/dialog.vala"
	_tmp113_ = _tmp112_;
#line 167 "../games/scores/dialog.vala"
	_g_free0 (_tmp111_);
#line 167 "../games/scores/dialog.vala"
	_g_free0 (_tmp109_);
#line 167 "../games/scores/dialog.vala"
	label_column_1 = _tmp113_;
#line 168 "../games/scores/dialog.vala"
	_tmp114_ = label_column_1;
#line 168 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp114_, TRUE);
#line 169 "../games/scores/dialog.vala"
	_tmp115_ = self->priv->grid;
#line 169 "../games/scores/dialog.vala"
	_tmp116_ = label_column_1;
#line 169 "../games/scores/dialog.vala"
	gtk_grid_attach (_tmp115_, (GtkWidget*) _tmp116_, 0, 0, 1, 1);
#line 171 "../games/scores/dialog.vala"
	_tmp117_ = g_strdup ("");
#line 171 "../games/scores/dialog.vala"
	score_or_time = _tmp117_;
#line 173 "../games/scores/dialog.vala"
	if (self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 173 "../games/scores/dialog.vala"
		_tmp118_ = TRUE;
#line 900 "dialog.c"
	} else {
#line 173 "../games/scores/dialog.vala"
		_tmp118_ = self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER;
#line 904 "dialog.c"
	}
#line 173 "../games/scores/dialog.vala"
	if (_tmp118_) {
#line 908 "dialog.c"
		gchar* _tmp119_;
#line 175 "../games/scores/dialog.vala"
		_tmp119_ = g_strdup (_ ("Score"));
#line 175 "../games/scores/dialog.vala"
		_g_free0 (score_or_time);
#line 175 "../games/scores/dialog.vala"
		score_or_time = _tmp119_;
#line 916 "dialog.c"
	} else {
		gchar* _tmp120_;
#line 177 "../games/scores/dialog.vala"
		_tmp120_ = g_strdup (_ ("Time"));
#line 177 "../games/scores/dialog.vala"
		_g_free0 (score_or_time);
#line 177 "../games/scores/dialog.vala"
		score_or_time = _tmp120_;
#line 925 "dialog.c"
	}
#line 179 "../games/scores/dialog.vala"
	_tmp121_ = score_or_time;
#line 179 "../games/scores/dialog.vala"
	_tmp122_ = g_strconcat ("<span weight='bold'>", _tmp121_, NULL);
#line 179 "../games/scores/dialog.vala"
	_tmp123_ = _tmp122_;
#line 179 "../games/scores/dialog.vala"
	_tmp124_ = g_strconcat (_tmp123_, "</span>", NULL);
#line 179 "../games/scores/dialog.vala"
	_tmp125_ = _tmp124_;
#line 179 "../games/scores/dialog.vala"
	_tmp126_ = (GtkLabel*) gtk_label_new (_tmp125_);
#line 179 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp126_);
#line 179 "../games/scores/dialog.vala"
	_tmp127_ = _tmp126_;
#line 179 "../games/scores/dialog.vala"
	_g_free0 (_tmp125_);
#line 179 "../games/scores/dialog.vala"
	_g_free0 (_tmp123_);
#line 179 "../games/scores/dialog.vala"
	label_column_2 = _tmp127_;
#line 180 "../games/scores/dialog.vala"
	_tmp128_ = label_column_2;
#line 180 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp128_, TRUE);
#line 181 "../games/scores/dialog.vala"
	_tmp129_ = self->priv->grid;
#line 181 "../games/scores/dialog.vala"
	_tmp130_ = label_column_2;
#line 181 "../games/scores/dialog.vala"
	gtk_grid_attach (_tmp129_, (GtkWidget*) _tmp130_, 1, 0, 1, 1);
#line 184 "../games/scores/dialog.vala"
	_tmp131_ = g_strdup (_ ("Player"));
#line 184 "../games/scores/dialog.vala"
	string_player = _tmp131_;
#line 185 "../games/scores/dialog.vala"
	_tmp132_ = string_player;
#line 185 "../games/scores/dialog.vala"
	_tmp133_ = g_strconcat ("<span weight='bold'>", _tmp132_, NULL);
#line 185 "../games/scores/dialog.vala"
	_tmp134_ = _tmp133_;
#line 185 "../games/scores/dialog.vala"
	_tmp135_ = g_strconcat (_tmp134_, "</span>", NULL);
#line 185 "../games/scores/dialog.vala"
	_tmp136_ = _tmp135_;
#line 185 "../games/scores/dialog.vala"
	_tmp137_ = (GtkLabel*) gtk_label_new (_tmp136_);
#line 185 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp137_);
#line 185 "../games/scores/dialog.vala"
	_tmp138_ = _tmp137_;
#line 185 "../games/scores/dialog.vala"
	_g_free0 (_tmp136_);
#line 185 "../games/scores/dialog.vala"
	_g_free0 (_tmp134_);
#line 185 "../games/scores/dialog.vala"
	label_column_3 = _tmp138_;
#line 186 "../games/scores/dialog.vala"
	_tmp139_ = label_column_3;
#line 186 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp139_, TRUE);
#line 187 "../games/scores/dialog.vala"
	_tmp140_ = self->priv->grid;
#line 187 "../games/scores/dialog.vala"
	_tmp141_ = label_column_3;
#line 187 "../games/scores/dialog.vala"
	gtk_grid_attach (_tmp140_, (GtkWidget*) _tmp141_, 2, 0, 1, 1);
#line 189 "../games/scores/dialog.vala"
	_tmp142_ = self->priv->grid;
#line 189 "../games/scores/dialog.vala"
	gtk_grid_set_baseline_row (_tmp142_, 0);
#line 190 "../games/scores/dialog.vala"
	games_scores_dialog_fill_grid_with_labels (self);
#line 192 "../games/scores/dialog.vala"
	if (new_high_score != NULL) {
#line 1003 "dialog.c"
		GtkWidget* _tmp143_;
		GtkStyleContext* _tmp144_;
#line 194 "../games/scores/dialog.vala"
		_tmp143_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("_Done"), (gint) GTK_RESPONSE_OK);
#line 194 "../games/scores/dialog.vala"
		_tmp144_ = gtk_widget_get_style_context (_tmp143_);
#line 194 "../games/scores/dialog.vala"
		gtk_style_context_add_class (_tmp144_, "suggested-action");
#line 1012 "dialog.c"
	}
#line 196 "../games/scores/dialog.vala"
	games_scores_dialog_load_categories (self);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (label_column_3);
#line 41 "../games/scores/dialog.vala"
	_g_free0 (string_player);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (label_column_2);
#line 41 "../games/scores/dialog.vala"
	_g_free0 (score_or_time);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (label_column_1);
#line 41 "../games/scores/dialog.vala"
	_g_free0 (string_rank);
#line 41 "../games/scores/dialog.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (label);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (hdiv);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (catbar);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (vbox);
#line 41 "../games/scores/dialog.vala"
	_g_object_unref0 (title_widget);
#line 41 "../games/scores/dialog.vala"
	return self;
#line 1042 "dialog.c"
}

GamesScoresDialog*
games_scores_dialog_new (GamesScoresContext* context,
                         const gchar* category_type,
                         GamesScoresStyle style,
                         GamesScoresScore* new_high_score,
                         GamesScoresCategory* current_cat,
                         GtkWindow* window,
                         const gchar* icon_name)
{
#line 41 "../games/scores/dialog.vala"
	return games_scores_dialog_construct (GAMES_SCORES_TYPE_DIALOG, context, category_type, style, new_high_score, current_cat, window, icon_name);
#line 1056 "dialog.c"
}

static void
games_scores_dialog_fill_grid_with_labels (GamesScoresDialog* self)
{
#line 199 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 1064 "dialog.c"
	{
		gint row = 0;
#line 201 "../games/scores/dialog.vala"
		row = 1;
#line 1069 "dialog.c"
		{
			gboolean _tmp0_ = FALSE;
#line 201 "../games/scores/dialog.vala"
			_tmp0_ = TRUE;
#line 201 "../games/scores/dialog.vala"
			while (TRUE) {
#line 1076 "dialog.c"
				GtkStack* stack = NULL;
				GtkStack* _tmp10_;
				GtkStack* _tmp11_;
				GtkStack* _tmp12_;
				GtkStack* _tmp13_;
				GtkStack* _tmp14_;
				GtkLabel* label = NULL;
				GtkLabel* _tmp15_;
				GtkLabel* _tmp16_;
				GtkLabel* _tmp17_;
				GtkLabel* _tmp18_;
				GtkStack* _tmp19_;
				GtkLabel* _tmp20_;
				GtkEntry* entry = NULL;
				GtkEntry* _tmp21_;
				GtkEntry* _tmp22_;
				GtkEntry* _tmp23_;
				GtkEntry* _tmp24_;
				GtkEntry* _tmp25_;
				GtkStack* _tmp26_;
				GtkEntry* _tmp27_;
				GtkStack* _tmp28_;
				GtkGrid* _tmp29_;
				GtkStack* _tmp30_;
#line 201 "../games/scores/dialog.vala"
				if (!_tmp0_) {
#line 1103 "dialog.c"
					gint _tmp1_;
#line 201 "../games/scores/dialog.vala"
					_tmp1_ = row;
#line 201 "../games/scores/dialog.vala"
					row = _tmp1_ + 1;
#line 1109 "dialog.c"
				}
#line 201 "../games/scores/dialog.vala"
				_tmp0_ = FALSE;
#line 201 "../games/scores/dialog.vala"
				if (!(row <= self->priv->rows_to_display)) {
#line 201 "../games/scores/dialog.vala"
					break;
#line 1117 "dialog.c"
				}
				{
					gint column = 0;
#line 203 "../games/scores/dialog.vala"
					column = 0;
#line 1123 "dialog.c"
					{
						gboolean _tmp2_ = FALSE;
#line 203 "../games/scores/dialog.vala"
						_tmp2_ = TRUE;
#line 203 "../games/scores/dialog.vala"
						while (TRUE) {
#line 1130 "dialog.c"
							GtkLabel* label = NULL;
							GtkLabel* _tmp4_;
							GtkLabel* _tmp5_;
							GtkLabel* _tmp6_;
							GtkLabel* _tmp7_;
							GtkGrid* _tmp8_;
							GtkLabel* _tmp9_;
#line 203 "../games/scores/dialog.vala"
							if (!_tmp2_) {
#line 1140 "dialog.c"
								gint _tmp3_;
#line 203 "../games/scores/dialog.vala"
								_tmp3_ = column;
#line 203 "../games/scores/dialog.vala"
								column = _tmp3_ + 1;
#line 1146 "dialog.c"
							}
#line 203 "../games/scores/dialog.vala"
							_tmp2_ = FALSE;
#line 203 "../games/scores/dialog.vala"
							if (!(column <= 1)) {
#line 203 "../games/scores/dialog.vala"
								break;
#line 1154 "dialog.c"
							}
#line 205 "../games/scores/dialog.vala"
							_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 205 "../games/scores/dialog.vala"
							g_object_ref_sink (_tmp4_);
#line 205 "../games/scores/dialog.vala"
							label = _tmp4_;
#line 206 "../games/scores/dialog.vala"
							_tmp5_ = label;
#line 206 "../games/scores/dialog.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 207 "../games/scores/dialog.vala"
							_tmp6_ = label;
#line 207 "../games/scores/dialog.vala"
							gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 208 "../games/scores/dialog.vala"
							_tmp7_ = label;
#line 208 "../games/scores/dialog.vala"
							gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 210 "../games/scores/dialog.vala"
							_tmp8_ = self->priv->grid;
#line 210 "../games/scores/dialog.vala"
							_tmp9_ = label;
#line 210 "../games/scores/dialog.vala"
							gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, column, row, 1, 1);
#line 203 "../games/scores/dialog.vala"
							_g_object_unref0 (label);
#line 1182 "dialog.c"
						}
					}
				}
#line 213 "../games/scores/dialog.vala"
				_tmp10_ = (GtkStack*) gtk_stack_new ();
#line 213 "../games/scores/dialog.vala"
				g_object_ref_sink (_tmp10_);
#line 213 "../games/scores/dialog.vala"
				stack = _tmp10_;
#line 214 "../games/scores/dialog.vala"
				_tmp11_ = stack;
#line 214 "../games/scores/dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
#line 215 "../games/scores/dialog.vala"
				_tmp12_ = stack;
#line 215 "../games/scores/dialog.vala"
				gtk_stack_set_hhomogeneous (_tmp12_, FALSE);
#line 216 "../games/scores/dialog.vala"
				_tmp13_ = stack;
#line 216 "../games/scores/dialog.vala"
				gtk_stack_set_vhomogeneous (_tmp13_, TRUE);
#line 217 "../games/scores/dialog.vala"
				_tmp14_ = stack;
#line 217 "../games/scores/dialog.vala"
				gtk_stack_set_transition_type (_tmp14_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 219 "../games/scores/dialog.vala"
				_tmp15_ = (GtkLabel*) gtk_label_new ("");
#line 219 "../games/scores/dialog.vala"
				g_object_ref_sink (_tmp15_);
#line 219 "../games/scores/dialog.vala"
				label = _tmp15_;
#line 220 "../games/scores/dialog.vala"
				_tmp16_ = label;
#line 220 "../games/scores/dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp16_, TRUE);
#line 221 "../games/scores/dialog.vala"
				_tmp17_ = label;
#line 221 "../games/scores/dialog.vala"
				gtk_label_set_justify (_tmp17_, GTK_JUSTIFY_CENTER);
#line 222 "../games/scores/dialog.vala"
				_tmp18_ = label;
#line 222 "../games/scores/dialog.vala"
				gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 223 "../games/scores/dialog.vala"
				_tmp19_ = stack;
#line 223 "../games/scores/dialog.vala"
				_tmp20_ = label;
#line 223 "../games/scores/dialog.vala"
				gtk_stack_add_named (_tmp19_, (GtkWidget*) _tmp20_, "label");
#line 225 "../games/scores/dialog.vala"
				_tmp21_ = (GtkEntry*) gtk_entry_new ();
#line 225 "../games/scores/dialog.vala"
				g_object_ref_sink (_tmp21_);
#line 225 "../games/scores/dialog.vala"
				entry = _tmp21_;
#line 226 "../games/scores/dialog.vala"
				_tmp22_ = entry;
#line 226 "../games/scores/dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp22_, TRUE);
#line 227 "../games/scores/dialog.vala"
				_tmp23_ = entry;
#line 227 "../games/scores/dialog.vala"
				gtk_widget_set_size_request ((GtkWidget*) _tmp23_, 20, 20);
#line 228 "../games/scores/dialog.vala"
				_tmp24_ = entry;
#line 228 "../games/scores/dialog.vala"
				gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, FALSE);
#line 229 "../games/scores/dialog.vala"
				_tmp25_ = entry;
#line 229 "../games/scores/dialog.vala"
				gtk_widget_set_vexpand ((GtkWidget*) _tmp25_, FALSE);
#line 230 "../games/scores/dialog.vala"
				_tmp26_ = stack;
#line 230 "../games/scores/dialog.vala"
				_tmp27_ = entry;
#line 230 "../games/scores/dialog.vala"
				gtk_stack_add_named (_tmp26_, (GtkWidget*) _tmp27_, "entry");
#line 232 "../games/scores/dialog.vala"
				_tmp28_ = stack;
#line 232 "../games/scores/dialog.vala"
				gtk_stack_set_visible_child_name (_tmp28_, "label");
#line 233 "../games/scores/dialog.vala"
				_tmp29_ = self->priv->grid;
#line 233 "../games/scores/dialog.vala"
				_tmp30_ = stack;
#line 233 "../games/scores/dialog.vala"
				gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 2, row, 1, 1);
#line 201 "../games/scores/dialog.vala"
				_g_object_unref0 (entry);
#line 201 "../games/scores/dialog.vala"
				_g_object_unref0 (label);
#line 201 "../games/scores/dialog.vala"
				_g_object_unref0 (stack);
#line 1276 "dialog.c"
			}
		}
	}
}

static void
__lambda10_ (GamesScoresDialog* self,
             GamesScoresCategory* x)
{
	GtkComboBoxText* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 250 "../games/scores/dialog.vala"
	_tmp0_ = self->priv->combo;
#line 250 "../games/scores/dialog.vala"
	_tmp1_ = games_scores_category_get_key (x);
#line 250 "../games/scores/dialog.vala"
	_tmp2_ = _tmp1_;
#line 250 "../games/scores/dialog.vala"
	_tmp3_ = games_scores_category_get_name (x);
#line 250 "../games/scores/dialog.vala"
	_tmp4_ = _tmp3_;
#line 250 "../games/scores/dialog.vala"
	gtk_combo_box_text_append (_tmp0_, _tmp2_, _tmp4_);
#line 1303 "dialog.c"
}

static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
#line 250 "../games/scores/dialog.vala"
	__lambda10_ ((GamesScoresDialog*) self, (GamesScoresCategory*) data);
#line 1312 "dialog.c"
}

static void
games_scores_dialog_load_categories (GamesScoresDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GamesScoresScore* _tmp1_;
	GtkComboBoxText* _tmp3_;
	GList* categories = NULL;
	GamesScoresContext* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GamesScoresCategory* _tmp7_;
	GamesScoresCategory* _tmp17_;
#line 238 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 241 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->new_high_score;
#line 241 "../games/scores/dialog.vala"
	if (_tmp1_ != NULL) {
#line 241 "../games/scores/dialog.vala"
		_tmp0_ = TRUE;
#line 1335 "dialog.c"
	} else {
		GtkComboBoxText* _tmp2_;
#line 241 "../games/scores/dialog.vala"
		_tmp2_ = self->priv->combo;
#line 241 "../games/scores/dialog.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1342 "dialog.c"
	}
#line 241 "../games/scores/dialog.vala"
	if (_tmp0_) {
#line 243 "../games/scores/dialog.vala"
		games_scores_dialog_load_scores (self);
#line 1348 "dialog.c"
	}
#line 246 "../games/scores/dialog.vala"
	_tmp3_ = self->priv->combo;
#line 246 "../games/scores/dialog.vala"
	if (_tmp3_ == NULL) {
#line 247 "../games/scores/dialog.vala"
		return;
#line 1356 "dialog.c"
	}
#line 249 "../games/scores/dialog.vala"
	_tmp4_ = self->priv->context;
#line 249 "../games/scores/dialog.vala"
	_tmp5_ = games_scores_context_get_categories (_tmp4_);
#line 249 "../games/scores/dialog.vala"
	categories = _tmp5_;
#line 250 "../games/scores/dialog.vala"
	_tmp6_ = categories;
#line 250 "../games/scores/dialog.vala"
	g_list_foreach (_tmp6_, ___lambda10__gfunc, self);
#line 252 "../games/scores/dialog.vala"
	_tmp7_ = self->priv->scores_active_category;
#line 252 "../games/scores/dialog.vala"
	if (_tmp7_ == NULL) {
#line 1372 "dialog.c"
		GtkComboBoxText* _tmp8_;
		GList* _tmp9_;
		gconstpointer _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 253 "../games/scores/dialog.vala"
		_tmp8_ = self->priv->combo;
#line 253 "../games/scores/dialog.vala"
		_tmp9_ = categories;
#line 253 "../games/scores/dialog.vala"
		_tmp10_ = g_list_nth_data (_tmp9_, (guint) 0);
#line 253 "../games/scores/dialog.vala"
		_tmp11_ = games_scores_category_get_key ((GamesScoresCategory*) _tmp10_);
#line 253 "../games/scores/dialog.vala"
		_tmp12_ = _tmp11_;
#line 253 "../games/scores/dialog.vala"
		gtk_combo_box_set_active_id ((GtkComboBox*) _tmp8_, _tmp12_);
#line 1390 "dialog.c"
	} else {
		GtkComboBoxText* _tmp13_;
		GamesScoresCategory* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 255 "../games/scores/dialog.vala"
		_tmp13_ = self->priv->combo;
#line 255 "../games/scores/dialog.vala"
		_tmp14_ = self->priv->scores_active_category;
#line 255 "../games/scores/dialog.vala"
		_tmp15_ = games_scores_category_get_key (_tmp14_);
#line 255 "../games/scores/dialog.vala"
		_tmp16_ = _tmp15_;
#line 255 "../games/scores/dialog.vala"
		gtk_combo_box_set_active_id ((GtkComboBox*) _tmp13_, _tmp16_);
#line 1406 "dialog.c"
	}
#line 257 "../games/scores/dialog.vala"
	_tmp17_ = self->priv->active_category;
#line 257 "../games/scores/dialog.vala"
	if (_tmp17_ == NULL) {
#line 1412 "dialog.c"
		GList* _tmp18_;
		gconstpointer _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GList* _tmp22_;
		gconstpointer _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		GamesScoresCategory* _tmp26_;
#line 259 "../games/scores/dialog.vala"
		_tmp18_ = categories;
#line 259 "../games/scores/dialog.vala"
		_tmp19_ = g_list_nth_data (_tmp18_, (guint) 0);
#line 259 "../games/scores/dialog.vala"
		_tmp20_ = games_scores_category_get_key ((GamesScoresCategory*) _tmp19_);
#line 259 "../games/scores/dialog.vala"
		_tmp21_ = _tmp20_;
#line 259 "../games/scores/dialog.vala"
		_tmp22_ = categories;
#line 259 "../games/scores/dialog.vala"
		_tmp23_ = g_list_nth_data (_tmp22_, (guint) 0);
#line 259 "../games/scores/dialog.vala"
		_tmp24_ = games_scores_category_get_name ((GamesScoresCategory*) _tmp23_);
#line 259 "../games/scores/dialog.vala"
		_tmp25_ = _tmp24_;
#line 259 "../games/scores/dialog.vala"
		_tmp26_ = games_scores_category_new (_tmp21_, _tmp25_);
#line 259 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->active_category);
#line 259 "../games/scores/dialog.vala"
		self->priv->active_category = _tmp26_;
#line 1444 "dialog.c"
	} else {
		GamesScoresCategory* _tmp27_;
		GList* _tmp28_;
		gconstpointer _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		GamesScoresCategory* _tmp32_;
		GList* _tmp33_;
		gconstpointer _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
#line 263 "../games/scores/dialog.vala"
		_tmp27_ = self->priv->active_category;
#line 263 "../games/scores/dialog.vala"
		_tmp28_ = categories;
#line 263 "../games/scores/dialog.vala"
		_tmp29_ = g_list_nth_data (_tmp28_, (guint) 0);
#line 263 "../games/scores/dialog.vala"
		_tmp30_ = games_scores_category_get_key ((GamesScoresCategory*) _tmp29_);
#line 263 "../games/scores/dialog.vala"
		_tmp31_ = _tmp30_;
#line 263 "../games/scores/dialog.vala"
		games_scores_category_set_key (_tmp27_, _tmp31_);
#line 264 "../games/scores/dialog.vala"
		_tmp32_ = self->priv->active_category;
#line 264 "../games/scores/dialog.vala"
		_tmp33_ = categories;
#line 264 "../games/scores/dialog.vala"
		_tmp34_ = g_list_nth_data (_tmp33_, (guint) 0);
#line 264 "../games/scores/dialog.vala"
		_tmp35_ = games_scores_category_get_name ((GamesScoresCategory*) _tmp34_);
#line 264 "../games/scores/dialog.vala"
		_tmp36_ = _tmp35_;
#line 264 "../games/scores/dialog.vala"
		games_scores_category_set_name (_tmp32_, _tmp36_);
#line 1480 "dialog.c"
	}
#line 238 "../games/scores/dialog.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 1484 "dialog.c"
}

static void
games_scores_dialog_load_scores (GamesScoresDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GamesScoresScore* _tmp1_;
	GeeList* best_n_scores = NULL;
	GamesScoresContext* _tmp16_;
	GamesScoresCategory* _tmp17_;
	GeeList* _tmp18_;
	gint row_count = 0;
#line 269 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 271 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->new_high_score;
#line 271 "../games/scores/dialog.vala"
	if (_tmp1_ != NULL) {
#line 271 "../games/scores/dialog.vala"
		_tmp0_ = TRUE;
#line 1505 "dialog.c"
	} else {
		GtkComboBoxText* _tmp2_;
#line 271 "../games/scores/dialog.vala"
		_tmp2_ = self->priv->combo;
#line 271 "../games/scores/dialog.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1512 "dialog.c"
	}
#line 271 "../games/scores/dialog.vala"
	if (_tmp0_) {
#line 1516 "dialog.c"
		GamesScoresCategory* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GamesScoresCategory* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GamesScoresCategory* _tmp9_;
#line 272 "../games/scores/dialog.vala"
		_tmp3_ = self->priv->scores_active_category;
#line 272 "../games/scores/dialog.vala"
		_tmp4_ = games_scores_category_get_key (_tmp3_);
#line 272 "../games/scores/dialog.vala"
		_tmp5_ = _tmp4_;
#line 272 "../games/scores/dialog.vala"
		_tmp6_ = self->priv->scores_active_category;
#line 272 "../games/scores/dialog.vala"
		_tmp7_ = games_scores_category_get_name (_tmp6_);
#line 272 "../games/scores/dialog.vala"
		_tmp8_ = _tmp7_;
#line 272 "../games/scores/dialog.vala"
		_tmp9_ = games_scores_category_new (_tmp5_, _tmp8_);
#line 272 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->active_category);
#line 272 "../games/scores/dialog.vala"
		self->priv->active_category = _tmp9_;
#line 1542 "dialog.c"
	} else {
		GtkComboBoxText* _tmp10_;
		const gchar* _tmp11_;
		GtkComboBoxText* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GamesScoresCategory* _tmp15_;
#line 274 "../games/scores/dialog.vala"
		_tmp10_ = self->priv->combo;
#line 274 "../games/scores/dialog.vala"
		_tmp11_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp10_);
#line 274 "../games/scores/dialog.vala"
		_tmp12_ = self->priv->combo;
#line 274 "../games/scores/dialog.vala"
		_tmp13_ = gtk_combo_box_text_get_active_text (_tmp12_);
#line 274 "../games/scores/dialog.vala"
		_tmp14_ = _tmp13_;
#line 274 "../games/scores/dialog.vala"
		_tmp15_ = games_scores_category_new (_tmp11_, _tmp14_);
#line 274 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->active_category);
#line 274 "../games/scores/dialog.vala"
		self->priv->active_category = _tmp15_;
#line 274 "../games/scores/dialog.vala"
		_g_free0 (_tmp14_);
#line 1568 "dialog.c"
	}
#line 276 "../games/scores/dialog.vala"
	_tmp16_ = self->priv->context;
#line 276 "../games/scores/dialog.vala"
	_tmp17_ = self->priv->active_category;
#line 276 "../games/scores/dialog.vala"
	_tmp18_ = games_scores_context_get_high_scores (_tmp16_, _tmp17_, self->priv->rows_to_display);
#line 276 "../games/scores/dialog.vala"
	best_n_scores = _tmp18_;
#line 278 "../games/scores/dialog.vala"
	row_count = 1;
#line 1580 "dialog.c"
	{
		GeeList* _score_list = NULL;
		GeeList* _tmp19_;
		gint _score_size = 0;
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _score_index = 0;
#line 280 "../games/scores/dialog.vala"
		_tmp19_ = best_n_scores;
#line 280 "../games/scores/dialog.vala"
		_score_list = _tmp19_;
#line 280 "../games/scores/dialog.vala"
		_tmp20_ = _score_list;
#line 280 "../games/scores/dialog.vala"
		_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 280 "../games/scores/dialog.vala"
		_tmp22_ = _tmp21_;
#line 280 "../games/scores/dialog.vala"
		_score_size = _tmp22_;
#line 280 "../games/scores/dialog.vala"
		_score_index = -1;
#line 280 "../games/scores/dialog.vala"
		while (TRUE) {
#line 1605 "dialog.c"
			gint _tmp23_;
			gint _tmp24_;
			GamesScoresScore* score = NULL;
			GeeList* _tmp25_;
			gpointer _tmp26_;
			GamesScoresScore* _tmp27_;
			GeeList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
#line 280 "../games/scores/dialog.vala"
			_score_index = _score_index + 1;
#line 280 "../games/scores/dialog.vala"
			_tmp23_ = _score_index;
#line 280 "../games/scores/dialog.vala"
			_tmp24_ = _score_size;
#line 280 "../games/scores/dialog.vala"
			if (!(_tmp23_ < _tmp24_)) {
#line 280 "../games/scores/dialog.vala"
				break;
#line 1626 "dialog.c"
			}
#line 280 "../games/scores/dialog.vala"
			_tmp25_ = _score_list;
#line 280 "../games/scores/dialog.vala"
			_tmp26_ = gee_list_get (_tmp25_, _score_index);
#line 280 "../games/scores/dialog.vala"
			score = (GamesScoresScore*) _tmp26_;
#line 282 "../games/scores/dialog.vala"
			_tmp27_ = score;
#line 282 "../games/scores/dialog.vala"
			_tmp28_ = best_n_scores;
#line 282 "../games/scores/dialog.vala"
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
#line 282 "../games/scores/dialog.vala"
			_tmp30_ = _tmp29_;
#line 282 "../games/scores/dialog.vala"
			games_scores_dialog_display_single_score (self, _tmp27_, row_count, (guint) _tmp30_);
#line 283 "../games/scores/dialog.vala"
			_tmp31_ = row_count;
#line 283 "../games/scores/dialog.vala"
			row_count = _tmp31_ + 1;
#line 280 "../games/scores/dialog.vala"
			_g_object_unref0 (score);
#line 1650 "dialog.c"
		}
	}
#line 286 "../games/scores/dialog.vala"
	if (row_count < (self->priv->rows_to_display + 1)) {
#line 287 "../games/scores/dialog.vala"
		games_scores_dialog_make_remaining_labels_empty (self, row_count);
#line 1657 "dialog.c"
	}
#line 269 "../games/scores/dialog.vala"
	_g_object_unref0 (best_n_scores);
#line 1661 "dialog.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 292 "../games/scores/dialog.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 292 "../games/scores/dialog.vala"
	return _data4_;
#line 1671 "dialog.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 292 "../games/scores/dialog.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1681 "dialog.c"
		GamesScoresDialog* self;
#line 292 "../games/scores/dialog.vala"
		self = _data4_->self;
#line 292 "../games/scores/dialog.vala"
		_g_object_unref0 (_data4_->score);
#line 292 "../games/scores/dialog.vala"
		_g_object_unref0 (self);
#line 292 "../games/scores/dialog.vala"
		g_slice_free (Block4Data, _data4_);
#line 1691 "dialog.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 313 "../games/scores/dialog.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 313 "../games/scores/dialog.vala"
	return _data5_;
#line 1702 "dialog.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 313 "../games/scores/dialog.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1712 "dialog.c"
		GamesScoresDialog* self;
#line 313 "../games/scores/dialog.vala"
		self = _data5_->_data4_->self;
#line 313 "../games/scores/dialog.vala"
		_g_object_unref0 (_data5_->entry);
#line 313 "../games/scores/dialog.vala"
		block4_data_unref (_data5_->_data4_);
#line 313 "../games/scores/dialog.vala"
		_data5_->_data4_ = NULL;
#line 313 "../games/scores/dialog.vala"
		g_slice_free (Block5Data, _data5_);
#line 1724 "dialog.c"
	}
}

static void
___lambda9_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	GamesScoresDialog* self;
	GamesScoresContext* _tmp0_;
	GamesScoresCategory* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
#line 326 "../games/scores/dialog.vala"
	_data4_ = _data5_->_data4_;
#line 326 "../games/scores/dialog.vala"
	self = _data4_->self;
#line 327 "../games/scores/dialog.vala"
	_tmp0_ = self->priv->context;
#line 327 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->active_category;
#line 327 "../games/scores/dialog.vala"
	_tmp2_ = _data5_->entry;
#line 327 "../games/scores/dialog.vala"
	_tmp3_ = gtk_editable_get_text ((GtkEditable*) _tmp2_);
#line 327 "../games/scores/dialog.vala"
	games_scores_context_update_score_name (_tmp0_, _data4_->score, _tmp1_, _tmp3_);
#line 328 "../games/scores/dialog.vala"
	_tmp4_ = _data5_->entry;
#line 328 "../games/scores/dialog.vala"
	_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
#line 328 "../games/scores/dialog.vala"
	games_scores_score_set_user (_data4_->score, _tmp5_);
#line 1759 "dialog.c"
}

static void
____lambda9__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 326 "../games/scores/dialog.vala"
	___lambda9_ (self);
#line 1769 "dialog.c"
}

static void
games_scores_dialog_display_single_score (GamesScoresDialog* self,
                                          GamesScoresScore* score,
                                          gint row_count,
                                          guint no_scores)
{
	Block4Data* _data4_;
	GamesScoresScore* _tmp0_;
	GtkLabel* rank_label = NULL;
	GtkGrid* _tmp1_;
	GtkWidget* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* score_label = NULL;
	GtkGrid* _tmp7_;
	GtkWidget* _tmp8_;
	GtkLabel* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp27_ = FALSE;
	GamesScoresScore* _tmp28_;
	GtkStack* name_stack = NULL;
	GtkGrid* _tmp45_;
	GtkWidget* _tmp46_;
	GtkStack* _tmp47_;
	GtkWidget* widget = NULL;
	GtkStack* _tmp48_;
	GtkWidget* _tmp49_;
	GtkWidget* _tmp50_;
	GtkStack* _tmp51_;
	const gchar* _tmp52_;
#line 292 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 292 "../games/scores/dialog.vala"
	g_return_if_fail (score != NULL);
#line 292 "../games/scores/dialog.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 292 "../games/scores/dialog.vala"
	_data4_->_ref_count_ = 1;
#line 292 "../games/scores/dialog.vala"
	_data4_->self = g_object_ref (self);
#line 292 "../games/scores/dialog.vala"
	_tmp0_ = _g_object_ref0 (score);
#line 292 "../games/scores/dialog.vala"
	_g_object_unref0 (_data4_->score);
#line 292 "../games/scores/dialog.vala"
	_data4_->score = _tmp0_;
#line 294 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->grid;
#line 294 "../games/scores/dialog.vala"
	_tmp2_ = gtk_grid_get_child_at (_tmp1_, 0, row_count);
#line 294 "../games/scores/dialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_label_get_type (), GtkLabel));
#line 294 "../games/scores/dialog.vala"
	rank_label = _tmp3_;
#line 295 "../games/scores/dialog.vala"
	_tmp4_ = rank_label;
#line 295 "../games/scores/dialog.vala"
	_tmp5_ = g_strdup_printf ("%i", row_count);
#line 295 "../games/scores/dialog.vala"
	_tmp6_ = _tmp5_;
#line 295 "../games/scores/dialog.vala"
	gtk_label_set_text (_tmp4_, _tmp6_);
#line 295 "../games/scores/dialog.vala"
	_g_free0 (_tmp6_);
#line 297 "../games/scores/dialog.vala"
	_tmp7_ = self->priv->grid;
#line 297 "../games/scores/dialog.vala"
	_tmp8_ = gtk_grid_get_child_at (_tmp7_, 1, row_count);
#line 297 "../games/scores/dialog.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_label_get_type (), GtkLabel));
#line 297 "../games/scores/dialog.vala"
	score_label = _tmp9_;
#line 298 "../games/scores/dialog.vala"
	if (self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 298 "../games/scores/dialog.vala"
		_tmp10_ = TRUE;
#line 1850 "dialog.c"
	} else {
#line 298 "../games/scores/dialog.vala"
		_tmp10_ = self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER;
#line 1854 "dialog.c"
	}
#line 298 "../games/scores/dialog.vala"
	if (_tmp10_) {
#line 1858 "dialog.c"
		GtkLabel* _tmp11_;
		glong _tmp12_;
		glong _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 300 "../games/scores/dialog.vala"
		_tmp11_ = score_label;
#line 300 "../games/scores/dialog.vala"
		_tmp12_ = games_scores_score_get_score (_data4_->score);
#line 300 "../games/scores/dialog.vala"
		_tmp13_ = _tmp12_;
#line 300 "../games/scores/dialog.vala"
		_tmp14_ = g_strdup_printf ("%li", _tmp13_);
#line 300 "../games/scores/dialog.vala"
		_tmp15_ = _tmp14_;
#line 300 "../games/scores/dialog.vala"
		gtk_label_set_text (_tmp11_, _tmp15_);
#line 300 "../games/scores/dialog.vala"
		_g_free0 (_tmp15_);
#line 1878 "dialog.c"
	} else {
		glong minutes = 0L;
		glong _tmp16_;
		glong _tmp17_;
		glong seconds = 0L;
		glong _tmp18_;
		glong _tmp19_;
		GtkLabel* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 304 "../games/scores/dialog.vala"
		_tmp16_ = games_scores_score_get_score (_data4_->score);
#line 304 "../games/scores/dialog.vala"
		_tmp17_ = _tmp16_;
#line 304 "../games/scores/dialog.vala"
		minutes = _tmp17_ / 60;
#line 305 "../games/scores/dialog.vala"
		_tmp18_ = games_scores_score_get_score (_data4_->score);
#line 305 "../games/scores/dialog.vala"
		_tmp19_ = _tmp18_;
#line 305 "../games/scores/dialog.vala"
		seconds = _tmp19_ % 60;
#line 306 "../games/scores/dialog.vala"
		_tmp20_ = score_label;
#line 306 "../games/scores/dialog.vala"
		_tmp21_ = g_strdup_printf (g_dngettext (GETTEXT_PACKAGE, "%ld minute", "%ld minutes", (gulong) minutes), minutes);
#line 306 "../games/scores/dialog.vala"
		_tmp22_ = _tmp21_;
#line 306 "../games/scores/dialog.vala"
		_tmp23_ = g_strdup_printf (g_dngettext (GETTEXT_PACKAGE, "%ld second", "%ld seconds", (gulong) seconds), seconds);
#line 306 "../games/scores/dialog.vala"
		_tmp24_ = _tmp23_;
#line 306 "../games/scores/dialog.vala"
		_tmp25_ = g_strdup_printf ("%s %s", _tmp22_, _tmp24_);
#line 306 "../games/scores/dialog.vala"
		_tmp26_ = _tmp25_;
#line 306 "../games/scores/dialog.vala"
		gtk_label_set_text (_tmp20_, _tmp26_);
#line 306 "../games/scores/dialog.vala"
		_g_free0 (_tmp26_);
#line 306 "../games/scores/dialog.vala"
		_g_free0 (_tmp24_);
#line 306 "../games/scores/dialog.vala"
		_g_free0 (_tmp22_);
#line 1927 "dialog.c"
	}
#line 313 "../games/scores/dialog.vala"
	_tmp28_ = self->priv->new_high_score;
#line 313 "../games/scores/dialog.vala"
	if (_tmp28_ != NULL) {
#line 1933 "dialog.c"
		GamesScoresScore* _tmp29_;
#line 313 "../games/scores/dialog.vala"
		_tmp29_ = self->priv->new_high_score;
#line 313 "../games/scores/dialog.vala"
		_tmp27_ = games_scores_score_equals (_data4_->score, _tmp29_);
#line 1939 "dialog.c"
	} else {
#line 313 "../games/scores/dialog.vala"
		_tmp27_ = FALSE;
#line 1943 "dialog.c"
	}
#line 313 "../games/scores/dialog.vala"
	if (_tmp27_) {
#line 1947 "dialog.c"
		Block5Data* _data5_;
		GtkLabel* _tmp30_;
		gboolean _tmp31_ = FALSE;
		GtkStack* temp_stack = NULL;
		GtkGrid* _tmp34_;
		GtkWidget* _tmp35_;
		GtkStack* _tmp36_;
		GtkStack* _tmp37_;
		GtkStack* _tmp38_;
		GtkWidget* _tmp39_;
		GtkEntry* _tmp40_;
		GtkEntry* _tmp41_;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		GtkEntry* _tmp44_;
#line 313 "../games/scores/dialog.vala"
		_data5_ = g_slice_new0 (Block5Data);
#line 313 "../games/scores/dialog.vala"
		_data5_->_ref_count_ = 1;
#line 313 "../games/scores/dialog.vala"
		_data5_->_data4_ = block4_data_ref (_data4_);
#line 315 "../games/scores/dialog.vala"
		_tmp30_ = self->priv->window_subtitle;
#line 315 "../games/scores/dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp30_, TRUE);
#line 316 "../games/scores/dialog.vala"
		if (no_scores > ((guint) 1)) {
#line 316 "../games/scores/dialog.vala"
			_tmp31_ = row_count == 1;
#line 1977 "dialog.c"
		} else {
#line 316 "../games/scores/dialog.vala"
			_tmp31_ = FALSE;
#line 1981 "dialog.c"
		}
#line 316 "../games/scores/dialog.vala"
		if (_tmp31_) {
#line 1985 "dialog.c"
			GtkLabel* _tmp32_;
#line 317 "../games/scores/dialog.vala"
			_tmp32_ = self->priv->window_subtitle;
#line 317 "../games/scores/dialog.vala"
			gtk_label_set_label (_tmp32_, _ ("Your score is the best!"));
#line 1991 "dialog.c"
		} else {
			GtkLabel* _tmp33_;
#line 319 "../games/scores/dialog.vala"
			_tmp33_ = self->priv->window_subtitle;
#line 319 "../games/scores/dialog.vala"
			gtk_label_set_label (_tmp33_, _ ("Your score has made the top ten."));
#line 1998 "dialog.c"
		}
#line 321 "../games/scores/dialog.vala"
		_tmp34_ = self->priv->grid;
#line 321 "../games/scores/dialog.vala"
		_tmp35_ = gtk_grid_get_child_at (_tmp34_, 2, row_count);
#line 321 "../games/scores/dialog.vala"
		_tmp36_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_stack_get_type (), GtkStack));
#line 321 "../games/scores/dialog.vala"
		temp_stack = _tmp36_;
#line 322 "../games/scores/dialog.vala"
		_tmp37_ = temp_stack;
#line 322 "../games/scores/dialog.vala"
		gtk_stack_set_visible_child_name (_tmp37_, "entry");
#line 324 "../games/scores/dialog.vala"
		_tmp38_ = temp_stack;
#line 324 "../games/scores/dialog.vala"
		_tmp39_ = gtk_stack_get_visible_child (_tmp38_);
#line 324 "../games/scores/dialog.vala"
		_tmp40_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_entry_get_type (), GtkEntry));
#line 324 "../games/scores/dialog.vala"
		_data5_->entry = _tmp40_;
#line 325 "../games/scores/dialog.vala"
		_tmp41_ = _data5_->entry;
#line 325 "../games/scores/dialog.vala"
		_tmp42_ = games_scores_score_get_user (_data4_->score);
#line 325 "../games/scores/dialog.vala"
		_tmp43_ = _tmp42_;
#line 325 "../games/scores/dialog.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp41_, _tmp43_);
#line 326 "../games/scores/dialog.vala"
		_tmp44_ = _data5_->entry;
#line 326 "../games/scores/dialog.vala"
		g_signal_connect_data ((GObject*) _tmp44_, "notify::text", (GCallback) ____lambda9__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 313 "../games/scores/dialog.vala"
		_g_object_unref0 (temp_stack);
#line 313 "../games/scores/dialog.vala"
		block5_data_unref (_data5_);
#line 313 "../games/scores/dialog.vala"
		_data5_ = NULL;
#line 2038 "dialog.c"
	}
#line 332 "../games/scores/dialog.vala"
	_tmp45_ = self->priv->grid;
#line 332 "../games/scores/dialog.vala"
	_tmp46_ = gtk_grid_get_child_at (_tmp45_, 2, row_count);
#line 332 "../games/scores/dialog.vala"
	_tmp47_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_stack_get_type (), GtkStack));
#line 332 "../games/scores/dialog.vala"
	name_stack = _tmp47_;
#line 333 "../games/scores/dialog.vala"
	_tmp48_ = name_stack;
#line 333 "../games/scores/dialog.vala"
	_tmp49_ = gtk_stack_get_visible_child (_tmp48_);
#line 333 "../games/scores/dialog.vala"
	_tmp50_ = _g_object_ref0 (_tmp49_);
#line 333 "../games/scores/dialog.vala"
	widget = _tmp50_;
#line 335 "../games/scores/dialog.vala"
	_tmp51_ = name_stack;
#line 335 "../games/scores/dialog.vala"
	_tmp52_ = gtk_stack_get_visible_child_name (_tmp51_);
#line 335 "../games/scores/dialog.vala"
	if (g_strcmp0 (_tmp52_, "label") == 0) {
#line 2062 "dialog.c"
		GtkLabel* user_label = NULL;
		GtkWidget* _tmp53_;
		GtkLabel* _tmp54_;
		GtkLabel* _tmp55_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
#line 337 "../games/scores/dialog.vala"
		_tmp53_ = widget;
#line 337 "../games/scores/dialog.vala"
		_tmp54_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, gtk_label_get_type (), GtkLabel));
#line 337 "../games/scores/dialog.vala"
		user_label = _tmp54_;
#line 338 "../games/scores/dialog.vala"
		_tmp55_ = user_label;
#line 338 "../games/scores/dialog.vala"
		_tmp56_ = games_scores_score_get_user (_data4_->score);
#line 338 "../games/scores/dialog.vala"
		_tmp57_ = _tmp56_;
#line 338 "../games/scores/dialog.vala"
		gtk_label_set_text (_tmp55_, _tmp57_);
#line 335 "../games/scores/dialog.vala"
		_g_object_unref0 (user_label);
#line 2085 "dialog.c"
	} else {
		GtkEntry* entry = NULL;
		GtkWidget* _tmp58_;
		GtkEntry* _tmp59_;
		GtkEntry* _tmp60_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
#line 342 "../games/scores/dialog.vala"
		_tmp58_ = widget;
#line 342 "../games/scores/dialog.vala"
		_tmp59_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, gtk_entry_get_type (), GtkEntry));
#line 342 "../games/scores/dialog.vala"
		entry = _tmp59_;
#line 343 "../games/scores/dialog.vala"
		_tmp60_ = entry;
#line 343 "../games/scores/dialog.vala"
		_tmp61_ = games_scores_score_get_user (_data4_->score);
#line 343 "../games/scores/dialog.vala"
		_tmp62_ = _tmp61_;
#line 343 "../games/scores/dialog.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp60_, _tmp62_);
#line 335 "../games/scores/dialog.vala"
		_g_object_unref0 (entry);
#line 2109 "dialog.c"
	}
#line 292 "../games/scores/dialog.vala"
	_g_object_unref0 (widget);
#line 292 "../games/scores/dialog.vala"
	_g_object_unref0 (name_stack);
#line 292 "../games/scores/dialog.vala"
	_g_object_unref0 (score_label);
#line 292 "../games/scores/dialog.vala"
	_g_object_unref0 (rank_label);
#line 292 "../games/scores/dialog.vala"
	block4_data_unref (_data4_);
#line 292 "../games/scores/dialog.vala"
	_data4_ = NULL;
#line 2123 "dialog.c"
}

static void
games_scores_dialog_make_remaining_labels_empty (GamesScoresDialog* self,
                                                 gint row_count)
{
#line 348 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 2132 "dialog.c"
	{
		gint i = 0;
#line 350 "../games/scores/dialog.vala"
		i = row_count;
#line 2137 "dialog.c"
		{
			gboolean _tmp0_ = FALSE;
#line 350 "../games/scores/dialog.vala"
			_tmp0_ = TRUE;
#line 350 "../games/scores/dialog.vala"
			while (TRUE) {
#line 2144 "dialog.c"
				GtkStack* stack = NULL;
				GtkGrid* _tmp8_;
				GtkWidget* _tmp9_;
				GtkStack* _tmp10_;
				GtkLabel* label = NULL;
				GtkStack* _tmp11_;
				GtkWidget* _tmp12_;
				GtkLabel* _tmp13_;
				GtkLabel* _tmp14_;
#line 350 "../games/scores/dialog.vala"
				if (!_tmp0_) {
#line 2156 "dialog.c"
					gint _tmp1_;
#line 350 "../games/scores/dialog.vala"
					_tmp1_ = i;
#line 350 "../games/scores/dialog.vala"
					i = _tmp1_ + 1;
#line 2162 "dialog.c"
				}
#line 350 "../games/scores/dialog.vala"
				_tmp0_ = FALSE;
#line 350 "../games/scores/dialog.vala"
				if (!(i <= self->priv->rows_to_display)) {
#line 350 "../games/scores/dialog.vala"
					break;
#line 2170 "dialog.c"
				}
				{
					gint j = 0;
#line 352 "../games/scores/dialog.vala"
					j = 0;
#line 2176 "dialog.c"
					{
						gboolean _tmp2_ = FALSE;
#line 352 "../games/scores/dialog.vala"
						_tmp2_ = TRUE;
#line 352 "../games/scores/dialog.vala"
						while (TRUE) {
#line 2183 "dialog.c"
							GtkLabel* label = NULL;
							GtkGrid* _tmp4_;
							GtkWidget* _tmp5_;
							GtkLabel* _tmp6_;
							GtkLabel* _tmp7_;
#line 352 "../games/scores/dialog.vala"
							if (!_tmp2_) {
#line 2191 "dialog.c"
								gint _tmp3_;
#line 352 "../games/scores/dialog.vala"
								_tmp3_ = j;
#line 352 "../games/scores/dialog.vala"
								j = _tmp3_ + 1;
#line 2197 "dialog.c"
							}
#line 352 "../games/scores/dialog.vala"
							_tmp2_ = FALSE;
#line 352 "../games/scores/dialog.vala"
							if (!(j <= 1)) {
#line 352 "../games/scores/dialog.vala"
								break;
#line 2205 "dialog.c"
							}
#line 354 "../games/scores/dialog.vala"
							_tmp4_ = self->priv->grid;
#line 354 "../games/scores/dialog.vala"
							_tmp5_ = gtk_grid_get_child_at (_tmp4_, j, i);
#line 354 "../games/scores/dialog.vala"
							_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_label_get_type (), GtkLabel));
#line 354 "../games/scores/dialog.vala"
							label = _tmp6_;
#line 355 "../games/scores/dialog.vala"
							_tmp7_ = label;
#line 355 "../games/scores/dialog.vala"
							gtk_label_set_text (_tmp7_, "");
#line 352 "../games/scores/dialog.vala"
							_g_object_unref0 (label);
#line 2221 "dialog.c"
						}
					}
				}
#line 358 "../games/scores/dialog.vala"
				_tmp8_ = self->priv->grid;
#line 358 "../games/scores/dialog.vala"
				_tmp9_ = gtk_grid_get_child_at (_tmp8_, 2, i);
#line 358 "../games/scores/dialog.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_stack_get_type (), GtkStack));
#line 358 "../games/scores/dialog.vala"
				stack = _tmp10_;
#line 359 "../games/scores/dialog.vala"
				_tmp11_ = stack;
#line 359 "../games/scores/dialog.vala"
				_tmp12_ = gtk_stack_get_visible_child (_tmp11_);
#line 359 "../games/scores/dialog.vala"
				_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_label_get_type (), GtkLabel));
#line 359 "../games/scores/dialog.vala"
				label = _tmp13_;
#line 360 "../games/scores/dialog.vala"
				_tmp14_ = label;
#line 360 "../games/scores/dialog.vala"
				gtk_label_set_text (_tmp14_, "");
#line 350 "../games/scores/dialog.vala"
				_g_object_unref0 (label);
#line 350 "../games/scores/dialog.vala"
				_g_object_unref0 (stack);
#line 2249 "dialog.c"
			}
		}
	}
}

static void
games_scores_dialog_class_init (GamesScoresDialogClass * klass,
                                gpointer klass_data)
{
#line 24 "../games/scores/dialog.vala"
	games_scores_dialog_parent_class = g_type_class_peek_parent (klass);
#line 24 "../games/scores/dialog.vala"
	g_type_class_adjust_private_offset (klass, &GamesScoresDialog_private_offset);
#line 24 "../games/scores/dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = games_scores_dialog_finalize;
#line 2265 "dialog.c"
}

static void
games_scores_dialog_instance_init (GamesScoresDialog * self,
                                   gpointer klass)
{
#line 24 "../games/scores/dialog.vala"
	self->priv = games_scores_dialog_get_instance_private (self);
#line 27 "../games/scores/dialog.vala"
	self->priv->active_category = NULL;
#line 28 "../games/scores/dialog.vala"
	self->priv->rows_to_display = 10;
#line 30 "../games/scores/dialog.vala"
	self->priv->combo = NULL;
#line 31 "../games/scores/dialog.vala"
	self->priv->category_label = NULL;
#line 32 "../games/scores/dialog.vala"
	self->priv->headerbar = NULL;
#line 2284 "dialog.c"
}

static void
games_scores_dialog_finalize (GObject * obj)
{
	GamesScoresDialog * self;
#line 24 "../games/scores/dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_SCORES_TYPE_DIALOG, GamesScoresDialog);
#line 26 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->context);
#line 27 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->active_category);
#line 30 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->combo);
#line 31 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->category_label);
#line 32 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 33 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->grid);
#line 34 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->window_title);
#line 35 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->window_subtitle);
#line 38 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->new_high_score);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->scores_active_category);
#line 24 "../games/scores/dialog.vala"
	G_OBJECT_CLASS (games_scores_dialog_parent_class)->finalize (obj);
#line 2315 "dialog.c"
}

static GType
games_scores_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesScoresDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_scores_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesScoresDialog), 0, (GInstanceInitFunc) games_scores_dialog_instance_init, NULL };
	GType games_scores_dialog_type_id;
	games_scores_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "GamesScoresDialog", &g_define_type_info, 0);
	GamesScoresDialog_private_offset = g_type_add_instance_private (games_scores_dialog_type_id, sizeof (GamesScoresDialogPrivate));
	return games_scores_dialog_type_id;
}

GType
games_scores_dialog_get_type (void)
{
	static volatile gsize games_scores_dialog_type_id__once = 0;
	if (g_once_init_enter (&games_scores_dialog_type_id__once)) {
		GType games_scores_dialog_type_id;
		games_scores_dialog_type_id = games_scores_dialog_get_type_once ();
		g_once_init_leave (&games_scores_dialog_type_id__once, games_scores_dialog_type_id);
	}
	return games_scores_dialog_type_id__once;
}

